/*
 * Licensed Materials - Property of IBM
 *
 * 5724-U18
 *
 * (C) Copyright IBM Corp. 2018 All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 */

Polymer({
	is: 'maximo-meter-details',
	behaviors: [BaseComponent, TileBehavior, EditableTileBehavior],
	listeners: {
		'maximo-lookup-selected' : '_returnFromLookup'
	},
	properties: {
		data: {
			type: Object
		},
		
	    meterObj :{
	    	type: Object
	    },
	    guageFlag : {
	    	type : Boolean,
	    	value: false
	    },
	    charectersticFlag : {
	    	type : Boolean,
	    	value : false
	    },
	    continuesFlag : {
	    	type : Boolean,
	    	value : false
	    },
	    meterMeasure : {
			   type : String
		},
		meterHref : {
			type : String
		},
		record : {
			type : Object
		},
		yes: {
	    	type: String,
	    	value: ''
	    },
	    no : {
	    	type: String,
	    	value: ''
	    },
	    href : {
	    	type : String
	    },
	    dataset :{
	    	type : Object
	    },
		rolloverVal :{
			type : Boolean,
			value : false
		},
		rolloverFlag :{
			type : Boolean,
			value : false
		},
		dateDisplay :{
			type : String
		},
		timeDisplay :{
			type : String
		},
		remarks :{
			type : String
		},
		lookupreading :{
			type : String
		},
		meterTitle : {
			type : String
		},
  		/* For Min value for numeric spinner */
		minValue : {
			type : Number
		},
		/* To allow negative value */
		allowNegative : {
			type : Boolean,
			value : false
		},
		/* Default Date format*/
		dateFormat : {
			type: String
  		},
  		/* Default Time format */
  		timeFormat : {
  			type: String
  		},
  		/* internal DateTime foramt*/
  		dateTimeFormat : {
  			type: String
  		},
  		
  		/* flag for delta reading*/
  		deltaFlag :{
			type : Boolean,
			value : false
		},
		
		/* for delta meter reading value*/
		deltaVal :{
			type : String
		},
		
		/* reading type filter*/
		readingTypeFilter: {
			type: Array,
			value: function () {
				return [{'filtertype': 'SIMPLE', 'field': 'domainid', 'availablevalues': [ {'value': 'READINGTYPE', 'selected': true} ]}];
			} 	
		},		
		/* reading type result*/
		readingTypeDomainObj: {
			type: Object
		}
	},
	
	
	attached : function(){
		this.yes = $M.localize('uitext','mxapibase', 'Yes');
		this.no = $M.localize('uitext','mxapibase', 'No');
		$j('.datetimedetails').find('.ui-datetime-wrapper').css({'height':'47px'});
		$j('.datetimedetails').find('input').css({'margin-top':'7px','font-size':'18px'});
		$j('.datetimedetails').find('.ui-datetime-lookup').css({'padding-top':'13px'});
		$j('.datetimedetails').find('.ui-datetime-divAdjust').css({'height':'23px', 'padding-top':'9px', 'margin-top': '7px'});
		$j('.datetimedetails').find('.ui-datetime-divTimeLabel').css({'display':'flex', 'flex-direction':'column', 'justify-content': 'center'});		
		$j('.newreading, .rolloverclass, .meterinfo').find('label').css({'font-size':'18px'});
		$j('.meterinfo').find('input').css({'font-size':'18px'});
		$j('.newreading').find('label').css({'font-weight': 'normal'});		
	},
	
	/**
	 * To show meter details on maximo-table-tile
	 */
	showMeterDetails : function(e){
		//Focus on the first input element after flip the card
		this.async(function(){
			if(this.charectersticFlag){
				$j(this.$.meterinfo).find('input')[0].focus();
			}else{
				$j(this.$.meterinfo).find('input[data-scope-id=valueElement]').focus();
			}
		});
		
		this.guageFlag = false;
		this.charectersticFlag = false;
		this.continuesFlag = false;
		this.record = e.detail.record;
		this.rolloverFlag = false;
		this.deltaFlag =  false;
		this.record ={};
		this.meterObj ='';
		this.meterMeasure='';
		this.dateDisplay='';
		this.timeDisplay ='';
		this.remarks='';
		this.newreading ='0.00';
		this.rolloverVal =  false;
		this.lookupreading ='';
		
		this.record = e.detail.record; 
		
		if(e.detail.record.remarks !== ''){
			this.remarks =  this.record.remarks;
		}
		this.meterObj = this.record.meter.metertype;
		this.meterMeasure = this.record.meter.measureunitid;
		
		var currentDate ='';
		var rollover = this.record.rollover;
		
		var self = this;
		$M.getServerDateTime().then(function(response){
			if($M.isMobile()){
				var datetimeformat = $M.getMaxauth().whoami.dateformat.toUpperCase()+' '+$M.getMaxauth().whoami.timeformat;
				currentDate= moment(response.datetime,datetimeformat).format('YYYY-MM-DD HH:mm');
			}else{
				currentDate= moment(response.datetime,$M.maxauth.whoami.datetimeformat.toUpperCase())._i;
			}
			self.dateDisplay = currentDate.substr(0,currentDate.indexOf(' '));
			self.timeDisplay = currentDate.substr(currentDate.indexOf(' ')+1);
	    });
		
		if(rollover && rollover!== null){
			this.rolloverFlag =  true;
		}
		
		if(this.record.readingtype && this.getInternalValueForDomain(this.record.readingtype)==='DELTA'){
			this.deltaFlag = true;
		}
				
		this.allowNegative = false;
		if(this.meterObj === 'GAUGE'){
			this.allowNegative = true;
			this.guageFlag = true;
		} else if(this.meterObj === 'CONTINUOUS'){
			this.minValue = 0.00;
			this.continuesFlag = true;
		} else if(this.meterObj === 'CHARACTERISTIC'){
			this.charectersticFlag = true;
			var id = '';
			if(this.record && this.record.location){
				id = this.record.index+'-'+this.record.locationmeterid;
				this.href = this.record.locations[0].localref+'/locationmeter/'+id;
			} else {
				id = this.record.index+'-'+this.record.assetmeterid;
				this.href = this.meterHref+'/assetmeter/'+id;
			}
			this.meterTitle = e.detail.record.meter.description;
			var lookup = $M.showLookup('alndomain', this, this.meterTitle, this.href, null, null);
			$M.lookup.fire('set-lookup-label', this.meterTitle); 
		}
	},
	
	/**
	 * To set lookup value
	 */
	_returnFromLookup : function(e){
		if(e.detail && e.detail.records[0] && e.detail.records[0].value !== undefined) {
			this.record.lastreading = e.detail.records[0].value;
			if(e.detail.records[0].description){
				this.$.newreading = e.detail.records[0].description;
				this.lookupreading = e.detail.records[0].description;
			} else {
				this.$.newreading = e.detail.records[0].value;
				this.lookupreading = e.detail.records[0].value;
			}
		}
	},
	
	/**
	 * cancel the existing meter details 
	 */
	_cancelMeterInfo : function(e){
		this._applyEdit(e);
	},
	
	/**
	 * Getting the rollover checkbox info. 
	 */
	
	_rolloverInfo : function(e){
		this.rolloverVal = e.currentTarget.checked;
	},
	
	/**
	 * Updating the existing meter details. 
	 */
	_saveMeterInfo :  function(e) {
		var meterObject ={};
		meterObject.remarks = this.$.remarksid.value;
		meterObject.metername= this.record.metername;
		if(this.record.meter.metertype === 'CHARACTERISTIC') {
			  meterObject.newreading = this.record.lastreading;
		} else {
			  meterObject.newreading = parseFloat(this.$.measureid.value);
		}
		if(this.record.assetnum){
		  meterObject.assetnum = this.record.assetnum;
		  meterObject.linearassetmeterid = 0;
		  meterObject.assetmeterid =  this.record.assetmeterid;
		} else {
		  meterObject.location = this.record.location;
		  meterObject.linearlocationid = 0;
		  meterObject.locationmeterid =  this.record.locationmeterid;
		}
		meterObject.dorollover = this.rolloverVal;
		meterObject.isdelta = this.deltaFlag;
		meterObject.inspector = $M.userInfo.personid;
		
		if(this.dateDisplay){
			  if(!this.timeDisplay){
				  this.timeDisplay = '00:00';
			  }	
			  this.setDefaultDateTimeFormat();
			  meterObject.newreadingdate = moment(this.dateDisplay + " " + this.timeDisplay,this.dateTimeFormat).toDate();
		  }
		this.fire('save-meter-details', {'record':meterObject, 'href':this.record.href});
	},
	
	/** 
  	 * Set the date format
  	 */ 
  	setDefaultDateTimeFormat : function(){
		if ($M.getMaxauth().whoami && $M.getMaxauth().whoami.dateformat && $M.getMaxauth().whoami.timeformat && $M.getMaxauth().whoami.datetimeformat){
  			this.dateFormat = $M.getMaxauth().whoami.dateformat.toUpperCase();	  			
  			this.dateTimeFormat = $M.getMaxauth().whoami.datetimeformat.replace($M.getMaxauth().whoami.dateformat,$M.getMaxauth().whoami.dateformat.toUpperCase());
  			this.timeFormat =  $M.getMaxauth().whoami.timeformat;
  			this.showAMPM = $M.getMaxauth().whoami.datetimeformat.includes('a');
		} else {
			this.dateFormat = 'MM/DD/YYYY';
			this.dateTimeFormat = 'MM/DD/YYYY hh:mm';
			this.timeFormat = 'hh:mm';
			this.showAMPM = true;
		}
	},
	
	 /**
	  * Handler for reading type domain
	  */
	 _handleReadingTypeSet : function(e){
		 var readingTypeFilteredSet =this.readingTypeDomainCollection[0].synonymdomain;
		 var obj={};
		 $j.each(readingTypeFilteredSet,function(key,value){ 
			if(this.defaults){
				obj[this.maxvalue] = this;
			}
		 });
		 this.readingTypeDomainObj=obj;
	 },
	 /**
	  * Error Handler for reading type domain
	  */	
	 _handleReadingTypeSetError : function(e){
		 this.readingTypeDomainObj = null;
	 },
	 
	 /**
	   * Fetch internal value of reading type from synonym domain based on external Value
	  */
	 getInternalValueForDomain: function(externalValue){
		 return this.readingTypeDomainObj[externalValue].maxvalue;
	 },
	 
	 /**
	  *  Getting the delta checkbox info.
	  */
		
	_deltaInfo : function(e){
		if(e.currentTarget.checked){
			this.deltaFlag = true;
		}else {
			this.deltaFlag = false;
		}
			
	}
 });
