/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2018,2109
 */

Polymer({
	is: 'maximo-storeroom-detail',
	behaviors: [BaseComponent,Storeroom],
	listeners: {	  	
		   'maximo-table-collection-sort' : 'collectionOrderByChanged',
		   'inventory-detail' : '_displayItemDetail',
		   'table-action-clicked' : '_storeroomActions',
		   'importInventory' : '_uploadInventoryWizard',
		   'maximo-lookup-selected' : '_returnFromLookup',
		   'maximo-table-collection-sort':'collectionOrderByChanged',
		   'display-sitestore': '_displaySiteStore',
		   'loadBalanceTable':'_loadBalanceTable',
		   'storeroomlist':'_storeroomlist',
		   'iron-overlay-opened': '_positionOverlay',
		   'disable-sidemenu':'_disableSideMenu',
		   'displayItemPage':'_displayItemPage'
	  	},
	properties: {
		record : {
    		type: Object,
    		value: null,
    		notify: true
    	},
    	attributeList: {
			type: String,
			value: 'inventoryid,location,locations.description,status,issueunit,itemnum,item.description,vendor,manufacturer,binnum,bincnt,lotnum,lotcnt,curbaltotal,avblbalance,costtype,unitcost,itemsetid,siteid,invcost.stdcost,invcost.avgcost,haschildinvbalance,item.lottype--lottype,item.rotating--rotating,orderunit,orderqty,minlevel,reorder,deliverytime,_imagelibref,vendor.name--vname,manufacturer.name--mname,ccf'
		},
      	/**
		Collection order by, required for collection sorting
		**/
		collectionOrderBy: {
			type: String,
			value: '%2Bitemnum'
		},
		hierarchicalcolumns: {
			type: Array,
			  value: []
		},
		storeroomItemCount: {
			type: Number
		},
		redirectedRecord : {
    		type: Object,
    		value: null
    		
    	},
    	/**
		 * Select tab name
		 */
    	selectedTabName: {
    		type: String,
    		observer: '_loadSection' 
    	},
		rowRecord: {
			type: Object,
		},
		setRowOffset: {
			type: String,
			value:''
		},
		menuItems : {
        	type: Array,
    		value: [],
    		notify:true    		
        },
	  /**
         * Display the actions button.
         */
		actions:{
				type: Object,
				value: function(){
					return {
						header:{
							width: window.innerWidth/5+ 'px'
						},
						list:[
							{
								icon:'Maximo:Overflow',
								action: 'sractions',
								style: 'transform: rotate(90deg)',
								label: $M.localize('uitext', 'mxapiinventory', 'actions')
							}
						]
					};
				}
		  },
		  overlayPosition:{
			  type: Object
		  }
	},
	setAdditionalParam: function(){
		if(this.record){
    	    var siteid = this.record.siteid;
			var loc = this.record ? this.record.location:'';
			var additionalparams=[];
			additionalparams.push('oslc.where=location=%22'+loc+'%22and%20siteid=%22'+siteid+'%22');
			this.$.storeroomdetailcollection.additionalParams=additionalparams;
		}
	 }, 
	       
   /**
   	*	Check if action to be shown or not
   	*	Show action only when haschildinvbalance
   	*/
   	 _actionCallback: function(record,action){
   		var hasAdjustbalance = ($M.getSigoptions().MXAPIINVENTORY.CURBALADJ===1 || $M.getSigoptions().MXAPIINVENTORY.TRANSFER===1); 
   		if(hasAdjustbalance){
   			if(record && record.haschildinvbalance){
				return false;
			}
   			else // if(record && record.invbalances && record.invbalances.length > 0)
   			{
   				return true;//record && record.invbalances && record.invbalances.length > 0;
   			}
   		}else{
   			return false;
   		}
   	 },
   	 
   	 _initLoadTable: function(){
   		 if(this.isTableInitialized) {
   			return;
   		 }
    		 var hierarchicalcolumns = [];
    		 this.set('hierarchicalcolumns', hierarchicalcolumns);
    		 hierarchicalcolumns =
        	 [{'attribute':'itemnum','title':$M.localize('uitext', 'mxapistoreloc', 'id'),'sortable':true,'hyperlink' : true,
       				'listener' : 'inventory-detail','flexGrow': '2'},
 		  		{'attribute':'itemdescription','title':$M.localize('uitext', 'mxapistoreloc', 'description'),'flexGrow': '2'},
 		  		{'attribute':'bincnt','title':$M.localize('uitext', 'mxapistoreloc', 'bin'),'flexGrow': '1'},
 		  		{'attribute':'lotcnt','title':$M.localize('uitext', 'mxapistoreloc', 'lot'),'flexGrow': '1'},
 		  		{'attribute':'curbaltotal_localized','title':$M.localize('uitext', 'mxapistoreloc', 'balance'),'flexGrow': '1' },
 		  		{'attribute':'avblbalance_localized','title':$M.localize('uitext', 'mxapistoreloc', 'available'),'flexGrow': '1'},
 		  		{'attribute':'invreserveqty_localized','title':$M.localize('uitext', 'mxapistoreloc', 'reserved'),'flexGrow': '1'},
 		  		{'attribute':'stagedqty_localized','title':$M.localize('uitext', 'mxapistoreloc', 'staged'),'flexGrow': '1'},
 		  		{'attribute':'shippedqty_localized','title':$M.localize('uitext', 'mxapistoreloc', 'shipped'),'flexGrow': '1'},				  		
 		  		{'attribute':'expiredqty_localized','title':$M.localize('uitext', 'mxapistoreloc', 'expired'),'flexGrow': '1'}
 		  	 ];
    		 this.set('hierarchicalcolumns', hierarchicalcolumns);
    		 this.set('actions', this.actions);
    		 this.isTableInitialized = true;
    	 },
   	 /**
        * Created Storeroom table with fixed headers and calculated widths based on column type. 
        */
       _loadTable: function(){
    	      var self = this;  
              this.setAdditionalParam();
              $M.toggleWait(true);
              if(this.record){
            	  this.redirectedRecord=this.record;
              }
              this.storeroomItemCount = 0;
			  self.$.storeroomdetailcollection.refreshRecords().then(function(data){
           		 $M.toggleWait(false);
           		 self._initLoadTable();
           		 self._tableStyle(self);
              });           		  
           	  this.$.searchbar.clear(true);  
           	this.selectTab('balance');
	       },
	      
	       attached: function(){
	    	   var self = this;
	    	   $j(window).resize(function(){
	    		   $j(self.$.storeroomActionsOverlay).hide();
	    		   self._tableStyle(self);
	    	   });
	    	   $j('.maximo-table').on('scroll', function(){
	           	   $j(self.$.storeroomActionsOverlay).hide();
	            });
	       },
	       
	       _isTransferAccessible : function(e){
	    	   $j(this.$.transferActionDiv).hide();
	    	   if(this._isSigOptionGranted('MXAPIINVENTORY','TRANSFER') && !(e.detail.record && e.detail.record.haschildinvbalance)) {
	    		   $j(this.$.transferActionDiv).show();
	    	   }
	       },
	       
	       _isReorderAccessible : function(e){
	    	   $j(this.$.reorderActionDiv).hide();
	    	   if(this._isSigOptionGranted('MXAPIINVENTORY','MANAGEREORDER') && !(e.detail.record && e.detail.record.haschildinvbalance)) {
	    		   $j(this.$.reorderActionDiv).show();
	    	   }
	       },
	       
	       _isIssueAccessible : function(e){
	    	   $j(this.$.issue).show();
	    	   if(e.detail.record && e.detail.record.haschildinvbalance) {
	    		   $j(this.$.issue).hide();
	    	   }
	       },
	       
	       _rotatingAssetseAccessibile : function(e){
	    	   $j(this.$.updateBalanceActionDiv).show();
	    	   if(e.detail.record && e.detail.record.item){
		    	   if(e.detail.record.item.rotating===false){
		    		   if(!this._isSigOptionGranted('MXAPIINVENTORY','CURBALADJ') && e.detail.record._hierarchylevel_ && e.detail.record._hierarchylevel_  !== 0) {
		    			   $j(this.$.updateBalanceActionDiv).hide();
		    		   }
		    		   $j(this.$.rotatingAssetsActionDiv).hide(); 
		    	   }else if(e.detail.record.item.rotating && e.detail.record._hierarchylevel_ && e.detail.record._hierarchylevel_  !== 0){
	    			   $j(this.$.updateBalanceActionDiv).hide();
	    		   }
	    		   else{
	    			   $j(this.$.rotatingAssetsActionDiv).show();
	    		   }
	    	   }
	       },
	       _showStoreroomName : function(data){
	    	   if(data){
		    	   this.$.storeDescription.label=(data.description)? data.description:data.location;
		    	   this.$.siteId.label=(data.siteid)? data.siteid:data.site.description;
	    	   }
	       },
	       _storeroomActions: function(e){
	    	   var displaytext = $M.localize('uitext','mxapistoreloc','stgbinactiontext');
	    	   this.buttonCount = 0;
	    	   this.selectedRow = e.detail.source.closest('.tablerow');
	    	   if(this._isSigOptionGranted('MXAPIINVENTORY', 'CURBALADJ')) {
	    		   this.buttonCount++;
	    	   }
	    	   if(this._isSigOptionGranted('MXAPIINVENTORY', 'TRANSFER')) {
	    		   this.buttonCount++;
	    	   }
	    	   if(this._isSigOptionGranted('MXAPIINVENTORY', 'MANAGEREORDER')) {
	    		   this.buttonCount++;
	    	   }
	    	   if(this._isSigOptionGranted('MXAPIINVENTORY', 'EDITSTORE')) {
	    		   this.buttonCount++;
	    	   }
	    	   if(e.detail.record.stagingbin){
	    		   $M.notify(displaytext, $M.alerts.error);
	    		   return;
			   } else { 
			   	   var pos = e.detail.source.getBoundingClientRect(); 
				   this.overlayPosition = pos;
				   this.rowRecord = e.detail.record;
				   this.$.storeroomActionsOverlay.open();
				   this._rotatingAssetseAccessibile(e);
				   this._isIssueAccessible(e);
				   this._isTransferAccessible(e);
				   this._isReorderAccessible(e);
	       		}
           },
	       /**
			 * Displays overlay on card to undo/CLOSED action.
			 */		
           _close: function (e) {                       
				this.$.storeroomActionsOverlay.close();                                             
				
           },
           _getFlyoutStyles: function(){
        	   	var tableOffset;
        	   	var flyoutPos = {};
				var updatedBalanceSlider = $j(this.$.storeroomTable.$.table);
				var tableOffsetLeft = updatedBalanceSlider.offset().left;
				var tableOffsetWidth = updatedBalanceSlider.innerWidth() - 8;
				if(window.navigator.userAgent.toLowerCase().indexOf('firefox') > -1){
					tableOffsetWidth = updatedBalanceSlider.innerWidth() - 16;
				}
				tableOffset =  this.setRowOffset;
				tableOffset = (parseFloat(tableOffset)+11)+ 'px';
				flyoutPos.flyoutWidth = tableOffsetWidth;
				flyoutPos.flyoutLeft = tableOffsetLeft;
				flyoutPos.flyoutTop = tableOffset;
				return flyoutPos;
           },

           _setFlyoutStyles: function(flyoutObj,pos,hierarchylevel){
        	   this.async(function(){
        		   flyoutObj.css({'left': pos.flyoutLeft + 'px', 'width':'calc(100vw - '+pos.flyoutLeft+'px)', 'padding':'1px' ,'box-sizing': 'border-box'});
        		   if(hierarchylevel && hierarchylevel  !== 0) {
        		   flyoutObj.find('#internal').css({'padding': '0px','justify-content': 'left'});
        		   }else{
        		   	 flyoutObj.find('#internal').css({'padding': '0px 0px 0px 20px','justify-content': 'left'});
        		   }
        		   flyoutObj.find('.updatestoreinput').css({'width':pos.flyoutWidth});
				}, 100);
           },
        
           _adjustBalance: function(e){
				var self = this;
				this.$.storeroomActionsOverlay.close();
				var pos = this.getBoundingClientRect();
				var tableOffset =  this.setRowOffset;

				tableOffset = (parseFloat(tableOffset)+11)+ 'px';
				pos.flyoutWidth = pos.width;
				pos.flyoutLeft = pos.left;
				pos.flyoutTop = tableOffset;
				
				var inventoryRecord = {
						'action' : {
							'identifier' : 'editaction',
						},
						'record' : this.rowRecord
					}
					var hierarchylevel=inventoryRecord.record._hierarchylevel_;
				if(inventoryRecord.record.item && inventoryRecord.record.item.rotating !== undefined){
					inventoryRecord.record.rotating=this.rowRecord.item.rotating;
				}
				if(hierarchylevel && hierarchylevel  !== 0) {
					  this.$.storeroomActionsOverlay.close();
					  var pos = this._getFlyoutStyles();
					  this.updateStoreDialog = $M.showFlyout('editStoreroomDetail', 'maximo-storeroomedit-dialog',  null, {'hideFooter':true, 'updateStoreData': this.rowRecord ,'constrainWidth':true, 'top':pos.flyoutTop});
				}else{
	    		     this.updateStoreDialog = $M.showFlyout('editStoreroomDetail', 'maximo-inventory-storeroom-flyout',  null, {'hideFooter':true, 'storeroomData': inventoryRecord ,'addItem' : true,'addItemDesc':true,'constrainWidth':true, 'top':pos.flyoutTop});
	    		     this.async(function(){
	    			 $j(this.updateStoreDialog).find('.selected-storeroom').attr('readonly','true');
	    			 $j(this.updateStoreDialog).find('.flyout').css({'padding' : '0px 10px 10px 10px'});
	    			 $j(this.updateStoreDialog).find('.internal').css({'padding':'0px 0px 0px 10px','display':'block'});
	    			 $j(this.updateStoreDialog).find('#economicrecord').addClass('adjust-balances');
	    			 $j(this.updateStoreDialog).find('#economicrecordpoint').addClass('adjust-balances');
	    			 $j(this.updateStoreDialog).find('#economicrecordquentity').addClass('adjust-balances');
	    			 $j(this.updateStoreDialog).find('#economicrecordleadtime').addClass('lead-time');
		    			 var costype = $j(this.updateStoreDialog).find('#costtypeselect')[0];
		    			 if(costype && (costype.value === 'FIFO' || costype.value === 'LIFO')) {
		    				 $j(this.updateStoreDialog).find('#stdcosttext_wrapper').show();
			         		 $j(this.updateStoreDialog).find('#avgcosttext_wrapper').show();
			         		 $j(this.updateStoreDialog).find('#stdcost').addClass('hide-std-avg-cost');
			         		 $j(this.updateStoreDialog).find('#avgcost').addClass('hide-std-avg-cost');
		    			 }
		    			 else {
		    				 $j(this.updateStoreDialog).find('#stdcosttext_wrapper').hide();
			         		 $j(this.updateStoreDialog).find('#avgcosttext_wrapper').hide();
			         		 $j(this.updateStoreDialog).find('#stdcost').removeClass('hide-std-avg-cost');
			         		 $j(this.updateStoreDialog).find('#avgcost').removeClass('hide-std-avg-cost');
		    			 }
	    		    },  100);
				}
				  var flyoutDiv = $j(this.updateStoreDialog.$.flyout);
				  this._setFlyoutStyles(flyoutDiv, pos,hierarchylevel);
			},
		
			/**
			 * Transfer the Item Inventory to store room
			 */
			_transferItem: function(e){
				var self = this;
				var conditioncode;
				var colURI = this.rowRecord.href;
				var redirectedRec=this.redirectedRecord;
				var tranferInventory={};
				
				var tableOffset;
				tableOffset = '32%';
				if(window.navigator.userAgent.toLowerCase().indexOf('ipad') > -1){
					tableOffset = '10%';
				}
				
				if(this.rowRecord.localref){
					colURI = this.rowRecord.localref.slice(0,this.rowRecord.localref.indexOf('invbalances')-1);
					conditioncode  = this.rowRecord.conditioncode;
				}else{
					if(this.rowRecord.invbalances){
						conditioncode  = this.rowRecord.invbalances[0].conditioncode;
					}
				}
				
				if(this.rowRecord.item && this.rowRecord.item.rotating){					
					var storeroomresource = this.$.inventoryResource;
					storeroomresource.resourceUri = colURI + '/matrectrans';
			        storeroomresource.updateAction('new', null, '*', 'GET').then(
			    		function(result){
			    			if(result.response) {
			    				tranferInventory = result.response;
			    				if(tranferInventory && tranferInventory.matrectrans[0]){	
			    					tranferInventory.matrectrans[0].fromstoreloc = self.rowRecord.location;
									tranferInventory.matrectrans[0].frombin = self.rowRecord.bincnt;
								}
			    				$j(self.$.storeroomActionsOverlay).hide();
								self.updateStoreDialog = $M.showFlyout('transferItem', 'maximo-storeroom-itemtransfer',  null, {'hideFooter':true, 'storeRowRecord': self.rowRecord, 'tranferInventory': tranferInventory,'redirectedRecord':redirectedRec,'transferobj':tranferInventory.matrectrans[0],'transferobj_collectionref': colURI + '/matrectrans', 'constrainWidth':true, 'top':tableOffset});
								self.setTransferDialog(self.updateStoreDialog, tableOffset);
			    			}
			    		},
			    		function(error){
			    			$M.toggleWait(false);
				            $M.showResponseError(error);
				        });
				} else {
					
					var inventoryCollection = $j(this.$.storeroomdetailcollection).clone(true)[0];
					inventoryCollection.id = inventoryCollection.id + (new Date()).getTime(); 
					inventoryCollection.collectionUri  = colURI + '/transfercuritem';
					inventoryCollection.invokeAction('new', {'oslc.select': '*'}, 'GET').then(function(results){
						if(results.response) {
							$j(self.$.storeroomActionsOverlay).hide();
							
							tranferInventory = results.response;
							if(conditioncode){
								tranferInventory.transfercuritem[0].fromconditioncode = conditioncode;
							}
							if(tranferInventory && tranferInventory.transfercuritem[0]){							
								tranferInventory.transfercuritem[0].frombin=self.rowRecord.bincnt;							
								if(self.rowRecord.lotcnt){
									tranferInventory.transfercuritem[0].fromlot=self.rowRecord.lotcnt;
								}
							}
							self.updateStoreDialog = $M.showFlyout('transferItem', 'maximo-storeroom-itemtransfer',  null, {'hideFooter':true, 'storeRowRecord': self.rowRecord, 'tranferInventory': tranferInventory,'redirectedRecord':redirectedRec,'transferobj':tranferInventory.transfercuritem[0] ,'transferobj_collectionref': colURI + '/transfercuritem','constrainWidth':true, 'top':tableOffset});
							self.setTransferDialog(self.updateStoreDialog, tableOffset);
						}
					});
				}
			},
			_reorderItem: function(){
				this.$.storeroomActionsOverlay.close();
				$M.setSubRoute('storeroom/storeroomdetail/reorderitem');
				var self = this;
				var colURI = this.rowRecord.href;
				if(this.rowRecord.localref){
					colURI = this.rowRecord.localref.slice(0,this.rowRecord.localref.indexOf('invbalances')-1);
				}
				this.$.inventoryResource.resourceUri = colURI;
				this.$.inventoryResource.loadRecord().then(function(result){
					if(result) {
						result.storeRoomType = self.$.storeDescription.label;
						self.fire('display-reorder',{'pagename':'storeroomReorder','record':result,'recordhref':colURI,'reorderRecord':self.rowRecord,'redirectedRecord':self.redirectedRecord});
				
					}				
				});	
					},
			 /**
			* Hide the actions.
			*/
			_overFlowIcon : function(){
				this.$.storeroomActionsOverlay.close();	
			},
	       /*
		   	 * Triggered when sort was applied for refreshed collection.
		   	 */
		   	 collectionOrderByChanged: function(){	
		   		this.$.storeroomdetailcollection.refreshRecords();	
		   	 },
	   	/**
	   	* Apply style on table
	   	*/
	    _tableStyle: function(self){
	    	var topPageWidth = 232;
	    	if(navigator.userAgent.toLowerCase().indexOf('firefox') > -1){
  				topPageWidth = 320;
  			}
	    	var tbody = this.$.storeroomTable.$.tbody;
	    	if(tbody) {
	    		tbody.style.maxHeight = $j(window).height() - topPageWidth + 'px';	
  			}
	    },
	 /*
		* Show the twisty span within then first column
		*/
		_showTwisty: function(colnum, record){
			return colnum === 0 && this._hierarchical && this._hasChildren(record);
		},
		_storeList: function(){

			var invBalData= this.$.physicalcount.invBalData;
        	var invBalDataArray=this.$.physicalcount.invBalDataArray;
			if(invBalData.length>0){
        		invBalData.forEach(function(item,index){
		    		invBalDataArray.push(invBalData[index]);
		    	});
	    		
	    		$M.showDialog(this, 'storeroomlist', null, 'maximo-physicalcount-savedialog', false, null, {'invBalData':invBalDataArray , 'MsgText':$M.localize('uitext','mxapiinvbal','physicalcountconfirmsg'),'tab':'storeroomlist' });
	    		this.$.physicalcount.invBalDataArray=[];
	    		this.$.physicalcount.invBalData=[];
        	}
        	else{
        		this._storeroomlist();
            }
		},
 
		_displayItemDetail: function(e){
			var invBalData= this.$.physicalcount.invBalData;
        	var invBalDataArray=this.$.physicalcount.invBalDataArray;
        	
        	if(invBalData.length>0){
        		invBalData.forEach(function(item){
		    		invBalDataArray.push(item);
		    	});
	    		$M.showDialog(this, 'itemDetail', null, 'maximo-physicalcount-savedialog', false, null, {'invBalData':invBalDataArray , 'MsgText':$M.localize('uitext','mxapiinvbal','physicalcountconfirmsg'),'tab':'itemDetail','event':e});
	    		this.$.physicalcount.invBalDataArray=[];
	    		this.$.physicalcount.invBalData=[];
        	}
        	else{
        		this._displayItemPage(e);
        	}
		},
		
		_displayItemPage:function(e){
			$M.toggleWait(true);
			if(this.domHost){
				this.domHost.addContent('invItemList');
			}
			this.$.storeroomActionsOverlay.close();
	    	var self=this;
	    	var itemcollection = $M.getGlobalResource('itemcollection');
	    	var itemnum;
	    	var isRotatingTab;
	    	if(e.detail.model && e.detail.model.record){
	    		itemnum=e.detail.model.record.itemnum ? e.detail.model.record.itemnum : e.detail.model.record.physicalcountitemnum;
	    	}else if(this.rowRecord && (this.rowRecord.itemnum || this.rowRecord.invitemnum)){
	    		itemnum = this.rowRecord.invitemnum? this.rowRecord.invitemnum : this.rowRecord.itemnum;
	    		isRotatingTab='RotatingAssets';
	    	}
	    	var additionalparams=[];
			additionalparams.push('oslc.where=itemnum=%22'+itemnum+'%22');
			itemcollection.additionalParams=additionalparams;
			itemcollection.searchTermValue='';
			itemcollection.collectionUri='';
			
			this.async(function(){
				itemcollection.refreshRecords().then(function(result){
					if(result.response){				
						$M.setSubRoute('inventoryItems/itemDetail');				
						self.fire('display-itempage',{'pagename':'itemDetail','record':result.response.member[0],'collection':itemcollection,'isRotatingTab':isRotatingTab,'isRedirected': 'Storeroom','redirectedRecord':self.redirectedRecord, 'schema':itemcollection.schema});
						$M.toggleWait(false);  	
					}
				});			
			}, 300);
		},
		
		setTransferDialog: function(updateStoreDialog){
			var updatedBalanceSlider = $j(this.$.storeroomTable.$.table);
			var tableOffsetLeft = updatedBalanceSlider.offset().left;
			var tableOffsetWidth = updatedBalanceSlider.innerWidth() - 8;
			if(window.navigator.userAgent.toLowerCase().indexOf('firefox') > -1){
				tableOffsetWidth = updatedBalanceSlider.innerWidth() - 16;
			}
			var flyoutDiv = $j(updateStoreDialog.$.flyout);
			flyoutDiv.css({'left': tableOffsetLeft + 'px', 'width': tableOffsetWidth, 'box-sizing': 'border-box'});
			flyoutDiv.find('#internal').css({'padding': '0 0 20px 0','justify-content': 'left', 'display': 'block'});
		},
		
		/**
		 * Opens Inventory Upload Page
		 */
	    _uploadInventoryWizard: function(e){
	    	this.fire('inventory-upload', {'pagename':'inventoryUpload','schema':this.storeroomdetailschema});
	    },
	    
	    
	    _issueItem : function() {
	    	var self = this;
            var theadPos = this.$.storeroomTable.$.thead.getBoundingClientRect();
            var flyoutPos = this._getFlyoutStyles();
            var issueItem = {};
            var colURI = this.rowRecord.href;
            if(this.rowRecord.localref){
				colURI = this.rowRecord.localref.slice(0,this.rowRecord.localref.indexOf('invbalances')-1);
			}
            this.rowRecord['matusetrans_collectionref'] = colURI+'/matusetrans';
            var inventoryresource = this.$.inventoryResource;
            inventoryresource.resourceUri = this.rowRecord.matusetrans_collectionref;
            inventoryresource.updateAction('new', null, '*', 'GET').then(
    		function(result){
    			if(result.response) {
    				issueItem = result.response;
    				self.issueItem = $M.showFlyout('issue_item','maximo-storeroom-issueitem', null,{'hideFooter':true, 'storeRowRecord': self.rowRecord, 'invrecord': issueItem, 'constrainWidth':true,'top': theadPos.bottom, 'flyoutowner':self, 'schema': self.storeroomdetailschema.properties.matusetrans.items});
    				var issueItemFlyout = $j(self.issueItem.$.flyout);
    				self._setFlyoutStyles(issueItemFlyout, flyoutPos);
    			}
    		},
    		function(error){
    			$M.toggleWait(false);
	            $M.showResponseError(error);
	        });
        },
        
        /**
		 * create add item flyout page
		 */
        _createInventoryWizard: function(){	
            var self=this;
    	    var tableOffset;
     	    var hederPos = this.$.storeroomTable.$.thead.getBoundingClientRect();
    		var pos = this.getBoundingClientRect();
    		var maximoFlyout = $M.showFlyout('addItem','maximo-inventory-storeroom-flyout', null,
    				{
    					'hideFooter' : true,
    					'top' : hederPos.bottom,
    					'addItem' : true,
    					'constrainWidth': true
    				});
            self.async(function(){
            	$j(maximoFlyout).find('.inventory_status').attr('readonly','true');
            }, 100);
            	
        	self.async(function(){
     			$j(maximoFlyout).find('.flyout').css({'left': pos.left, 'width':'calc(100vw - '+pos.left+'px)', 'padding' : '1px'});
     			$j(maximoFlyout).find('.internal').css({'display':'block', 'padding':'0px 0px 0px 20px'});
     			$j(maximoFlyout).find('.flyout').find('.footer').css({'padding-top': ''});
     		
        		$j(maximoFlyout).find('.edit_storeroom_input_row2').show();
        		$j(maximoFlyout).find('.inventory_issueunit').removeAttr('readonly');
        		$j(maximoFlyout.$.dfltbin).addClass('edit-field-old');
        		$j(maximoFlyout.$.inventory_status).addClass('edit-field-old');
        		$j(maximoFlyout).find('#count_frequency')[0].value = '0.0';
        		$j(maximoFlyout).find('#stdcosttext_wrapper').hide();
        		$j(maximoFlyout).find('#avgcosttext_wrapper').hide();
        	}, 100);    	
          },
    	
    	_showStoreroomlookup : function(itemnum) {
    		var lookupAction = {'event':'show-storeroom-allsites','icon':'Maximo:View','label':$M.localize('uitext', 'mxapiitem', 'item')};
   		    $M.showLookup('itemselect', this,'selectstoreroom', '/oslc/os/mxapiinventory/zombie', null, null, null, lookupAction, null, null, null, null);
    	},
    	/**
		 * Opens Item lookup
		 */
    	_returnFromLookup: function(e){
    		var tableOffset;
    		var items = e.detail.records; 	
    		var self = this;
    		var tableHeader = $j(this.$.storeroomTable).find('.tableheaderrow');
    		tableOffset =  tableHeader.offset().top + tableHeader.height();
    		var pos = this.getBoundingClientRect();
    		var maximoFlyout;
    		if(items && items.length) {
    			var  actionData = {};    
    			this.record.lottype_maxvalue=items[0].lottype_maxvalue;
				actionData.itemnum = items[0].itemnum;
			    actionData.itemsetid = items[0].itemsetid;
			    actionData.storeroom = $j('maximo-storeroom-detail')[0].record.location;
			    actionData.siteid =  $j('maximo-storeroom-detail')[0].record.siteid;
			    actionData.istool = false;
				actionData.savenow = false;
				actionData.reorder=0;
    			
    			var inventoryRecord = {};			
    	        var inventoryresouce = this.$.inventoryResource;
    	        var responseProperties = inventoryresouce.attributeNames;
    	        inventoryresouce.resourceUri = $M.maxauth.baseUri + '/oslc/service/location?responseos=MXAPIINVENTORY';
    	        inventoryresouce.updateAction('wsmethod:addAnItemToStoreroom', actionData, responseProperties).then(
    	        	function(result){
    	        		if(result.response) {
    	        			self.inventoryExists = false;
    	        			inventoryRecord.record = result.response;
    			        	inventoryRecord.record.lottype_maxvalue = self.record.lottype_maxvalue;
    			        	inventoryRecord.record.inventoryExists = self.inventoryExists;
    			        	var storeroomFlyout = $j('maximo-inventory-storeroom-flyout');
    			        	if(storeroomFlyout.length) {
    			        		storeroomFlyout[0].storeroomData = inventoryRecord;
    			        	} else {
    			        		maximoFlyout = $M.showFlyout('additemtostoreroom','maximo-inventory-storeroom-flyout', null,
    									{
    										'hideFooter' : true,
    										'top' : tableOffset,
    										'storeroomData' : inventoryRecord,
    										'schema' : self.inventoryschema,
    										'constrainWidth': true
    									});
    					        self.async(function(){
    					        	$j(maximoFlyout).find('.inventory_status').attr('readonly','true');
    					        }, 100);
    				        	
    			        	}
    			        	self.async(function(){
    			     			$j(maximoFlyout).find('.flyout').css({'left': pos.left, 'width':'calc(100vw - '+pos.left+'px)', 'padding' : '0px'});
    			     			$j(maximoFlyout).find('.internal').css({'display':'block', 'padding':'0px 0px 0px 5px'});
    			     			$j(maximoFlyout).find('.flyout').find('.footer').css({'padding-top': ''});
    			     		
    			        		$j(maximoFlyout).find('.edit_storeroom_input_row2').show();
    			        		$j(maximoFlyout).find('.inventory_issueunit').removeAttr('readonly');
    			        	}, 100);
    			        	$j(storeroomFlyout).find('#edit-row1').addClass('edit-row1-border');
    	        		}
    		        },
    	    		function(error){
    		        	$M.toggleWait(false);
    		        	var e = $M._getErrorResponse(error);
    		        	var storeroomFlyout = '';
    		        	if(e && e.reasonCode==='BMXAA2701E'){
    		        		self.inventoryExists = true;
    		        		var maximoQbe = new MaximoQbe();
    		        		maximoQbe.setEquals('itemnum', actionData.itemnum);
    		        		maximoQbe.setEquals('location', actionData.storeroom);
    		        		maximoQbe.setEquals('itemsetid', actionData.itemsetid);
    		        		maximoQbe.setEquals('siteid', actionData.siteid);
    		        		
    		        		var currentInventoryCollection = $j(self.$.storeroomdetailcollection).clone(true)[0];
    		        		currentInventoryCollection.id = 'currentstoreroomdetailcollection';
    		        		currentInventoryCollection.attributeNames = self.attributeList;
    		        		var qbeObject = maximoQbe.toJSON();
    		        		currentInventoryCollection.queryWhere = qbeObject;
    		        		currentInventoryCollection.refreshRecords().then(function(result){
    		          			$M.toggleWait(false);
    		          			if(result.response.member.length > 0){
    		          				inventoryRecord.record = result.response.member[0];
    		          				if(inventoryRecord.record.item && inventoryRecord.record.item.lottype){
    		          					inventoryRecord.record.lottype_maxvalue = inventoryRecord.record.item.lottype_maxvalue;
    		          				}
    		          				inventoryRecord.record.inventoryExists = self.inventoryExists;
    		          			}
    		          			
    	          				if($j('maximo-inventory-storeroom-flyout')[0]){
    		          				storeroomFlyout = $j('maximo-inventory-storeroom-flyout')[0];
    				        		storeroomFlyout.storeroomData = inventoryRecord;
    				        	} else {
    				        		maximoFlyout = $M.showFlyout('additemtostoreroom', 'maximo-inventory-storeroom-flyout', null, {'hideFooter':true, 'top':tableOffset, 'storeroomData':inventoryRecord,'schema':self.inventoryschema,'constrainWidth': true});
    				        		self.async(function(){
    				        			$j(maximoFlyout).find('.inventory_status').attr('readonly','true');
    				        		},100);	
    				        		
    				        	}
    	          				
    	          				$j(storeroomFlyout).find('#edit-row1').removeClass('edit-row1-border');
    	          				
    		          			self.async(function(){
    		          				$j(maximoFlyout).find('.flyout').css({'left':pos.left+'px', 'width':'calc(100vw - '+pos.left+'px)', 'padding' : '1px'});
    		          				$j(maximoFlyout).find('.internal').css({'display':'block', 'padding':'0px'});
    		          				$j(maximoFlyout).find('.flyout').find('.footer').css({'padding-top': '20px'});
    		          				$j(maximoFlyout).find('.edit_storeroom_input_row2').hide();
    					        	storeroomFlyout = $j('maximo-inventory-storeroom-flyout')[0];
    					        	if(storeroomFlyout){
    					        		storeroomFlyout.$.editbinid.value = '';
    						        	storeroomFlyout.$.editlotid.value = '';
    						        	storeroomFlyout.$.balance_qty.value = 0.00;
    					        	}				        	
    					        	$j(maximoFlyout).find('.inventory_issueunit').attr('readonly','true');
    		          			},100);		          			
    		          		});
    		        	} else {
    		        		$M.showResponseError(error);
    		        	}
    		        });	       
    		}		
    	},
    	/*
       	 * Triggered when sort was applied for refreshed collection.
       	 */
       	 collectionOrderByChanged: function(e){	
       		e.target.collection.refreshRecords();	
       	 },
       	 _handlePageNavigation: function(e) {
         		var name = e.currentTarget.getAttribute('name');
         		this.selectTab(name);
     	},
     	/**
    	 * Update selectedTabName property
    	 */
    	selectTab: function(tabName) {
    	    if (this.selectedTabName !== tabName) {
    	        this.selectedTabName = tabName;
    	    }
    	},
    	
    	/**
    	 * Load Tab Section
    	 */
    	_loadSection: function(tabName){
          var sectionid = tabName + '_section';
            switch(tabName){
                case 'physicalCount':
                	$j(this.$.physicalCount_section).show();
                	$j(this.$.addInventoryLink).hide();
                	$j(this.$.balance_section).hide();
                	this.$.contentSelector.select(1); 
                	this.$.physicalcount.invBalData=[];
                 	this.$.physicalcount.invBalDataArray=[];
                    $M.setSubRoute('storeroomdetail/physicalcount');
                    this.$.physicalcount._loadInvBalTable(this);
                    break;
                case 'balance':
                	var invBalData= this.$.physicalcount.invBalData;
                	var invBalDataArray=this.$.physicalcount.invBalDataArray;
                	this.$.contentSelector.select(0);
                	if(invBalData.length>0){
                		invBalData.forEach(function(item,index){
        		    		invBalDataArray.push(invBalData[index]);
        		    	});
        	    		
        	    		$M.showDialog(this, 'balance', null, 'maximo-physicalcount-savedialog', false, null, {'invBalData':invBalDataArray , 'MsgText':$M.localize('uitext','mxapiinvbal','physicalcountconfirmsg'),'tab':'balance' });
        	    		this.$.physicalcount.invBalDataArray=[];
        	    		this.$.physicalcount.invBalData=[];
                	}
                	else{
                		this._loadBalanceTable();
                    }
                    break;
                default: $M.setSubRoute('storeroomdetail');
            }
            if($j(window).scrollTop()){
                window.scrollTo(0,0);
            }
        },
    	 
        /**
         * Funciton to load balance Tab data
         */
    	 _loadBalanceTable:function(){
    		 $j(this.$.balance_section).show();
         	$j(this.$.addInventoryLink).show();
         	$j(this.$.physicalCount_section).hide();
         	$M.setSubRoute('storeroomdetail');
         	this._loadTable();
         	this.$.physicalcount.invBalData=[];
         	this.$.physicalcount.invBalDataArray=[];
    	 },
    	 
    	 /**
          * Function calls when click on back navigation
          */
    	_storeroomlist:function(){
    		this.$.storeroomActionsOverlay.close();
 			this.fire('storeroom-list');
    	 },
    	 _positionOverlay: function(e){
    		 	var windowHeight = $j(window).height() - 150;
    			var pos = this.overlayPosition;
    	        var topLastItems = pos.top + 50;
    	        var top = pos.top - 15;
    	        var left = pos.left - 165;
    	        this.setRowOffset = top;
    	        var overlayDiv = $j(this).find('.storeroomActionsOverlay');
    	        if((windowHeight+$j(window).scrollTop()) < topLastItems){
				   overlayDiv.addClass('fliptooltip');
				   if(this.buttonCount <= 2) {
					   $j(this.$.storeroomActionsBottomDiv).addClass('adjust-bottomdiv-top');
					   $j(this.$.storeroomActionsBottomDiv).removeClass('adjust-top');
				   }
				   if(this.buttonCount === 3) {
					   $j(this.$.storeroomActionsBottomDiv).removeClass('adjust-bottomdiv-top');
					   $j(this.$.storeroomActionsBottomDiv).addClass('adjust-top');
				   }					  
			   }else{
				   overlayDiv.removeClass('fliptooltip');
				   $j(this.$.storeroomActionsBottomDiv).removeClass('adjust-bottomdiv-top');
				   $j(this.$.storeroomActionsBottomDiv).removeClass('adjust-top');
			   }
			   $j(this.$.storeroomActionsOverlay).css({'left':left, 'top':top});
    	 },
    	 _disableSideMenu : function(e){
    			if(e.detail !== undefined ){
    				$M.toggleDisabled([ $M.workScape.querySelector('#hamburger'), $M.workScape.querySelector('#sideMenu')],e.detail);
    				$M.allowPageNavigation(!e.detail);
    			}else{
    				$M.toggleDisabled([ $M.workScape.querySelector('#hamburger'), $M.workScape.querySelector('#sideMenu')],e);
    				$M.allowPageNavigation(!e);
    			}
    		}
  
});
