/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2016,2017
 */
Polymer({
	is: 'maximo-submitsr-asset',
  	behaviors: [BaseComponent,InfiniteScroll],
    properties: {
       	label: {
			type: String,
			value: 'Panel'
		},
		icon: {
			type: String,
			value: 'title'
		},		
		
		title: {
			type: String,
			value: 'title'
		},
		itemCount: {
			type: Number,
			value: 0
		},	
		recordData :{
			type:Object,
			notify : true
		},
		itemData :{
			type:Object,
			notify : true
		},		
		selectedRecord :{
			type:Object,
			notify:true
		},		
		additionalConditionParams : {
			type:Object
		},
        searchValue: {
            type: String,
            value: '',
            notify: true,
            observer: '_valueChanged'
        },
        isSearch: {
            type: Boolean,
            value: false
        },        
        description : {
        	type : String
        },
        locationRef : {
        	type : String
        },
		siteidRef : {
			type:String
		},
        location : {
        	type : String
        },     
        locationDesc : {
        	type : String
        },         
        assetnum : {
        	type : String
        },
        siteid : {
        	type : String
        },
    	searchTerms: {
    		type: String
    	},
        userLocationDesc:{
        	type : String
        },
		additionalparams : {
			type : Object,
			notify : true
		},
		locanData : {
			type : Object,
			notify : true
		},
		locancestor :{
			type: Array,
    		value: []
		},
		bcdata : {
    		type: Array,
    		value: []
    	},
		selectedLocationDesc : {
			type: String
		},
		selectedLocation : {
			type:String
		},
        systemid : {
        	type: String
        },
        assetFirst :{ // if false, asset step is after the location step
        	type: Boolean,
        	value : false
        },
        lookupWhereClause :{
			type : String
    	},
		radiusValue:{
			type: Number
		},
		 /**
      	 * Indicates if the screen is on desktop mode
      	 */
		isDesktop: {
			type: Boolean,
			value: true,
			observer: '_updateCSS'
		},
		
		 /**
      	 * confirm dialog (location)  
      	 */
		confirmDialog: {
			type: Object 
		} ,
		
		
		/**
    	 * locAssetStatus Domain   
    	 */
		classDomain: {
    		type: Object 
    	},
    	orgid : {
        	type : String
        },
	},
	listeners :{
		'dom-change' : '_showNodataLabel',
		'maximo-lookup-selected' : '_returnFromLookup',
  		'maximo-typeahead-selected' : '_returnFromLookup',
  		'maximo-qrcode-result' : '_returnQRcode',
	},
	ready: function()
	{
		var locIdx, assIdx;
		var steps = this.parentNode.children;
		for(var i=0; i<steps.length; i++) {
			if(steps[i].tagName === this.tagName) {
				assIdx = i;
			}
			else if(steps[i].tagName === 'MAXIMO-SUBMITSR-LOCATION') {
				locIdx = i;
			}
		}
		this.assetFirst = locIdx < assIdx ?  false : true;
		this.$.locationRadiusValue.fetchProperty();
		
		var self = this;
  		$j(window).on('resize', function(){
			 self._windowResize();
	    });
	},
	
	attached: function(){
		this._windowResize();
		
		var self = this;
		this.async(function(){
			self.$.resultList.scrollTarget=self.$.assetList; 
			self.infiniteScrollingList(this.$.resultList, 'assetsrcollection');
			self._windowResize();
		}, 100);
	},
	
	/**
	 * set the scree to desktop / mobile mode
   	 */
	_windowResize : function(){
		this.isDesktop = !$M.isMobile();
	},
	
	/**
	 * set the scree to desktop / mobile mode
   	 */
	_updateCSS : function(){
		$j(this.$.assetList).toggleClass('mobile',!this.isDesktop);
	},
	
	
	/**
	 * Go to the next page 
	 */
	_goNext : function(e) {
		if (!this.assetnum || (this.$.assetsearch.value && this.$.assetsearch.value.length < 3)) {
	  		return;
	  	}
		var that = this;
		// when location step skip or asset a head
		if (!this.locationRef) {       	
    		this.additionalancestorparams = [];
    		this.additionalancestorparams.push('oslc.where=location=%22'+encodeURI(this.location)+'%22 and siteid=%22'+encodeURI(this.siteid)+'%22');
      		this.additionalancestorparams.push('responseos=MXAPILOCATION');
      		
      		that.selectedBc = '';
      		
      		this.$.locancestorcollection.refreshRecords().then(function(collection) { 			
      			if (that.locanData.length > 0 ) {
      				that._addAncestor();
          			
          			if (that.bcdata) {
          				if(that.bcdata.length > 1) {
    	        	      	for(var i =0; i<that.bcdata.length; i++) {
    	                		if(i === that.bcdata.length-1) {
    	                			if(that.bcdata[i].description!=='All'){
    	                				that.selectedBc += that.bcdata[i].description;
    	                			}
    	                			break;
    	                		} else {
    	                			if(that.bcdata[i].description!=='All'){
    	                				that.selectedBc += that.bcdata[i].description+' > ';
    	                			}
    	                		}
    	                	}
          				}
          				else {
          					that.selectedBc = '';
          				}
            	    }
          			 
         	      	that.fire('go-nextdetail', [{step:'Asset'          , value: {description: that.description, assetnum : that.assetnum, location : that.location, siteid : that.siteid, orgid : that.orgid}},
         	      			                    {step:'Location' , value: {description: that.selectedLocationDesc, breadcrumb: that.selectedBc, location:that.selectedLocation}}]);
      			} else {
      				
        	      	that.fire('go-nextdetail', [{step:'Asset'          , value: {description: that.description, assetnum : that.assetnum, location : that.location, siteid : that.siteid, orgid : that.orgid}},
        	      	                            {step:'Location' , value: {description: that.locationDesc, breadcrumb: that.selectedBc, location: that.location}}]);      			
      			}
      			that.closeConfirmDialogLocation();
      		});
    	}
    	else {
    		if (this.location != null && this.location != '' && this.location !== this.locationRef) {
    		 this.confirmDialog	=$M.confirm($M.localize('uitext', 'mxapisr', 'AssetLocationMismatch'), this.loadAssetLocation, this, 1, [0,1]);
    		}
    		else {
    			this.closeConfirmDialogLocation();
    			this.fire('go-nextdetail', {step:'Asset'       , value: {description: this.description, assetnum : this.assetnum, siteid : this.siteid, orgid : this.orgid}});
    		}
    	}
	},
	
	
	closeConfirmDialogLocation : function() {
		if( this.confirmDialog)  {
			this.confirmDialog.closeMe();
			this.confirmDialog =null;
	   }
	},
	

	loadAssetLocation : function(yes) {
		if (yes) {
    		this.additionalancestorparams = [];
    		this.additionalancestorparams.push('oslc.where=location=%22'+encodeURI(this.location)+'%22');
      		this.additionalancestorparams.push('responseos=MXAPILOCATION');
      		var that = this;
      		that.selectedBc = '';
      		this.$.locancestorcollection.refreshRecords().then(function(collection) { 			
      			if (that.locanData.length > 0 ) {
      				that._addAncestor();

          			if (that.bcdata) {
          				if(that.bcdata.length > 1) {
    	        	      	for(var i =0; i<that.bcdata.length; i++) {
    	                		if(i === that.bcdata.length-1) {
    	                			if(that.bcdata[i].description!=='All'){
    	                				that.selectedBc += that.bcdata[i].description;
    	                			}
    	                			break;
    	                		} else {
    	                			if(that.bcdata[i].description!=='All'){
    	                				that.selectedBc += that.bcdata[i].description+' > ';
    	                			}
    	                		}
    	                	}
          				}
          				else {
          					that.selectedBc = '';
          				}
            	    }
          			that.closeConfirmDialogLocation();
          			that.fire('go-nextdetail', [{step:'Asset'   , value: {description: that.description, assetnum : that.assetnum, location : that.location, siteid : that.siteid, orgid: that.orgid}},
        	 	      			                {step:'Location', value: {description: that.locationDesc, breadcrumb: that.selectedBc, location: that.location, bcdata: that.bcdata}}]);
      			}
      		});
		} else {
			this.closeConfirmDialogLocation();
			this.fire('go-nextdetail', {step:'Asset'    , value: {description: this.description, assetnum : this.assetnum, siteid : this.siteid, orgid : this.orgid}});
		}
	},
	/**
	 * Redirect on next page when skipped
	 */
	_skipStep: function(e) {
		this.$.assetsearch.value = null;
		this.description = null;
		if (this.locationRef) {
			this.fire('go-nextdetail', {step:'Asset', value:{}});
		} else {
			if(this.assetFirst){
				this.fire('go-nextdetail', {step:'Asset', value:{}});
			}
			else{
				this.fire('go-nextdetail', [{step:'Asset', value:{}},
				                            {step:'Location', value:{}}]);
			}
		}
	
	},
	/**
	 * Initialize the page data
	 */
	initPage: function() {
		this._initVar();
	},
	/**
	 * Function for initialize the page data variables
	 */
	_initVar : function() {
		// asset variable
		this.$.assetsearch.value=null;
		this.searchValue='';
		$j(this.$.itemList).toggleClass('setAsset',false);
		this.locationRef = null;
		this.siteidRef = null;
		this.description = null;
        this.assetnum = null;
		this.location = null;
		this.siteid = null;
		this.orgid = null;
		this._myIronList = null;
		
		//location info variable 
		this.selectedLocation = null;
		this.selectedBc = null;
		this.selectedLocationDesc = null;
		this.additionalparams = [];
		this.bcdata = [];
	},
	
	
	/**
	 * function for filtering the data
	 */
   _filter: function(val) {  
    	var that = this;
    	this.itemCount = 0;
		this.additionalConditionParams = [];
    	$j(this.$.selectAssetWrapper).css({'display':'none'});
     	if (val.length < 3) {
        	this.itemCount = 0;
    		this.isSearch = true;
    		$j(this.$.itemList).toggleClass('setAsset',true);
    		
    		return null;
    	}
    	else if (val.length === 3 && this.isSearch) {
            val =  encodeURIComponent(val);
            
    		this.$.nodataLabelWrapper.hidden=true;
    		// searchTerms
    		this.recordData = [];
    		this.isSearch = false;
 
    		this.searchTerms = val + '%';
    		//oslc.where
    		this.additionalConditionParams = [];
    		
    		// exist location from locations
    		if(this.locationRef)
    		{
    			this.additionalConditionParams.push('oslc.where=status%20in%5B'+this._getDomains(['ACTIVE','OPERATING'])+'%5D%20and%20primarysyslocasset.ancestor=%22'+encodeURI(this.locationRef)+'%22%20and%20siteid=%22'+this.siteidRef+'%22');
    			this.$.assetsrcollection.refreshRecords().then(function(){
    				if(that.recordData.length === 0) {
    					that.additionalConditionParams = [];
    					that.additionalConditionParams.push('oslc.where=status%20in%5B'+this._getDomains(['ACTIVE','OPERATING'])+'%5D%20and%20location%21=%22%2A%22%20and%20siteid=%22'+that.siteidRef+'%22');
    					that.$.assetsrcollection.refreshRecords();  
    				}
    			});
    		} 
    		else
    		{
    			this.locationRef = null;    	
    			this.$.assetsrcollection.refreshRecords();      
    		}
    		
    		$j(this.$.itemList).toggleClass('setAsset',false);
    	    return function(asset) {
				return that._findAsset(val, asset);
    	    }; 
    	}
    	else {
    		$j(this.$.itemList).toggleClass('setAsset',false);
    	    return function(asset) {
				return that._findAsset(val, asset);
    	    };    		
    	}
    },
    /**
	 * function for finding the asset values
	 */
    _findAsset : function(val, asset)
    {
    	 var desc = new String(asset.description).toUpperCase();
		 var assetnum = new String(asset.assetnum).toUpperCase();
		 val = val.toUpperCase();

		 var result = desc.includes(val) || assetnum.includes(val);
		 
		 if (result)
		 {
			 this.itemCount = this.itemCount + 1;
		 }
		 return result;
    },
    /**
	 * function for getting the asset
	 */
    _getAsset(item) {
    	var desc = item.description;
    	
    	return desc + ' (' + item.assetnum + ')';
    },
    /**
	 * function for getting the asset description
	 */
    _getAssetDisp(item) {
    	return  '(' + item.assetnum + ')';
    },
    /**
	 * Check changed value
	 */
    _valueChanged: function(e) {
        if (this.searchValue.length >= 3) 
        {
            this.$.resultList.render();
        }
    },
    /**
	 * Selected asset 
	 */
    _selectedAsset : function (e) {
  	    var assetDiv = e.currentTarget;
    	
    	this.description = assetDiv.description;
    	this.assetnum = assetDiv.assetnum;
    	this.$.assetsearch.value = assetDiv.description;
    	this.siteid = assetDiv.siteid;
    	this.orgid = assetDiv.orgid;
    	
    	if (!assetDiv.location) {
    		this.location = '';
    		this.locationDesc = '';
    	} else {
    		this.location = assetDiv.location;
    		this.locationDesc = assetDiv.locationdesc;
    	}
 
    	this.$.selectAssetWrapper.hidden = false;
    	$j(this.$.itemList).toggleClass('setAsset',true);
    	$j(this.$.selectAssetWrapper).css({'display':'block'});
    },
    /**
	 * Handle record data
	 */
    _handleRecordDataRefreshed : function() {
    	var that = this;
  		if(that.recordData && that.recordData.length === 0) {
  			that.$.nodataLabelWrapper.hidden=false;
  			$j(this.$.assetList).toggleClass('noRecords',true);
		} else {
			that.$.nodataLabelWrapper.hidden=true;
			$j(this.$.assetList).toggleClass('noRecords',false);
		}
    },
    /**
	 * Handle data error
	 */
	_handleDataError : function(){
	},
	/**
	 * Show no data lebel when no data is selected
	 */
    _showNodataLabel : function(){
    	if (this.recordData && this.recordData.length > 0) {
        	if(this.searchValue){
        		if(!this.querySelector('.divRow')){
        			this.$.nodataLabelWrapper.hidden=false;
        		}
        		else{
        			this.$.nodataLabelWrapper.hidden=true;
        		}
        	}
    	}

    },
    /**
	 * Render the data on the page
	 */
	renderPage: function(submitInfo, stackData) {
		this.$.nodataLabelWrapper.hidden=true;
		this._initVar();
		// Hide the button if asset is not defined
		if(!this.$.assetsearch.value){
 			this.$.selectAssetWrapper.hidden = true;
 		}
		if(submitInfo['Location'] && submitInfo['Location'].contents && submitInfo['Location'].contents.location) {
			if (!submitInfo['Location'].contents.skipped) {
				this.locationRef = submitInfo['Location'].contents.location;
				this.siteidRef = submitInfo['Location'].contents.siteid;
			} 
		}
		
		var newStackData = [];
		if (stackData) {
			for (var idx = stackData.length-1; idx>=0; idx--) {
				if (stackData[idx].data && stackData[idx].data.length !== 0) {
					newStackData.push($M.cloneRecord(stackData[idx]));
				}
			}
		}
		this.$.assetStep.setStackList(newStackData);

		if (!this.siteidRef && submitInfo['Asset'] && submitInfo['Asset'].contents) {
			this.siteidRef = submitInfo['Asset'].contents.siteid;
		}

		this.$.nodataLabelWrapper.hidden=true;
		this.recordData = [];
		//oslc.where
		this.additionalConditionParams = [];
		
		// exist location from locations
		if(this.locationRef)
		{
			this.lookupWhereClause = 'oslc.where=status%20in%5B'+this._getDomains(['ACTIVE','OPERATING'])+'%5D';
			this.lookupWhereClause += '%20and%20primarysyslocasset.ancestor=%22' + encodeURI(this.locationRef) + '%22%20and%20siteid=%22'+this.siteidRef+'%22';
			this.additionalConditionParams.push(this.lookupWhereClause);
			this.$.assetsrcollection.refreshRecords().then(function() {});
		} 
		else
		{
			this.locationRef = null;
			this.$.assetsrcollection.refreshRecords();
			this.lookupWhereClause = 'oslc.where=status%20in%5B'+this._getDomains(['ACTIVE','OPERATING'])+'%5D';
			//this.lookupWhereClause += '%20and%20primarysyslocasset.locsystem.primarysystem=1';
		}
		$j(this.$.itemList).toggleClass('setAsset',false);
  		this.async(function(){
  			this.$.assetsearch._closeTAResult(window.event);
		});
	},
	/**
	 * Add Ancestor parameters
	 */
	_addAncestor : function() {
		var that = this;
		var sysId ;
		
		for(var i=0; i<that.locanData.length; i++){
			if (i === 0) {
				that.systemid = that.locanData[i].systemid;
				sysId = that.systemid;
			}
			
			if(that.locanData[i].ancestor === that.location ){
				if(!sysId){
					that.systemid = sysId = that.locanData[i].systemid;
				}
				that.userLocationDesc = that.locanData[i].locations.description;
				that.siteid = that.locanData[i].siteid;
			}
		}
	
		for(i=0; i<that.locanData.length; i++){
			if(that.locanData[i].systemid === sysId){
				that.locancestor.push(that.locanData[i]);
			}
		}
		
		that._initUserLocationBreadcrumb(that.locancestor);        
	},
	/**
	 * function for initialize breadcrumb 
	 */
	_initUserLocationBreadcrumb : function(list){
		this.bcdata = [];
		var tempParent;

		var userloc = this.location;
		
		if (this.userLocationDesc) {
			this.selectedLocationDesc = this.userLocationDesc;
		} else {
			this.selectedLocationDesc = '';
		}
		
		this.selectedLocation = userloc;

		for(var i=0; i<list.length; i++){
			if(list[i].ancestor === userloc){ 
				this.bcdata.push({'description':list[i].locations.description, 'location':list[i].ancestor, 'siteid':list[i].siteid});
				if(list[i].lochierarchy.parent){
					tempParent = list[i].lochierarchy.parent;
				}
				else{
					break;
				}
				for(var j =0 ; j<list.length; j++){
					if(list[j].ancestor === tempParent){
						this.bcdata.push({'description':list[j].locations.description, 'location':list[j].ancestor, 'siteid':list[j].siteid});
						userloc = list[j].lochierarchy.parent;
						i = -1;
						break;
					}
				}
			}
		}
		this.bcdata.push({'description':'All', 'location':'All'});
		this.bcdata.reverse();
		this.locancestor = [];
	},
	/**
	 * To set the values from Location lookup for BotC only
	 */
    _returnFromLookup: function(e) {
    	if(e.detail.records[0] && e.detail.records[0].assetnum){
			this.$.assetsearch.value = e.detail.records[0].description;
			this.description = e.detail.records[0].description;
			this.assetnum = e.detail.records[0].assetnum;
			this.siteid = e.detail.records[0].siteid;
    		this.location = e.detail.records[0].location.location;
    		this.locationDesc = e.detail.records[0].location.description;
    		this.orgid = e.detail.records[0].orgid;
			this.$.selectAssetWrapper.hidden = false;
		} else {
		       this.$.selectAssetWrapper.hidden = true;
    	}

    	$j(this.$.itemList).toggleClass('setAsset',true);
    	$j(this.$.selectAssetWrapper).css({'display':'block'});
	},
	/**
	 * To check the value from the input field for BotC only
	 **/
	_enableSetLocation : function(e){
		if(this.$.assetsearch.value===e.currentTarget.dataHost.asset){
			this.$.selectAssetWrapper.hidden = false;
		}
		else {
			this.$.selectAssetWrapper.hidden = true;
		}
	},
	_scroll: function(e){
//		if (!this._myIronList) {
//			this._scrollCollectionId = 'assetsrcollection';
//			var ironLists = $j(this.$.itemList).find('iron-list');
//			if(ironLists.length === 1){
//				ironLists[0].scrollTarget = this.$.assetList;
//				this._myIronList = ironLists[0];
//				this.infiniteScrollingList(ironLists[0]);
//			}
//		}
	},

  	_handleGetRadiusProperty: function(e) {
  		this.radiusValue = parseInt(e.detail);
  	},

	_showNearbyAssets: function() {
		if ("geolocation" in navigator) {
			$M.toggleWait(true);

			var that = this;
			var geoUtility = document.createElement('maximo-geo-utility');
			var lookupDefinition = JSON.parse(this.$.assetsearch.lookup);
			var whereClause = 'oslc.where=status%20in%5B'+this._getDomains(['ACTIVE','OPERATING'])+'%5D%20and%20';
			
			

			navigator.geolocation.getCurrentPosition(function(position) {
				console.log(position.coords.latitude);
				console.log(position.coords.longitude);
				$M._currentCoordinates = {"latitude": position.coords.latitude, "longitude": position.coords.longitude};
				var boundingBox = geoUtility.boundingBox(position.coords.latitude, position.coords.longitude, that.radiusValue);
				
				whereClause = whereClause + 'asset_serviceaddress.latitudey%3E%3D' + boundingBox['latMin'] + '%20and%20asset_serviceaddress.latitudey%3C%3D' + boundingBox['latMax'];
				whereClause = whereClause + '%20and%20';
				whereClause = whereClause + 'asset_serviceaddress.longitudex%3E%3D' + boundingBox['lonMin'] + '%20and%20asset_serviceaddress.longitudex%3C%3D' + boundingBox['lonMax'];
				$M.toggleWait(false);
				$M.showLookup(lookupDefinition['name'], that, that.getAttribute('data-scope-id'), lookupDefinition['href'], null, whereClause);
			}, function(error) {
				$M.toggleWait(false);
				$M.alert($M.localize('uitext', 'mxapisr', 'GeolocationNotAvailable'), $M.alerts.info);
            });
		} else {
			/* geolocation IS NOT available */
			$M.alert($M.localize('uitext', 'mxapisr', 'GeolocationNotAvailable'), $M.alerts.info);
		}
	},
	
	_returnQRcode: function(event) {
		if(event.detail.identifier == 'asset'){
			
			
			var maximoQbe = new MaximoQbe();
		    maximoQbe.setIn('assetnum',event.detail.value);
			qbeObject = maximoQbe.toJSON();
			this.$.assetQRCode.queryWhere = qbeObject; 
			var self = this;
		 	self.$.assetQRCode.refreshRecords().then(function() {
		 		
		 		if(self.$.assetQRCode.collectionData.length>0){
		 			var fakeEvent={};
		 			fakeEvent.detail={};
		 			fakeEvent.detail.records=[self.$.assetQRCode.collectionData[0]];
		 			self._returnFromLookup(fakeEvent);
		 		}else{ 
		 			self.$.assetsearch.value='';
		 			$M.notify($M.localize('uitext', 'mxapisr', 'NoResultsFound'), $M.alerts.warn);
		 		}
					
			});
			
		}
	},
	
	
	/** 
	 * retrieve a  domain set
	 */
	_getDomains: function( listStatus) {
		var result=''
	    var separator=''
		this.classDomain[0].synonymdomain.forEach(function(domain){
			if(this.containsElement(listStatus,domain.maxvalue) ){
				result += separator + '%22'+domain.value +'%22';
				separator=',';
			}
		}, this);
		
		return   result;
	},
	
	
	/**
	 * check if a list contains a element
   	 */
	containsElement: function(list , element) {
		var result = false;
		  list.some(function(value){
			  if(value == element){
				  result = true;
				}
			}, this);
		
		return result;
	},
});
