/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2016,2017
 */
Polymer({
	is: 'maximo-submitsr-wizard',
  	behaviors: [BaseComponent],
	properties : {
		/**
		 * page selected
		 */
    	selectedtab: {
    		type: Number,
    		notify: true ,
    		observer:'_displayPage'   	
    	},
    	
    	/**
		 *   new record href
		 */
    	newSrHref:{
			type: String,
			notify: true
		},
		
		/**
		 *  MXAPISR|SRNOTF
		 *  subscribe notification
		 */
		ctxSR:{
			type: Object,
			notify: true
		},
		
		/**
		 *  page list can be displayed
		 */
		_pages:{
			type: Array,
	    		value: function () {
	    			return [ 'subcategoryStep','defineissueStep','additionaldetailsStep',
	    				     'describeissueStep', 'behalfStep','attachmentStep','locationStep','assetStep',
	    				      'addcommentStep', 'reviewsrStep'];
	    		} 
		},
		
		/**
		 *  page index  
		 *  used to get access a specific page
		 */
		_pageIndex:{
			type: Object,
	    		value: function () {
	    			var record={'subcategoryStep':0,
	    					    'defineissueStep':1,
	    					    'additionaldetailsStep':2,
	    					    'describeissueStep':3,
	    					    'behalfStep':4,
	    					    'attachmentStep':5,
	    					    'locationStep':6,
	    					    'assetStep':7,
	    					    'addcommentStep':8,
	    					    'reviewsrStep':9};
	    			return record;
	    		} 
		},
		
		/**
		 *   information set on current step 
		 */
		_submitInfo: {
			type: Object,
			notify: true
		},
		
		/**
		 *  trace of information to be displayed on template
		 */
		_stackData :{
			type:Object,
			notify:true
		} ,
		
		
		/**
		 *   indicate if  Sub-Category page will be displayed
		 */
		_displaySubCategoryPage :{
			type: Boolean,
			value:true 
		}, 
		
		
		/**
		 *   indicate if  Define Issue  page will be displayed
		 */
		_displayDefineIssue :{
			type: Boolean,
			value:true 
		} ,
		

		/**
		 *   indicate if  Define Issue  was loaded
		 */
		_isDefineIssueLoaded :{
			type: Boolean,
			value:false 
		},
		
		selectedRecord :{
			type:Object,
			notify:true
		},
		
		
    	/**
    	 * locAssetStatus Domain   result
    	 */
		locAssetStatusDomainSet: {
    		type: Object 
    	},
    	
    	
    	/**
    	 * wo Class   filter
    	 */
    	locAssetStatusDomainFilter: {
    		type: Array,
    		value: function () {
    			return [{'filtertype': 'SIMPLE', 'field': 'domainid', 'availablevalues': [ {'value': 'LOCASSETSTATUS', 'selected': true} ]}];
    		} 	
    	} ,
    	
    	/**
    	 * Attribute Domain filter
    	 */
    	attribDomainFilter: {
    		type: Array,
    		value: function () {
    			return [{'filtertype': 'SIMPLE', 'field': 'domainid', 'availablevalues': [ {'value': 'DATATYPE', 'selected': true} ]}];
    		} 	
    	},
    	
    	 /**
    	 * Attribute Domain result
    	 */
        
    	attribDomainSet: {
    		type: Object,
    		notify: true ,
    		value:[]
    	},
    	
    	
    	
    	/**
    	 * doctype Domain filter
    	 */
    	doctypeDomainFilter: {
    		type: Array,
    		value: function () {
    			return [{'filtertype': 'SIMPLE', 'field': 'domainid', 'availablevalues': [ {'value': 'URLTYPE', 'selected': true} ]}];
    		} 	
    	},
    	
    	 /**
    	 * doctype Domain result
    	 */
        
    	doctypeDomainSet: {
    		type: Object,
    		notify: true ,
    		observer:'_configureDoctypeDomain'
    	},
    	
    	
    	FILE_DOMAIN: {
			type: String 
		},
		 
	},
	
	listeners:{
		'show-sub-category' : '_showSubCategoryPageHandler',
		'show-describe-issue' : '_showDescribeIssuePageHandler',
		'show-behalf' : '_showBehalfPageHandler',
		'submit-info' : '_onSubmitInfo',
	},
	
  	created : function() {
  	},
  	
	
  	/**
	 *  set  subscribe parameter .
	 *  set start step 
	 */
  	ready : function() {
  		this.selectedtab=0;
  		this.$.maxsynonymdomain.fetchValue(); 
  		this.$.locAssetStatusDomain.refreshRecords();
  		this.$.doctypeDomain.refreshRecords();
  		var ctxSR ={};
  		ctxSR.subscribeto= 'MXAPISR|SRNOTF';
		this.set('ctxSR', ctxSR);
  	},
  	
  	
  	/**
	 *  set  device mode
	 */
  	attached: function() {
  		this._submitInfo = {};
  		this._stackData = [];
  		if($M.screenInfo.device === 'desktop'){
  			$j(this.$.panelHeader).addClass('panelHeaderDesktop');
  		} 	
  	},
  	
  	
  	/**
	 *  hide/display a specific page  
	 */
	_displayPage: function(newValue, oldValue) {
		$j(this.$[this._pages[oldValue]+'Div']).toggleClass('hidePage',true);
		$j(this.$[this._pages[newValue]+'Div']).toggleClass('hidePage',false);
		this.addContent(this._pages[this.selectedtab]);
		this.$.pages.select(this.selectedtab);
		console.log('selectedtab:'+this.selectedtab);
	},
	
	/**
	 *  display sub-category page
	 */
	_showSubCategoryPageHandler: function(e) {
		this._displaySubCategoryPage = true;
		this._showSubCategoryPage(e.detail);
	},
	
	
	/**
	 *  display Describe Issue page
	 */
	_showDescribeIssuePageHandler: function(e) {
		this._displaySubCategoryPage = false; 
		this._displayDefineIssue=false;
		this._showDescribeIssuePage(e.detail);
	},
	
	/**
	 *  display On Behalf page
	 */
	_showBehalfPageHandler: function(e) {
		this._displaySubCategoryPage = false; 
		this._displayDefineIssue=false;
		this._showBehalfPage(e.detail);
	},
	

	/**
	 *  display sub-category page
	 */
	_showSubCategoryPage: function(record) {
		if(!this._displaySubCategoryPage){
			this._goToNextStep(record, this._pageIndex.subcategoryStep);
		}
		 
		var classstructureid ;
		if(record){
			if(record.value &&   record.value.classstructureid){
				classstructureid = record.value.classstructureid;
			}
		}else{
			if(this._submitInfo.Category ){
				classstructureid = this._submitInfo.Category.contents.classstructureid;
			}
		}
		var subcategoryStep = this.getComponent('subcategoryStep');
		var self =this;
		subcategoryStep.getSubCats(classstructureid).then(function(collection) {
			if(subcategoryStep.isEmpty){
				self._displaySubCategoryPage = false;
				self._goToNextStep(record, self._pageIndex.subcategoryStep);
			}else{
				self._displaySubCategoryPage = true;
				self._preparePage(record,self._pageIndex.subcategoryStep);
			}
		
		});
		
    },
	 
    
    /**
	 *  display sub-category page
	 */
	_showDefineIssuePage: function(record,goNext) {
		if(!this._displayDefineIssue){
			if(goNext){
				this._goToNextStep(record, this._pageIndex.defineissueStep);
			}else{
				this._goToPreviousStep(this._pageIndex.defineissueStep);
			}
		}
		
		 
		var classstructureid ;
		if(record){
			if(record.value &&   record.value.classstructureid){
				classstructureid = record.value.classstructureid;
			}
		}else{
			if(this._submitInfo.Category ){
				classstructureid = this._submitInfo.Category.contents.classstructureid;
			}
		}
		var defineissueStep = this.getComponent('defineissueStep');
		var self =this;
		
		if(this._isDefineIssueLoaded){
			if(defineissueStep.isEmpty){
				if(goNext){
					this._goToNextStep(record, this._pageIndex.defineissueStep);
				}else{
					this._goToPreviousStep( this._pageIndex.defineissueStep);
				}
			}else{
				self._displayDefineIssue =true;
				self._preparePage(record,self._pageIndex.defineissueStep);
			}
		}else{
			if(classstructureid){
				defineissueStep.getIssues(classstructureid).then(function(result) {
					self._isDefineIssueLoaded =true;
					if(defineissueStep.isEmpty){
						self._displayDefineIssue =false;
						if(goNext){
							self._goToNextStep(record, self._pageIndex.defineissueStep);
						}else{
							self._goToPreviousStep( self._pageIndex.defineissueStep);
						}
					}else{
						self._displayDefineIssue =true;
						self._preparePage(record,self._pageIndex.defineissueStep);
					}
		  		});
			}else{
				this._displayDefineIssue =false;
				if(goNext){
					this._goToNextStep(record, this._pageIndex.defineissueStep);
				}else{
					this._goToPreviousStep( this._pageIndex.defineissueStep);
				}
			}
			
		}
		 
		
	},
	
	/**
	 *  display sub-category page
	 */
	_showAdditionalDetailsPage: function(record,goNext) {
		
		 if (this.selectedRecord && this.selectedRecord.tktemplatespec && this.selectedRecord.tktemplatespec.length>0) {
			 this._preparePage(record,this._pageIndex.additionaldetailsStep);
		 }else{
			 if(goNext){
				 this._goToNextStep(record, this._pageIndex.additionaldetailsStep);
			 }else{
				 this._goToPreviousStep(this._pageIndex.additionaldetailsStep);
			 }
		 }
		
	},
	
	/**
	 *  display Describe Issue page
	 */
	_showDescribeIssuePage: function(record,goNext) {
		 if (this._submitInfo.Issue && this._submitInfo.Issue.contents && this._submitInfo.Issue.contents.templateid) {
			 if(goNext){
				 this._goToNextStep(record, this._pageIndex.describeissueStep);
			 }else{
				 this._goToPreviousStep( this._pageIndex.describeissueStep);
			 }
		 }else{
			 this._preparePage(record,this._pageIndex.describeissueStep);
		 }
	},
	
	/**
	 *  display Comments page
	 */
	_showCommentsPage: function(record,goNext) {
		this._preparePage(record, this._pageIndex.addcommentStep);
	},
	  
	
	
	
	/**
	 *  display  Behalf page
	 */
	_showBehalfPage: function(record) {
		 this._preparePage(record,this._pageIndex.behalfStep);
	},
	
	/**
	 *  display Attachment page
	 */
	_showAttachmentPage: function(record) {
	 
		this._preparePage(record,this._pageIndex.attachmentStep);
	},
	
	/**
	 *  display Location page
	 */
	_showLocationPage: function(record) {
		this._preparePage(record,this._pageIndex.locationStep);
	},
	
	/**
	 *  display Asset page
	 */
	_showAssetPage: function(record) {
		this._preparePage(record,this._pageIndex.assetStep);
	},
	
	/**
	 *  display Review page
	 */
	_showReviewSRPage: function(record) {
		this._preparePage(record,this._pageIndex.reviewsrStep);
	},
	
	
	/**
	 *  prepare a page to be displayed
	 */
	_preparePage: function(record, pageNumber) {
		
		 if (this._isPageAuthorized(pageNumber)) {
			 if(record){
				 this.addSubmitInfo(record);
			 }else{
				 record = this._submitInfo;
			 }
			 this.open(record.haschildren, record.ccdesc, record.ccid);
			 this._goToPage(pageNumber); 
		  }
	 },
	 
	 /**
	 *   has authorization to go to page
	 */
	 _isPageAuthorized :function(pageNumber){
		 var result = this.$[this._pages[pageNumber]+'Div'].isAuthorized;
		 if(!result){
			  console.log('use does not have permission to page :'+this._pages[pageNumber]);
		  }
		 return result; 
	 },
	

	 
	 /**
	 *   go to previous page
	 */
	 _prevStep: function(e ){
	 	this._goToPreviousStep();
	 },
	 
	 
	 /**
	 *   go to previous page
	 */	
  	_goToPreviousStep: function(currentPage){
  		this.saveDraft();
	    var pageNumber = this.selectedtab ;
  		if(currentPage!=null){
  			this._byPassRenderPage = true;
  			this.selectedtab=currentPage;
  			pageNumber= currentPage -1;
  		}else{
  			 pageNumber = this.selectedtab - 1;
  		}
  		
  	 
 		while ( pageNumber>0 && !this._isPageAuthorized(pageNumber) ) {
 			pageNumber--;
 		}
 		this._showPage(pageNumber, false);
  	},
	  
	 
	 /**
	 *   go to next page
	 */ 	
  	_nextStep: function(event){
  		if(event.detail){
			 this.addSubmitInfo(event.detail);
		 }
  		this._goToNextStep(event.detail );
  	},
  	
  	
  	/**
	 *   go to next page
	 */ 	
  	_goToNextStep: function(submitInfo , currentPage){
  		var pageNumber = 0 ;
  		if(currentPage!=null   && typeof currentPage === 'number' ){
  			this._byPassRenderPage = true;
  			this.selectedtab=currentPage;
  			pageNumber= currentPage +1;
  		}else{
  			 pageNumber = this.selectedtab + 1;
  		}
  		 
  		while ((pageNumber < this._pages.length) && !this._isPageAuthorized(pageNumber)  ) {
  			pageNumber++;
		}
  		this._showPage(pageNumber,true,submitInfo);
  	},
	 
	 
  	/**
	 *   display a specific page
	 */
  	_showPage: function(pageNumber,goNext,submitInfo) {
  	   if (  pageNumber<=0) {
 			this.close(true);
 			this.selectedtab =0;
 			return;
 	   }
  		
	   switch(pageNumber) {
	 	    case this._pageIndex.subcategoryStep:
	 	        this._showSubCategoryPage(submitInfo);
	 	        break;
	 	    case this._pageIndex.defineissueStep:
	 	    	 this._showDefineIssuePage(submitInfo,goNext);
	 	        break;
	 	    case this._pageIndex.additionaldetailsStep:
	 	    	 this._showAdditionalDetailsPage(submitInfo,goNext);
	 	        break;
	 	  case this._pageIndex.describeissueStep:
	 	    	 this._showDescribeIssuePage(submitInfo,goNext);
	 	        break; 
	 	 case this._pageIndex.behalfStep:
 	    	 this._showBehalfPage(submitInfo);
 	        break;         
	 	    case this._pageIndex.attachmentStep:
	 	    	 this._showAttachmentPage(submitInfo);
	 	        break;
	 	    case this._pageIndex.locationStep:
	 	    	 this._showLocationPage(submitInfo);
	 	        break;
	 	    case this._pageIndex.assetStep:
	 	    	 this._showAssetPage(submitInfo);
	 	        break; 
	 	        
	 	   case this._pageIndex.addcommentStep:
	 	    	 this._showCommentsPage(submitInfo,goNext);
	 	        break;      
	 	  case this._pageIndex.reviewsrStep:
	 		 this._showReviewSRPage(submitInfo);
	 	        break;
	 	  default:
	 		 this._showReviewSRPage(submitInfo);
	    };
	    
	},
	
	
	/**
	 *   go to a specific page
	 */
	_goToPage: function(pageNumber) {
		
		var toIssue = ( pageNumber <=2 ) ;
		var toDetails = ( pageNumber >=3  &&  pageNumber <= 8) ;
		var toReview =  ( pageNumber ==9 );
		
		
		if( pageNumber >=3){
			 this.$.submitsrWizard.fire('set-step-state',{'index':0, 'state':'complete'});
		}
		
		if( pageNumber >8){
			 this.$.submitsrWizard.fire('set-step-state',{'index':1, 'state':'complete'});
		}
	 
		 if(toReview){
			 this.$.submitsrWizard.currentIndex =2;
		 }else  if(toDetails){
			 this.$.submitsrWizard.currentIndex =1;
		 } if(toIssue){
			 this.$.submitsrWizard.currentIndex =0;
		 }
		 
		 if( pageNumber <=2){
			 this.$.submitsrWizard.fire('set-step-state',{'index':0, 'state':'initial'});
			 this.$.submitsrWizard.fire('set-step-state',{'index':1, 'state':'initial'});
			 this.$.submitsrWizard.fire('set-step-state',{'index':2, 'state':'initial'});
		} else if( pageNumber <=8){
			 this.$.submitsrWizard.fire('set-step-state',{'index':1, 'state':'initial'});
			 this.$.submitsrWizard.fire('set-step-state',{'index':2, 'state':'initial'});
		}
		 
		 this.selectedtab = pageNumber;
	     this.renderPage(this._submitInfo, this._stackData);    
	},
	
 
	/**
	 *   render a specific page
	 */
	saveDraft: function() {
		
		 var selectedPage = $j(this.$.pages).find('#'+this._pages[this.selectedtab])[0];
		 if(selectedPage  && ( typeof selectedPage.saveDraft === 'function') ){
			  selectedPage.saveDraft(); 
		 }

	},
	
	
	/**
	 *   render a specific page
	 */
	renderPage: function(submitInfo, stackData) {
		this._submitInfo = submitInfo;
		this._stackData = stackData;
		
		 var selectedPage = $j(this.$.pages).find('#'+this._pages[this.selectedtab])[0];
		 
		 if(selectedPage  && ( typeof selectedPage.renderPage === 'function') ){
			  selectedPage.renderPage(submitInfo, stackData); 
		 }

	},
	
	
	/**
	 *   open wizard  
	 */
  	open: function(haschildren,ccdesc, ccid,templateid,tkspeccount, callback) {
  		var that = this;
  		$j(this).off('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend');
  		  		
  		this.hidden = false;
		this.async(function() {
			if (callback) {
				$j(that).one('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend', function(e){
					if (e.target === that) {
						$j(that).off('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend');
						callback();
						return false;
					}
				}); 
			}
			
			$j(that).addClass('panel-slide-open');
		}, 100);
  	},
  
  	/**
	 *   close wizard  
	 */
  	close: function(slidingEffect, callback) {
  		 
  		this.$.submitsrWizard.reset();
		var steps = $j(this).find('maximo-wizard-step');
		for (var i = 0; i < steps.length; i++) {
			this.$.submitsrWizard.fire('set-step-state', {index: i, state:'initial'});
		}
	
	    this.initPages();
		
	    this._submitInfo = {};
		this._stackData = [];

  		if (slidingEffect) {
			var that = this;
			
			$j('maximo-button button').one('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend', function(e){
				e.stopPropagation();
			});
			$j('maximo-button').one('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend', function(e){
				e.stopPropagation();
			});
			$j('.maximo-wizard-step').one('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend', function(e){
				e.stopPropagation();
			});

			$j(this).one('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend', function(e){
				if (e.target === that) {
					$j('maximo-button button').off('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend');
					$j('maximo-button').off('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend');
					$j('.maximo-wizard-step').off('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend');
					$j(that).off('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend');
					
					that.hidden = true;
					
					if (callback) {
						callback();
					}
				}
			});
  		}
  		else {
  			this.hidden = true;
			if (callback) {
				callback();
			}
  		}
  		
		$j(this).removeClass('panel-slide-open');
  		this.fire('close-wizard');
  	},
  	
  	/**
	 *   reset wizard  
	 */
	initPages: function( ) {
  		var self =this; 
  		this._pages.forEach(function(page){
			 var selectedPage = $j(self.$.pages).find('#'+page)[0];
			 if(selectedPage  && ( typeof selectedPage.initPage === 'function')){
				 selectedPage.initPage();
			 }
		});
  		
  		this._displaySubCategoryPage = true;
  		this._displayDefineIssue = true;
  		this._isDefineIssueLoaded = false;
  	},
  	
  	
  	/**
	 *   store information set on specific step  
	 */
	addSubmitInfo: function(info) {
		if (info instanceof Array) {
			for (var idx in info) {
				if (info[idx].step) {
					if (!this._submitInfo[info[idx].step]) {
						this._submitInfo[info[idx].step] = {};
					}
					this._submitInfo[info[idx].step].contents = info[idx].value;
					this._addStackData(info[idx].step, info[idx].value);
				}  				   					 
			}
		}
		else {
			if (info.step) {
				if (!this._submitInfo[info.step]) {
					this._submitInfo[info.step] = {};
				}
				this._submitInfo[info.step].contents = info.value;
				this._addStackData(info.step, info.value)
			}  				 
		}  		
  	},
  	
  	
  	/**
	 *   store information set on specific step  
	 */
  	_addStackData: function(step, contents) {
 		var data;
  		
  		switch (step) {
  		case 'Category' : 
  			if (contents && contents.classstructureid) {
  				data = contents.description;
  			}else{
  				data = '--';
  			}
  			break;
  		case 'Description' : 
  			if (contents && contents.description) {
  				data = contents.description;
  			}else{
	
  				data = '';
  			}
  			
  			break;
  		case 'Location' :
  			if(contents && contents.location) {
  				data = contents.description;
  			}
  			else {
  				data = '--';
  			}
  			break;
  		case 'affectedPerson' :
  			if(contents && contents.personName) {
  				data = contents.personName;
  			}
  			else {
  				data = '--';
  			}
  			break;		
  		default : 
  			if(contents) {
  				if (contents.description) {
  					data = contents.description;	
  				} else {
  	  				data = '--';
  				}
  			}else{
  				data = '';
  			}
  			break;
  		}
		
  		if (typeof this._submitInfo[step].stackListIndex === 'undefined') {
  	  		var newStackData = {'step':step ,'topic': $M.localize('uitext','mxapisr',step), 'data':data};	
  			var idx = this._stackData.push(newStackData);
  	  		this._submitInfo[step].stackListIndex = idx - 1;
  		} else {
  			this._stackData[this._submitInfo[step].stackListIndex].data = data;
  		} 		
  	},
  	
  	/**
	 *   store information set on specific step  
	 */
  	_onSubmitInfo: function(e) {
  		 if (e.detail) {
  			 this.addSubmitInfo(e.detail);
  		 } 		 
  	},
  	
  	/**
	 *   create new Record  
	 */
  	_onSrSubmit: function(e) {
  		var newSR ={};
  		
  		this.fire('show-wait-spinner', true);

  		//newSR.class = this.classValue;
  		newSR.description = '';
  		
  		if (this._submitInfo.Category && this._submitInfo.Category.contents && this._submitInfo.Category.contents.classstructureid) {
  	  		newSR.classstructureid = this._submitInfo.Category.contents.classstructureid;
 		}
  		if (this._submitInfo.Issue && this._submitInfo.Issue.contents && this._submitInfo.Issue.contents.templateid) {
  			newSR.description = this._submitInfo.Issue.contents.description;
  		} else if (this._submitInfo.Description && this._submitInfo.Description.contents && this._submitInfo.Description.contents.description) {
  			newSR.description = this._submitInfo.Description.contents.description;
  		}
		
  		if (this._submitInfo.Description && this._submitInfo.Description.contents && this._submitInfo.Description.contents.description_longdescription) {
  			newSR.description_longdescription = this._submitInfo.Description.contents.description_longdescription;
  		}else if (this._submitInfo.AdditionalInformation && this._submitInfo.AdditionalInformation.contents && this._submitInfo.AdditionalInformation.contents.description) {
  			newSR.description_longdescription = this._submitInfo.AdditionalInformation.contents.description;
  		}
  		
  		newSR.reportedby = $M.userInfo.personid;
  		
  		
  		 
  		 if(this._submitInfo.affectedPerson &&this._submitInfo.affectedPerson .contents){
  			 var person = this._submitInfo.affectedPerson.contents;
  			 
  		     if(person.personId){
  		    	  newSR.affectedperson = person.personId;
  		     }else{
  		    	 newSR.affectedperson = person.personName;
  		     }
  	  		
  	  		 newSR.affectedphone = person.personPhone;
  	  		 newSR.affectedemail = person.personEmail;
  	  		 
  		 }
  		
  		if (this._submitInfo.Location && this._submitInfo.Location.contents) {
  			if(this._submitInfo.Location.contents.location){
  				newSR.location = this._submitInfo.Location.contents.location;
  			}
  			if(this._submitInfo.Location.contents.siteid){
  				newSR.assetsiteid = this._submitInfo.Location.contents.siteid;
  			}
  			if(this._submitInfo.Location.contents.orgid){
				newSR.assetorgid = this._submitInfo.Location.contents.orgid;
			}
  		}
  		if (this._submitInfo.Asset && this._submitInfo.Asset.contents) {
  			if(this._submitInfo.Asset.contents.assetnum){
  				newSR.assetnum = this._submitInfo.Asset.contents.assetnum;
  			}
  			if(this._submitInfo.Asset.contents.siteid){
  				newSR.assetsiteid = this._submitInfo.Asset.contents.siteid;
  			}
  			if(this._submitInfo.Asset.contents.orgid){
				newSR.assetorgid = this._submitInfo.Asset.contents.orgid;
			}
  		}
//  		// set siteid to default site - defect 306533- not set default site
//  		if ($M.getMaxauth() && $M.getMaxauth().whoami && $M.getMaxauth().whoami.defaultSite){
//  			newSR.siteid = $M.getMaxauth().whoami.defaultSite;
//  		}
  		
  		newSR.reportedpriority = 2;
  		if (e.detail) {
  			newSR.reportedpriority = e.detail;
  		}
  		
  		if (this._submitInfo.Issue && this._submitInfo.Issue.contents && this._submitInfo.Issue.contents.templateid) {
  			newSR.templateid = this._submitInfo.Issue.contents.templateid;
  		}
  		
  		var ticketspecs = [];
  		if (this._submitInfo.Issue && this._submitInfo.Issue.contents && this._submitInfo.Issue.contents.ticketspec) {
  		    if ( this._submitInfo.Issue.contents.ticketspec[0] !== null && newSR.classstructureid !== this._submitInfo.Issue.contents.ticketspec[0].classstructureid)
  		    	{
  		    		newSR.classstructureid = this._submitInfo.Issue.contents.ticketspec[0].classstructureid;
  		    	}
  		    	for (var i = 0; i < this._submitInfo.Issue.contents.ticketspec.length; i++) {
  				// build from tktemplatespec - matchange to ticketspec, then we can direct attach
  				var tktemplatespec = this._submitInfo.Issue.contents.ticketspec[i];
  	  			var ticketspec = {};
  	  			
  	  			ticketspec.classstructureid = tktemplatespec.classstructureid;
	  			ticketspec.assetattrid = tktemplatespec.assetattrid;
	  			if (tktemplatespec.alnvalue)
	  				ticketspec.alnvalue = tktemplatespec.alnvalue;
	  			if (tktemplatespec.numvalue !== undefined)
	  			{
	  				if(   typeof(tktemplatespec.numvalue)=="string" && tktemplatespec.numvalue.length > 0 )
	  				{
	  					ticketspec.numvalue = JSON.parse(tktemplatespec.numvalue);
	  				}
	  				else
	  					ticketspec.numvalue = tktemplatespec.numvalue;
	  			}
	  			if (tktemplatespec.orgid)
	  				ticketspec.orgid = tktemplatespec.orgid;
	  			if (tktemplatespec.siteid )
	  				ticketspec.siteid = tktemplatespec.siteid;
	  			
  	  			ticketspecs.push(ticketspec);
  			}
  			if (ticketspecs.length > 0) {
  	  			newSR.ticketspec = ticketspecs;
  			}
   		}
  		
  		var doclinks = [];
  		if (this._submitInfo.Attachment && this._submitInfo.Attachment.contents && this._submitInfo.Attachment.contents.files) {
  		
  			for (var i = 0; i < this._submitInfo.Attachment.contents.files.length; i++) {

  				var file = this._submitInfo.Attachment.contents.files[i];
  	  			var docLink = {};
  	  			docLink.urltype = this.FILE_DOMAIN;
  	  			docLink.doctype = 'Attachments';
  	  			docLink.document = file.description.substring(0, 20);
	  	  		docLink.urlname = file.description;
	  			docLink.description = file.description;

  	  			var idx = file.content.indexOf(',');
	  			
	  			if (idx === -1) {
	  				docLink.documentdata = file.content;
	  			}
	  			else {
	  				docLink.documentdata = file.content.substring(idx+1);
	  			}
	  			
	  			doclinks.push(docLink);
	  			
	  			
  			}
  			if (doclinks.length > 0) {
  	  			newSR.doclinks = doclinks;
  			}
   		}
  	 
  		this.$.csrcollection.createRecord(newSR, 'ticketid,description');
  		//this.$.csrcollection.saveNewRecord(newSR, 'ticketid,description');
  		
  	},
  	_handleNewRecordCreated: function(e) {
  		//console.log('create success : ' + e.detail.href);
  		this.newSrHref = e.detail.href;
  	},
  	_handleRecordCreated: function(e) {
  		trackAnalyticsCreatedObject('Service Request', 'Submit a service request');
	  	this.fire('sr-created', e.detail.ticketid);
  	},
  	_handleRecordCreationFailure: function(e) {
  		console.log('fail');
  		var reviewsrStep =   this.getComponent('reviewsrStep');
  		reviewsrStep.enableButtons();
  		this.fire('show-wait-spinner', false);
  		
  		
  		if (e.detail && e.detail.Error) {
			$M.alert(e.detail.Error.message);
		}
  	
  		
  	},
  	_handleNewRecordRemoved: function() {
  		console.log('removed');
  	},
  	_handleGetValueFromDomain: function(e) {
  		this.classValue = e.detail;
  	},
  	_handleGetValueFromDomainError: function(e) {
  		console.log(e);
  	},
  	
  	
  	/**
	 *  set      	FILE_DOMAIN 
	 *  set start step 
	 */
  	_configureDoctypeDomain : function(){
		var self = this;
		var doctypeDomainList = this.doctypeDomainSet[0].synonymdomain;
		if(doctypeDomainList.length>0){
			doctypeDomainList.forEach(function(domain){
				if(domain.maxvalue=='FILE'){
					self.FILE_DOMAIN= domain.value;
				}
				
			});
		}
	},
  	 
  	
  	
  	 /**  
     * 
     * return  component by id
     * 
     */
    getComponent: function(id, templateId){
    	var  component = $j(this).find('#'+id)[0];
    	if(component) {
    		return component;
    	}

    	if(templateId){
    		this.addContent(templateId);
	    }else{
	    	this.addContent(id);
		}
    	return  $j(this).find('#'+id)[0];
    },
    
    
    /**  
	 * locAssetStatusDomain success callback
	 */
    _locAssetStatusDomainSuccessHandler: function(event) {
		 
	},
	
    /**
     * woStatusDomain error callback
     */
	_locAssetStatusDomainErrorHandler: function(event) {
		    $M.toggleWait(false);
    },
    
    
    /**  
	 * AttribDomain success callback
	 */
    _handleaAttribDomainDataRefreshed : function(){
		 
		
	},
});
