/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2017,2018
 */
Polymer({

	is: 'maximo-inspection-item-card',

  	behaviors: [BaseComponent, DirtyBehavior],

  	listeners: {},

	properties : {
		/**
    	 * inspection result record
    	 */
		inspResult: {
			type : Object,
			value : null
		},
		
		isStacked: {
			type: Boolean,
			reflectToAttribute: true,
			computed: '_computeStackedState(inspResult)'
		}
	}, 

	attached: function(){ },
	
	/**
	 * Computed property isStacked
	 */
	_computeStackedState: function(inspResult) {
		return inspResult.referenceObject === 'PARENTWO';
	},
	
	/**
	 * Send user to inspection execution app
	 */
	_launchInspectionWC: function (e) {
	    e.stopPropagation();
	    
	    var location = window.location;
	    var hash = '#/inspector/detail';
	    var parameter = '?uid=' + this.inspResult.id;
	    
	    var url = location.origin;
	    var indexPos = location.pathname.indexOf('index.html');
	    if (indexPos >= 0) {
	        url += location.pathname.substring(0,indexPos);
	    } else {
	        url += location.pathname;
	    }
	    url += parameter;
	    url += hash;
	    
	    window.open(url,'execute_inspections');
	},
	
	/**
	 * Indicate where to show/not task field
	 */
	_hideTaskField: function(inspResult) {
		return isNaN(parseFloat(inspResult ? inspResult.task : null));
	}
});
