/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2017,2018
 */
Polymer({
	is: 'maximo-supervisor-details',
  	behaviors: [BaseComponent, AttachmentValidator, Workorder],
  	listeners: {
  		'carouselDelete': '_deleteFile',
  	    'refreshAttachments': '_refreshAttachments',
  		'hideViewMoreDisplay': '_hideViewMoreDisplay',
  		'maximo-tile-edit-apply': '_applyEdits',
  		'reloadAttachments' : '_reloadAttachments',
  		'lookupUser' : '_lookupUser',
  		'lookupOwnerGroup' : '_lookupOwnerGroup',
  		'closeDialog' : '_closeDialog',
  		'maximo-lookup-selected' : '_setValueFromLookup',
  		'maximo-typeahead-selected' : '_setValueFromLookup',
  		'approve':'_approve',
  		'close':'_close',
  		'showSelectOwner':'_showSelectOwner',
  		'save-long-desc' : '_saveLongDescription',
  		'cancel-long-desc' :'_cancelLongDescription',
  		'page-changed' : '_pageChanged',
  		'statusChanged' : '_statusChanged',
  		'tile-clicked':'_navigatePage',
  		'maximo-table-tile-delete-action' : '_deleteWOTableRecord',
  		'relatedrecord-wo-detail' : '_displayRelatedWODetail',
  		'tile-event-action' : '_displayFailurePage',
  		'wpdata-loaded' : '_wpDataLoaded',
  		'inner-app-saved' : '_recordChangedFromIframe',
  		'workorder-owner-changed' : '_notifyParentOwnerChanged',
  		'workorder-ownerGroup-changed' : '_notifyParentOwnerChanged',
  		'statusChanged' : '_notifyParent',
  		'tile-edit-mode' : '_setBackFaceValue',
  		'recordUpdated' : '_recordUpdated',
  		'show-confirm-ync': '_showYNC',
  		'maximo-tile-edit-cancel': '_handleTileEditCancel',
  		'cancelWorkorder':'_cancelWorkorder',
  		'_saveWorkorder':'saveWorkorder',
  		'maximo-lookup-addserviceaddress': '_showAddServiceAddressFlyout',
  		'maximo-serviceaddress-created': 'updateServiceAddress',
  		'chkToggleAction':'_chkToggleAction'
  	},
	properties : {
		_attachments: {
			type: Array,
			value: [],
			observer: '_loadAttachments',
			notify: true
		},
		_images: {
			type: Array,
			value: [],
			notify: true
		},
		
		/**
    	 * Flag for attachments data loaded
    	 */
		attchmentsLoaded: {
	            type: Object,
	            value: false
	    },

		/* Name of the current panel that includes the details */
		panelName: {
			type: String 
		},
		/** 
		 * prior page
		 */
		sourcePage: {
			type: String 
		},
		
		record: {
			type: Object,
			notify: true,
			observer: '_refreshRecord'
		},
		
		attributeList: {
			type: String,
			value: 'workorderid,origrecordid,wonum,worktype,description,description_longdescription,status,status_maxvalue, wopriority, estdur, actstart,actfinish,schedstart,schedfinish,statusdate,reportdate,targstartdate,targcompdate, assetnum,asset.description,asset._imagelibref,location,asset.isrunning, location.description,location.location,location._imagelibref,parent.wonum,parent.description, glaccount,siteid,onbehalfof._imagelibref,onbehalfof.displayname, uxlead._imagelibref,uxlead.displayname,ownerperson._imagelibref, ownerperson.displayname,uxsupervisor.displayname, uxsupervisor._imagelibref, workorderownergroup.description,site.description,rel.labtranstimerstatus{*},origrecordclass,origticket.description,origwo.description,failure.description,wo_worktype.wtypedesc,reportedby.displayname,reportedby._imagelibref,synonymdomain.description,reportedby.primarysms,reportedby.primaryemail,reportedby.primaryphone,onbehalfof.primarysms,onbehalfof.primaryemail,onbehalfof.primaryphone,uxlead.primarysms,uxlead.primaryemail,uxlead.primaryphone,ownerperson.primarysms,ownerperson.primaryemail,ownerperson.primaryphone,uxsupervisor.primarysms,uxsupervisor.primaryemail,uxsupervisor.primaryphone,relatedreckey,relatetype,jpnum,jobplan.description,pluscjprevnum,problemcode,problem.description,parent.status,failurecode,failure.description_longdescription,remarkdesc,remarkdesc_longdescription,worktype.promptfail--worktypeprompt,rel.moddowntimehist{*},classstructure.description_class,maxvar.labtrnallowanycrft,workorderownergroup.persongroup,workorderownergroup._imagelibref,istask,taskid,serviceaddress.saddresscode,serviceaddress.description,serviceaddress.formattedaddress,location.saddresscode,location.serviceaddress.addresscode,location.serviceaddress.formattedaddress,location.serviceaddress.description,inspformnum,inspectionformall.name--inspformname'
		},
		
		hideUploading: {
			type: Boolean,
			value: true,
			notify: true
		},
		
		/** 
		 * flag if there are comments
		 */
		hasComments: {
			type: Boolean,
			value: false
		},
		
		/**
    	 * Question progress object
    	 * read only
    	 */
    	progress: {
    		type: Object,
    		computed: 'computeQuestionProgress(originalDataListQuestions)'
    	},
    	/**
    	 * flag if total questions same as required total
    	 * read only
    	 */
    	allRequired: {
    		type: Boolean,
    		value: false,
    		computed: 'computeAllRequired(progress)'
    	},
		
		/**
	     * owner of the current registry 
	     */
		collection: {
			type: Object
		},
		
		/**
	     * Selected Tab 
	     */
		_currentTab: {
			type: String
		},
		
		/**
	     * property used to make the tiles read only
	     */		
		readOnly: {
			type: Boolean,
			value: false
		},
		/**
	     * property to display owner assign dialog box
	     */
		selectOwnerDialog: {
			type:  Object
		},
		/**
	     * property for longdescription flyout
	     */
		longdescriptionflyout: {
			type:  Object
		},
		/**
	     * property for action button
	     */
		actionName: {
			type: String
		},
		
		/**
         * Flag to show/hide Inspections tab based on grants
         */
        inspectionAccess: {
            type: Boolean,
            value: false
        },
        contextSubscriptions: {
			value: ['inner-app-saved']
		},
		/**
    	 * URI for Asset resource fetched from asset.mxapiasset object
    	 */
    	assetURI :{
    		type:Object
    	},
    	/**
    	 * Asset record data
    	 */
    	assetrecordData : {
    		type: Object    		
    	},
    	/**
         * Lightweight representation of the current record 
         */	
    	recordLight:{
    		type: Object,
    		observer:'_loadDetailedRecord'
    	},
    	/**
    	 * URI for resource location
    	 */
    	locationURI :{
    		type:Object
    	},
    	/**
    	 * Location record data
    	 */
    	locationRecordData : {
    		type: Object    		
    	},
    	/**
    	 * Preview workorder records
    	 */
    	previewWORecords : {
			type : Array,
			value : []
		},
		/**
		 * Check if the WO is new.
		 */
    	newWO : {
    		type: Boolean,
            value: false
    	},
    	/**
    	 *  Addtitional params for work order table used for filtering the records
    	 */
		additionalWOparams : {
   			type: Array,
   			value: [],
   			notify: true
   		},
   		/**
    	 * Property added in order to track user navigation after creation of workorder.
    	 */
   		backStack : {
			type : Array,
			value : []
		},
		/**
		 * Property added in order to trigger function to create the list of already related workorder numbers.
		 */
		workorderClause :{
			type : String,
			computed: '_getWorkorderClause(record,relatedwonums)'
    	},
    	/**
    	 * Propoerty added in order to maintain the lists of related workorder numbers.
    	 */
    	relatedwonums : {
			type : Array,
			value : []
		},
		
		/**
    	 * Flag for plan data loaded from Plans section
    	 */
		plandataloaded: {
	            type: Object,
	            value: false
	    },
	    
	    /**
    	 * Flag for existence plan data in details page
    	 */
	    plandataexists: {
            type: Object,
            value: false
	    },
	    
	    /**
    	 * Flag related to failure page
    	 */
		failureFlag :{
			type : Boolean,
			value : false
		},
		
		/**
    	 * Set action true if report time button is clicked.
    	 */
    	reportTimeAction : {
    		type: Boolean,
            value: false
    	}, 
		
		/**
    	 * Flag related to Asset meter section
    	 */
		assetFlag :{
			type : Boolean,
			value : false
		},
		/**
    	 * Flag related to Location meter section
    	 */
    	locationFlag :{
			type : Boolean,
			value : false
		},
		datalabel:{
			type : String,
			value : ''
		},
		
		/**
		 * Enable/Disable visibility for Actions
		 */
		woButtonActionsVisibility: {
			type: Boolean,
    		value: false,
    		notify: true					
		},		
		
		dataLoaded : {
			type : Boolean,
			value : false
		},
		/** 
		 * temp record for new work-order.
		 */
		cachedRecord: {
			type: Object,
			value:{}
		},
		/**
		 * Flag for create workorder page
		 */
		createWO :{
			type : Boolean,
			value : false
		},
		/**
		 * Flag for temp record clean
		 */
		tempRecordClean :{
			type : Boolean,
			value : false
		},
		/**
	     * To get customized href for job plan lookup
	     */
		customJobPlanHref :{
			type : String,
			computed:'_getCustomizedJobPlanHref(record)'
		},
		/**
	     * To get customized href for all tile in new work order scenario
	     */
		newWOCustomLookupHref :{
			type : String,
			computed:'_getCustomizedLookupHref(record)'
		},
		/**
	     * Set up clause for new work order scenario
	     */
		newWOSetupClause :{
			type : String,
			computed:'_getCustomizedCommonClause(record)'
		},
		/**
	     * Set up clause for parent new work order scenario
	     */
		newWOSetupClauseParent :{
			type : String,
			computed:'_getCustomizedParentClause(record)'
		},
		
		failTypeDomain : {
			type : Array
		},
		
		sectionName: {
			type: String,
			value: ''
		},
		
		/**
		 * URI for service address lookup
		 */
		serviceAddressURI: {
			type : String,
			value : ''
		},
		
		/**
		 * Record mapping for service address lookup 
		 */
		serviceAddressRecordMapping: {
			type : String,
			value : 'record.serviceaddress.formattedaddress:formattedaddress,record.serviceaddress.saddresscode:addresscode,record.serviceaddress.description:description'
		},
		
		toggleFilter: {
			type: Boolean,
			value: false
		},
		/**
		 * URI for insepction lookup
		 */
		inspectionURI: {
			type : String,
			value : ''
		}
	},
	
	 /**
	  * method for action button under bottom footer on attached event
	  */
	  attached: function(e){
		var that= this;
		
		if($j('[data-scope-id="nolabelstr"]').length && $j('[data-scope-id="frontLabel"]').length){
			$j('[data-scope-id="nolabelstr"], [data-scope-id="frontLabel"]').css('padding-top', '4px');
		}
		
		$j(this.$.wobtn).hide();
		$j(window).on('resize', function(){
			if(!$M.isMobile()){
			   that._updateFooterActionButton();
			}
			that._fixHeader();
        });
		this.async(function(){
			this._fixHeader();			
		},50);
		this.checkInspectionAccess();
		// fetch required details from session Cache
		var cacheData=JSON.parse(sessionStorage.getItem('WORecordLight'));
		if (!this.recordLight && cacheData){
			this.recordLight = cacheData;
			this.sourcePage = sessionStorage.getItem('WOSourcePage');
			this.collection = $M.getGlobalResource(sessionStorage.getItem('WOCollectionId'));
			this.collection.queryWhere=JSON.parse(sessionStorage.getItem('WOCollectionQueryWhere'));
			var self=this;
			this.collection.refreshRecords().then(function(records){
				self.$.navigationCollection.record=self.recordLight;
				self.$.navigationCollection.collection=self.collection;
				self.$.navigationCollection._updateRecord();
			});
			
		}
		
		this.previewWORecords = [{
			'attribute' : 'relatedreckey',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'WO'),
			'sortable' : true,
			'hyperlink' : true,
			'listener' : 'relatedrecord-wo-detail',
			'flexGrow': '1'
		}, {
			'attribute' : 'relatedrecwo.description',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'Description'),
			'flexGrow': '3'
		}, {
			'attribute' : 'relatetype_description',
			'sortattribute' : 'relatetype',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'relationship'),
			'sortable' : true,
			'flexGrow': '2',
		}];
		
		this.assetMeterRecords = [{
			'attribute' : 'metername',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'ID'),
			'flexGrow': '2'
		}, {
			'attribute' : 'meter.description',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'Description'),
			'flexGrow': '3'
		}, {
			'attribute' : 'readingmeasure',
			'title' : $M.localize('uitext', 'mxapimeter', 'lastreading'),
			'sortattribute' : 'previousreading',
			'sorttype':'descending',
			'flexGrow': '2'
		}];
		
		this.locationMeterRecords = [{
			'attribute' : 'metername',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'ID'),
			'flexGrow': '2'
		}, {
			'attribute' : 'meter.description',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'Description'),
			'flexGrow': '3'
		}, {
			'attribute' : 'readingmeasure',
			'sortattribute' : 'lastreading',
			'title' : $M.localize('uitext', 'mxapimeter', 'lastreading'),
			'sorttype':'descending',
			'flexGrow': '2'
		}];
		
		this.async(function(){
			this._generateUniqueIdForTableTile();
		}, 100);
		$j('.locationtile,.onbehalf-tile').find('h3>div').addClass('titleContainer');
		$j('maximo-tile').find('.maximo-tile.titleContainer').attr('style', 'display: block!important');
		$j('.largelabel').find('.mainLabeldiv > label').css('font-size','129%');
		$j(this.$.sitedesc).find('.front.face').css('display','grid');
		$j('.inspTile .ellipsis.largetext').attr('style', 'white-space:nowrap;');
		$j(this.$.responsesection).find('maximo-image-tile').each(function(i, el){
			el._initializeForEdit = null;
		});
	 },
	 
    /**
     * Hide/show inspection module
     */
    checkInspectionAccess: function() {
        var workCenter = 'inspector';
        this.inspectionAccess = $M.hasAccessToWorkscape(workCenter);
    },
    
	 _fixHeader: function(){
		var adjust = 55;
		if($M.screenInfo.device === 'tablet' ||$M.screenInfo.device === 'phone'){
			adjust = 0;
		}
		$j(this.$.mainPage).css({'width':'calc(100vw - '+adjust+'px)'});
		$j(this.$.section_comments).css({'width':'calc(100vw - '+adjust+'px)'});
	 },
    /**
     * Check whether data param is undefined or zero length
     * to show and hide view more option for description
     */
     _isnodata: function(data){
            return (data != undefined && data.length > 0 ? false : true);
     },
     
 	/**
 	 * Computed function for all required flag
 	 * Compute
 	 */
 	computeAllRequired: function (progress) {
 		
 		var allRequired = false;
 		if (progress.reqtotal === progress.total ) {
 			allRequired = true;
 		}
 		
 		return allRequired;
 	},
 	/**
 	 * Count total questions
 	 */
 	countQuestions: function (questions) {
 		
 		var totalQuestions = 0;

 		for (var i = 0; i < questions.length; i++) {
 			var q = questions[i];
 			
 			if (q.children) {
 				totalQuestions += this.countQuestions(q.children);
 			} else {
 				totalQuestions++;
 			}
 			
 		}
 		return totalQuestions;
 	},
 	
 	/**
 	 * Count required questions
 	 */
 	countRequiredQuestions: function(questions) {

 		var totalReqQuestions = 0;
 		outerl:
 		for (var i = 0; i < questions.length; i++) {
 			var q = questions[i];
 			
 			if (q.children) {
 				totalReqQuestions += this.countRequiredQuestions(q.children);
 			} else if (q._required && q._required === true) {
 				totalReqQuestions++;
 			}
 			
 		}
 		return totalReqQuestions;
 		
 	},
 	
 	_addBtnClicked: function() {
 		$j(this.$.fileInput).trigger('click');
 	},
     
 	/**
 	 * Handle the hide view more option to display once the detail page is loaded.
 	 */
 	_hideViewMoreDisplay: function(e){
 		this.$.description._hideViewMoreDisplay();
 	},

 	/**
 	 * Handle Back arrow button based on component name
 	 */ 
 	_goBack: function(e){
	   	 if(this.recordLight && !this.backStack.length && this.recordLight.origrecordclass === 'SR' && this.recordLight.origrecordid !== undefined){
	   	     $M.workScape.updateFooterToolbar(null, this);
	   		 this.fire('showCreate',{'record':this.recordLight});
	   		 this.fire('exit-detail-page',{'sourcePage':this.sourcePage , 'collection' : this.collection });
	   	 } else if(this.backStack.length > 0) {
	   		 this.recordLight = this.backStack.pop();
 		 }else if (this.failureFlag){
 			this.fire('wo-detail', {'record': this.recordLight,  'collection':this.collection, 'sourcePage':this.sourcePage});
 			this.failureFlag = false;
		 }else if(this.sourcePage === 'reportTime'){
   			this.$.supervisorreportedwork.showReportedTimeCard = false;
	    	this.reportTimeAction = false;	
	    	this.fire('exit-detail-page',{'sourcePage':this.sourcePage , 'collection' : this.collection });
		 } else {
			 if(this.sourcePage === 'create' && !this.tempRecordClean){
				 this._showYNC();
			 }else{
				 if(this.sourcePage === 'create' && this.lastSourcePage==='supervisorFullScreenPanel'){
					 this.sourcePage = 'expandwocard';
				 }
				 if(this.$.wopriority){
					 this.$.wopriority.emptyRecord = false;
				 }
				 this.fire('workscape-design-views',{'hasDesignMode':true});
	 			 this.fire('exit-detail-page',{'sourcePage':this.sourcePage , 'collection' : this.collection });
	 			 $M.workScape.updateFooterToolbar(null, this);
			 }
 		 }
	   	 
 		 // remove attribute from cache which no longer required.
	   	sessionStorage.removeItem("WORecordLight");
	   	sessionStorage.removeItem("WOSourcePage");
	   	sessionStorage.removeItem("WOCollectionId");
	   	sessionStorage.removeItem("WOCollectionQueryWhere");
		this.$.statusTile._flipTile(false);
		this._cancelTileEdit(e,this.$.durationMT);
	 },
	 /**
	     * Cancel maximo-tile edit
	     */	
		_cancelTileEdit: function(e, tile){
			if(tile.childTile && tile.childTile._editMode){
				tile._cancelEdit(e);
			}
		},
  	
 	_pageChanged: function(e){
 		e.stopPropagation();
 		if(window.performance && performance.navigation.type == 1) {
 	 		if($M.getSubRoute() !== e.detail){
 	 			$M.setSubRoute(e.detail);
 	 		}
 		}
 		this._updateFooterActionButton();
 	},
 	 
  	
	
	
	/**
	 * switch  panels
	 * 
	 */
	switchContent: function(event) {
		
		var curIdArray = event.currentTarget.id.split('_');
		var sectionId = 'section_' + curIdArray[curIdArray.length-1];
		/** Enable to load footer toolbar
		if(sectionId === 'section_details'){
			this.dataHost._loadButtons('details');
		} else {
			this.dataHost._loadButtons();
		}
		**/
		if(sectionId == 'section_comments'){
			this.woButtonActionsVisibility = true;
		} else {
			this.woButtonActionsVisibility = false;
		};
		
		if((this.record.status_maxvalue !== 'WAPPR' && ((this.record && this.record.ownerperson && this.record.ownerperson.displayname) || (this.record.workorderownergroup && this.record.workorderownergroup.description))) ||     
                (this.record.status_maxvalue === 'INPRG' && (this.record.ownerperson.displayname || this.record.workorderownergroup.description)) || 
                (this.record.status_maxvalue === 'COMP') || 
                (this.record.status_maxvalue === 'WMATL' && (this.record.ownerperson.displayname || this.record.workorderownergroup.description))|| 
                (this.record.status_maxvalue === 'WSCH' && (this.record.ownerperson.displayname || this.record.workorderownergroup.description)) || 
                (this.record.status_maxvalue === 'WPCOND' && (this.record.ownerperson.displayname || this.record.workorderownergroup.description))){
            this.reportTimeAction = true;
		}else{
			this.reportTimeAction = false;
		}
		var self=this;
			self._showSubTab(sectionId);
		},
	
	/**
	 * switch  panels
	 * set the color of the current tab's parent to the color of the tab.  This ensures the entire page is same color
	 * 
	 */
	_showSubTab:function( sectionId ){
		var currentTab = this._showHideSection(sectionId);
		var tabColor = currentTab.style.backgroundColor;
		$j(this).parent().css({'background': tabColor});
		this._currentTab = sectionId;
        $j(".commentsflex").css({'margin-right':'50px'});
	},
	
	
	/**
	 * hide/show  Sections
	 * 
	 */
	_showHideSection: function(sectionName) {
		this.sectionName = sectionName;
        this.addContent(sectionName);
		var currentSection;
		$M.publishEvent('page-changed', 'details');
		$j(this.$.maincontainer).children('div').each(function(index, elem) {
			if (elem.id.indexOf(sectionName) > -1) {
				currentSection = this;
			}
			$j(this).hide();
		});

		
		var backgroundMode = false;
		if(!this.$.supervisorComments){
			this.$.supervisorComments  = $j(this.$.section_comments).find('maximo-worklog')[0];
		}
		if(sectionName==='section_comments' && this.$.supervisorComments){
			this.$.supervisorComments._loadComments(backgroundMode);
			// hide the footer toolbar when on comments tab
			$M.workScape.updateFooterToolbar(null, this);
			$M.workScape.backTopHide = true;
			$M.workScape.toggleBackTopButton();
		}else{
			//Show footer toolbar on other tabs except comments tab
			this._updateFooterActionButton();
			$M.workScape.backTopHide = false;
		}
		
		if(sectionName==='section_plans'){
			var supervisorPlans  = $j(this.$.section_plans).find('maximo-supervisor-plans')[0];
			supervisorPlans.isFirstLoad = true;
			supervisorPlans.loadPlanData(backgroundMode);
			 $j('.field-width').find('input').css('max-width','165px');
		}

		if(sectionName==='section_reportedwork'){
			var supervisorreportedwork  = $j(this.$.section_reportedwork).find('maximo-supervisor-reportedwork')[0];
			supervisorreportedwork.isFirstLoad = true;
			supervisorreportedwork.loadReportedWorkData(backgroundMode, this.labtrnallowanycrft);
			if(this.record.status_maxvalue !== 'CLOSE'){
			supervisorreportedwork.$.reportedworkSelector.select(0);
			$j(supervisorreportedwork.$.section_failures).hide();
			$j(supervisorreportedwork.$.section_times).show();
			if(this.reportTimeAction){
            	supervisorreportedwork.showReportedTimeCard = true;
			}else{
				supervisorreportedwork.showReportedTimeCard = false;
		}
		}
		}
		
		if(sectionName==='section_inspections'){
			var supervisorInspections  = $j(this.$.section_inspections).find('maximo-supervisor-inspections')[0];
			supervisorInspections.loadInspections();
        }

		if(sectionName==='section_assignments'){
			var supervisorAssignments  = $j(this.$.section_assignments).find('maximo-supervisor-assignments')[0];
			supervisorAssignments.loadPlanData(backgroundMode);
        }
		
		if(sectionName==='section_attachments' && !this.attchmentsLoaded){
			 this._hideAddattachmentAndDeleteButton(this.record);
			 this._loadWOAttachments(this.record);
        }
		
		if(currentSection){
			$j(currentSection).show();
		}
		return currentSection;
	},
	
	/**
	 * Load the attachments to the details, using the temp array helps polymer knows the set underlying array changed
	 */
	_loadAttachments: function(){
		//Check isAborted property before invoking _abortUpload() since this function invokes when user upload, delete or cancel attachment.
		var self = this;
		this.async(function(){
			if(self.isAborted === true){
				self._abortUpload();
			}
		},300);
		this._buildImagesArray(this._attachments);
	},
	
	/**
	 * Load the attachments for this work order, and then do the actual transition
	 */
	_loadWOAttachments: function(record){
		var recordHref = record.href;
		if(record.istask){
			var self = this;
			var parentTaskId = record.taskid;
			this.getDoclinksWoactivityURL(record).then(function(record){
				var tempArray;
				if(record.response && record.response.member && record.response.member.length>0 && record.response.member[0].woactivity){
					tempArray = record.response.member[0].woactivity.filter(function(rec) {
						if(parentTaskId === rec.taskid){
							return rec.localref;
						}
					});
				}
				
				recordHref = (tempArray)?tempArray[0].localref:recordHref;
				self.refreshAttachmentCollection(recordHref);	
			});
		}else{
			this.refreshAttachmentCollection(recordHref);
		}
	},
	
	/**
	 * Refresh that attachment collection locally so the new images displayed will be correct.
	 */
	_refreshAttachments: function(){
		var self = this;
		this.$.attachmentsCollection.refreshRecords().then(function(records){
			self._attachments = records.response.doclinks.member;
			this.attchmentsLoaded = true;
		});
	},

	/**
	 * Listen response from dialog
	 */
	_deleteFile : function(e) {
		this.$.attachmentResource.deleteAttachment(e.detail[1]);
		this.$.section_attachments.querySelector('maximo-file-carousel').enableButtons();
	},
	
	/**
	 * After the file was deleted we need to remove it from the local array of files and refresh the array so the ui will pick up the change.
	 */
	_handleAttachmentDeleted : function(jsonResponse){
		var delUrl = jsonResponse.detail.url;
		var members = this._attachments;
		
		for(var i=0; i< members.length; i++){
			if(members[i].href === delUrl){
				this._attachments.splice(i, 1);
				this._loadAttachments();
				break;
			}
		}		
	},

	/**
	 * After we attempted to delete the file and it has failed.
	 */
	_handleAttachmentDeleteError : function(jsonResponse) {
		var errorMessage = jsonResponse.detail.request.xhr.response.Error.message;
		$M.alert(errorMessage, $M.alerts.error);
	},

	_formatTime: function (seconds) {
	    var date = new Date(seconds * 1000),
	        days = Math.floor(seconds / 86400);
	    days = days ? days + 'd ' : '';
	    return days +
	        ('0' + date.getUTCHours()).slice(-2) + 'h:' +
	        ('0' + date.getUTCMinutes()).slice(-2) + 'm:' +
	        ('0' + date.getUTCSeconds()).slice(-2) + 's';
	},
		
	_getDirection : function(wl){
		if(wl.createby === $M.userInfo.personid){
			return false;
		} else if (this.record && (wl.createby === this.record.reportedby)) {
			return false;
		} else if (this.record && (wl.createby === this.record.affectedperson)) {
			return false;
		}
		else {
			return true;
		}
	},
	_getDescription: function(wl) {
		if (wl.description_longdescription && wl.description_longdescription.length !== 0) {
			return wl.description_longdescription;
		} else if (wl.description && wl.description.length !== 0) {
			return wl.description;
		}
		return '';
	},
	_getMessageWidth : function(){
		return '500px';// (parseInt(this.querySelector('.commentPanel').offsetWidth) - 112) + 'px'; 
	},
	resetContentSelectorDefault : function(){
		this.$.contentSelector.select(0);
	},

	/** 
	 * apply any edits made to the record 
	 */
	_applyEdits: function(e){
		if(this.createWO){
			this._setCachedValue(e);
			return;
		}
		switch(e.detail.dataset.scopeId){
			case 'statusTile':
				this.changeWOStatus(e.target, this.collection);
				break;
			case 'assetimg':
				this._updateWO({'assetnum': e.target.value}, this.collection, true, e.target,true);
				break;
			case 'locationimg':
				var self = this;
				this._updateWO({'location': e.target.value}, this.collection, true, e.target,true).then(function(result){
		          	if(result && result.response && result.response.location && result.response.location.saddresscode){
						//Update WO's service address with location
		          		var fakeEvent = {detail:{serviceaddress:result.response.location.serviceaddress}}
		          		self.updateServiceAddress(fakeEvent);		          		
		          	}
		     	 });
				break;
			case 'reportbyimg':
				this._updateWO({'reportedby': this.record.reportedby.personid}, this.collection);
				break;
			case 'onbehalfof':
				this._updateWO({'onbehalfof': this.record.onbehalfof.personid}, this.collection);
				break;
			case 'superimg':
				var uxsupervisor = (e.target.value === this.record.uxsupervisor.displayname) ? this.record.uxsupervisor.personid : e.target.value;
				this._updateWO({'supervisor': uxsupervisor}, this.collection,false,e.target,true);
                break;
			case 'ownerimg':
				var ownerperson = (e.target.value === this.record.ownerperson.displayname) ? this.record.ownerperson.personid : e.target.value;
				this._updateWO({'owner': ownerperson,'ownergroup': ''}, this.collection,false,this.$.ownerimg,true);
				this.$.ownergrp.value=null;
			    break;
            case 'ownergrp':
            	if(this.$.ownergrp && this.$.ownergrp.value === ''){
                    this.record.workorderownergroup.persongroup = '';
                }
            	var workorderownergroup = (e.target.value === this.record.workorderownergroup.description) ? this.record.workorderownergroup.persongroup : e.target.value;
            	this._updateWO({'ownergroup': workorderownergroup,'owner': ''}, this.collection,false,this.$.ownergrp,true);
            	this.$.ownerimg.value=null;
            	break;
            case 'leadimg':
            	var uxlead = (e.target.value === this.record.uxlead.displayname) ? this.record.uxlead.personid : e.target.value;
                this._updateWO({'lead': uxlead}, this.collection,false,e.target,true);
                break;
            case 'reportdate':
                var reportdate=e.target.value;
                this._updateWO({'reportdate':reportdate }, this.collection);
                break;
            case 'schedstart':
            	var schedstart=e.target.value;
                var schedstartdata={'schedstart':schedstart};
                this._updateWODates(new Date(this.$.schedfinish.value),schedstart,schedstartdata,'schedstart',e.target,true);
                break; 
            case 'schedfinish':
                var schedfinish=e.target.value;
                var schedfinishdata={'schedfinish':schedfinish};
               	this._updateWODates(schedfinish,new Date(this.$.schedstart.value),schedfinishdata,'schedfinish',e.target,true);
                break;
            case 'actstart':
            	var actstart=e.target.value;
                var actualstartdata={'actstart':actstart};
                this._updateWODates(new Date(this.$.actfinish.value),actstart,actualstartdata,'actstart',this.$.actstart,true);
                break; 
            case 'actfinish':
                var actfinish=e.target.value;
                var actualfinishdata={'actfinish':actfinish};
               	this._updateWODates(actfinish,new Date(this.$.actstart.value),actualfinishdata,'actfinish',this.$.actfinish,true);
                break;
            case 'targstartdate':
                var targstartdate=e.target.value;
                var targetstartdata={'targstartdate':targstartdate};
                	this._updateWODates(new Date(this.$.targcompdate.value),targstartdate,targetstartdata,'targstartdate',e.target,true);
                break;
            case 'targcompdate':
                var targcompdate=e.target.value;
                var targcompdatedata={'targcompdate':targcompdate};
                this._updateWODates(targcompdate,new Date(this.$.targstartdate.value),targcompdatedata,'targcompdate',e.target,true);
                break;  
            case 'worktype':
            	var dataToUpdate = {'worktype': e.target.value};
				this._updateWO(dataToUpdate, this.collection);
                break; 
            case 'parentwo':
            	var dataToUpdate = {'parent': e.target.value};
				this._updateWO(dataToUpdate, this.collection, false, e.target,true);
                break;
            case 'wopriority':
            	var dataToUpdate = {'wopriority': e.target.value};
				this._updateWO(dataToUpdate, this.collection);
                break;
            case 'durationTile':
                this._updateWO({'estdur': e.target.value}, this.collection);
                break;
            case 'workfailure':
            	var failurecode = (e.target.value === this.record.failure.description) ? this.record.failure.failurecode : e.target.value;
	            this._updateWO({'failurecode': failurecode}, this.collection,false,e.target,true);
	            break;
            case 'jobplan':
            	var dataToUpdate = {'jpnum': e.target.value};
            	this._updateWO(dataToUpdate, this.collection, true, e.target);
				break;
			case 'workproblem':
				if(this.$.workproblem.value === ''){
					this.record.problemcode = this.$.workproblem.value;
				}
				var problemcode = (e.target.value === this.record.problem.description) ? this.record.problemcode : e.target.value;
	            this._updateWO({'problemcode': problemcode}, this.collection,false,e.target,true);
	            break;
			case 'inspTile':
				this._updateWO({'inspformnum': e.target.value}, this.collection, true, e.target,true);
				break;
			case 'slider_tile':  
				this._changeAssetStatus(e);
				break;
			case 'serviceAddress':
				if(e.detail.value=== ''){
                    this.record.serviceaddress.saddresscode = ''; //remove service address
                }
            	this._updateWO({'saddresscode':this.record.serviceaddress.saddresscode}, this.collection,undefined,undefined,true,'serviceaddress');
            	break;
		}
	},

	/**
	 * To reset to comment tab when clicked from Monitor Panel.
	 */
	resetContentSelectorComment : function(){
		this.$.contentSelector.select(4);
	},
	
	/**
	 * reload the attachments for this work order
	 */
	_reloadAttachments:function(event){
		this._loadWOAttachments(event.detail.record);
		this._hideAddattachmentAndDeleteButton(event.detail.record);
	},
	
	/**
	 * Show panel specific supervisor details page
	 */
	_showOnPanel: function(panel,cardtype) {
		if(cardtype == panel){
			return true;
		}
		return false;
	},
	/**
	 * Show action specific supervisor details page action button
	 */
	_showOnAction: function(actionName,cardtype) {
		if(!actionName){
            return false;
        }
		if(!this.createWO){
			if(cardtype === 'ASSIGNED' &&  actionName === 'ASSIGNED' && (this.currentButton === 'details_ownergrp_backtext' || this.currentButton === 'details_ownerimg_backtext')){
	            return false;
			}
			else if(cardtype == actionName ||  actionName == undefined ){
				return true;
			}
		}
		return false;
	},

	/**
	 * Update the description for work order
	 */
	_updateDescription : function(e){		
		var description=e.target.value;
		if (!description && this.record.description===description){
			return;
		}
		if(description.length > 0){
			var self=this;
			if(this.createWO){
				this.cachedRecord['description'] = description;
			}else{
				setTimeout(function() {
					self._updateWO({'description':description}, self.collection);
					}, 100); 
			}

		}else{
			this.$.textdescription.value=this.record.description;
		}
	},
	/**
	 * Check for readonly flag for description 
	 */
	_getReadonlyFlag : function(status){
		var self =this;
		if(status==='CLOSE' || status==='CAN'){
			return true;
		}else {
			var showChangeSatus = this.isAuthorized('MXAPIWODETAIL:STATUS');
			if(!showChangeSatus){
				console.log('access denied for WO Change Status');	
			}
			$j(this.$.section_details).find('maximo-badge-tile').each(function(currenttile){ 
				if(this.id==='details_statusTile' && showChangeSatus && !self.createWO){
					this.setAttribute('editable','true');
				}else if(this.id==='details_statusTile' && self.createWO){
					this.removeAttribute('editable');
				}
			});
		}
	},	
	/**
	 * Suppress flyout without updating the data when the cancel button is clicked 
	 */
	_cancelLongDescription : function(e){
		this.LongDescRTE = null;
	},
	/**
	 * Suppress flyout after updating the user entered data when the save  button is clicked 
	 */
	_saveLongDescription : function(e){
		var getRTEContent = ($M.isMobile()) ? $j(tinyMCE.activeEditor.getBody())[0].innerHTML : this.LongDescRTE.value;
		if(this.createWO){
			this.cachedRecord['description_longdescription'] = getRTEContent;
			this.record['description_longdescription'] = getRTEContent;
		}else{
			this._updateWO({'description_longdescription':getRTEContent}, this.collection);
		}
		this._cancelLongDescription();
	},
	/**
	 * Get Long Description for the work order and set iframe width
	 */
	_getLongDescription : function(longDesc){				
		if(longDesc != undefined && longDesc.length > 0 ){
			return longDesc;
		} else{				
			return $M.localize('uitext', 'mxapiwodetail','LongDescription');		
		}	
	},
	
	/**
	 * To refresh the panel name on change of status.
	 */
   	_refreshRecord : function(){
   		
   		if(this.record == undefined || this.record.workorderid == undefined){
   			return;
   		}
   		
   		if(this.panelName !== undefined){
   			if(this.record.status_maxvalue === 'CLOSE' || this.record.status_maxvalue ==='CAN'){
   				$j('.relatedRecordsWOTile').find('.actions button').hide();
   				$j('.workfailureTile').find('.actionLabel, .iron-icon').css({'color':this.getComputedStyleValue('--Primary-gray50'),'fill':this.getComputedStyleValue('--Primary-gray50')}); 
   			}
   			  
   			if(this.record.status_maxvalue === 'CLOSE'){
   	   			this.actionName = 'COMP';
   	   		}else if(this.record.status_maxvalue === 'COMP'){
   	   			this.actionName = 'CLOSE';
   	   		}else if(this.actionName === 'OWNER' && this.panelName !== 'MONITOR' && this.record.status_maxvalue === 'APPR' && (this.record.workorderownergroup.persongroup !== undefined || !this._isEmpty(this.record.ownerperson))){
   	   			this.actionName = 'ASSIGNED';
   	   		}else if(this.actionName === 'APPROVE' && this.panelName !== 'MONITOR' && this.record.status_maxvalue === 'APPR' && (this.record.workorderownergroup.persongroup !== undefined || !this._isEmpty(this.record.ownerperson))){
   	   			this.actionName = 'APPROVED';
   	   		}else if(this.record.status_maxvalue !== 'WAPPR' && this.record.workorderownergroup && !this.record.workorderownergroup.persongroup && this._isEmpty(this.record.ownerperson)){
   	   			this.actionName = 'OWNER';
   	   		}else if(this.record.status_maxvalue !== 'WAPPR' && ((this.record.workorderownergroup && this.record.workorderownergroup.persongroup) || !this._isEmpty(this.record.ownerperson))){
   	   			this.actionName = 'MONITOR';
   	   		}else if(this.record.status_maxvalue === 'WAPPR'){
   	   			this.actionName = 'APPROVE';
   	   		}else{
   	   			this.actionName = this.panelName;
   	   		}
   		}else{
   			this.actionName = 'HISTORY';
   		}
   		   		
   		//Set action name when new WO has created
   		if(this.newWO && this.record && this.record.status_maxvalue === 'WAPPR'){
   			this.actionName = this.panelName;
   		}
   		if(this.createWO){
   			this.actionName ='';
   		}
   		if(this.domHost && ((this.domHost.subrouteData  && this.domHost.subrouteData.route==='woFlow') || this.domHost.woDetailsFlag)){
   			this._updateFooterActionButton();
    	}
   		this._hideAddattachmentAndDeleteButton(this.record);
   		
   		//Set URI for service address lookup 
		this.serviceAddressURI =  this.record.href+'/serviceaddress/zombie';
		//Set URI for insepction lookup
		this.inspectionURI = 'oslc.where=orgid=%22'+ $M.userInfo.defaultOrg + '%22';
   	},
   	
   	
   	refreshTiles: function(){
   		var self=this;
   		self.checkInspectionAccess();
   		$j(this).find('maximo-tile').each(function(){
   			if((this.id!=='details_statusMT' && self.sourcePage==='create') || (self.sourcePage!=='create')){
   				this.cancelEditMode();
   			}
		});
   		  		
   		if(this.recordLight){
   		   $j(this.$.assetDowntimeTile).toggleClass('hideTile',  this._isValueBlank(this.recordLight.assetnum) );
 				
        }
   		
   		this.showActualTile(true);
	 },
   	
	 showActualTile: function(recordRefreshed) {
		    var wostatus = '';
		    var ownerAvailable = false;

		    if (this.record) {
		        wostatus = this.record.status_maxvalue;
		        if (this.record.ownerperson.displayname || this.record.workorderownergroup.description) {
		            ownerAvailable = true;
		        }
		    }

		    if (!recordRefreshed && this.recordLight && this.recordLight.status_maxvalue) {
		        wostatus = this.recordLight.status_maxvalue;
		    }

		    var statuses = ['HISTEDIT', 'CLOSE', 'COMP', 'CAN', 'WAPPR'];

		    if (wostatus === 'WAPPR' || ((wostatus === 'APPR' || wostatus === 'WMATL' || wostatus === 'INPRG' || wostatus === 'WSCH') && !ownerAvailable)) {
		        $j(this.$.actualTile).toggleClass('hideTile', true);
		    } else {
		        $j(this.$.actualTile).toggleClass('hideTile', false);
		    }

		    $j(this.$.actfinish).toggleClass('hideTile', ((wostatus === 'APPR' || wostatus === 'WMATL' || wostatus === 'INPRG' || wostatus === 'WSCH') && ownerAvailable));

		    if (!statuses.includes(wostatus) && ownerAvailable) {
		        this.$.actualTile.width = 1;
		    } else {
		        var width = this.$.actualTile.getAttribute('width');
		        if (width) {
		            this.$.actualTile.width = parseInt(width);
		        }
		    }
		},
	 
   	/**
	 * To check empty object
	 */
   	_isEmpty(obj) {
   		if(obj !== undefined){
   	   		for(var key in obj) { 
   	   			if(obj. hasOwnProperty(key)) 
   	   				return false; 
   	   		} 
   		}
   		return true;
   		
   	},
	
   	/**
	 * To show the assign owner dialog box
	 */
	showSelectOwner: function(event){
		//Set undefined value to empty string
		this.currentButton = event.target.id;
		var worktype = (this.record.worktype) ? this.record.worktype : '';
		selectOwnerDialog = $M.showDialog( this, 'select owner', $M.localize('uitext', 'mxapiwodetail','Assign')+' '+worktype+' '+this.record.wonum, 'maximo-supervisor-select-owner', false, this, {record:this.record});
		this.async(function(){
			$j(this).find('#underlay').css({'position':'fixed', 'top':'0px'}); 
		}, 100);
	},

	/**
	 * To enable the lookup for owner
	 */
	_lookupUser : function(){
		$M.showLookup('owner-custom', this,'SELECTOWNER', this.record.href, null, null);
	},

	/**
	 * To enable the lookup for owner group
	 */ 
	_lookupOwnerGroup : function(){
		$M.showLookup('ownergroup', this,'SELECTOWNERGROUP', this.record.href, null, null);
	},

	/**
	 * To close the owner assign dialog box
	 */
	_closeDialog: function(){
		selectOwnerDialog.cancel();
	},
	
	/**
	 * Handler for work order selection for relatedRecordsWOTable.
	 * Implementation for auto save except for status tile.
	 */
    _setValueFromLookup: function(e){
    	
		//Update record for selected work order from work orders table tile lookup
    	this.currentButton = e.target.id;
    	if(e.target.dataset.scopeId === 'relatedRecordsWOTable' ) {
            this.$.woresource.resourceUri = this.record.href;
            this._addRelatedWORecord(e);
        }else{
        	this.setValueFromLookup(e);
        	if(e.target.domHost && e.target.domHost.tagName.toUpperCase()==='MAXIMO-SLIDER-TILE'){
        		if(e.detail.records && e.detail.records.length>0){
        			this.datalabel = e.detail.records[0].value;
        			e.target.value=e.detail.records[0].description;
        		}
        	}
        	//Bypass auto-save for status, Job Plan, Slider Tile & Insp Tile
            if(e.target.id && (e.target.id.indexOf('statusTile')>-1 || e.target.id.indexOf('jobplan')>-1 || e.target.id.indexOf('slider_tile')>-1 || e.target.id.indexOf('inspTile')>-1) ) {
                 return; 
            }
            if(e.target.id && e.target.id.includes('serviceAddress')){
            	e.target.value = this.getServiceAddress(this.record);
            }
            //Auto save when a record is selected from look up.
	        var outerTile = $j(e.target).closest('maximo-tile');
	        if(outerTile && outerTile.length) {
	            var innerTile = outerTile.find('.inner-tile');
	            if(innerTile && innerTile.length) {
	                if(innerTile[0].nodeName === 'MAXIMO-TABLE-TILE') {
	                    this._applyEdits(e);
	                }                      
	                else if(e.target._applyEdit){
	                     e.target._applyEdit(e);
	                } else {
	                     e.target.domHost._applyEdit(e);
	                }
	            }
	        }
	   }
    },
    
    /**
     * Load different buttons
     */
    _actionButtons: function(button){
    	var buttons = null;
		var context = this;
		switch(button){
			case 'approvebtn':
				buttons = this._getFooterApproveButton();
				break;
			case 'approvedbtn':
				buttons = this._getFooterApprovedButton();
				break;				
			case 'assignbtn':
				buttons = this._getFooterAssignButton();
				break;
			case 'assignedbtn':
				buttons = this._getFooterAssignedButton();
				break;
			case 'closebtn':
				buttons = this._getFooterCloseButton();
				break;
			case 'closedbtn':
				buttons = this._getFooterClosedButton();
				break;
			case 'savecancelbtn':
				buttons = this._getCancelSaveButton();
				break;
			case undefined:
				buttons = null;
				break;
			default:
				break;
		}
		return buttons;
			
    },
    /**
     * Show button under Footer section from header section on small devices
     */
    _showFooterDetail: function(button){
		var supButton = this._actionButtons(button);		
		$M.workScape.updateFooterToolbar(null, this);
		$j(this.$.wobtn).show();			
		if(this.createWO){
			$j(this.$.workorderSaveCancel).css('display', 'flex');
		}
		var height = $j(this.$.headerdetail).height();
		/*
		 * Header buttons should not be visible on mobile devices
		 * So, below check would fix it.
		 */
		if($M.isMobile() || height > 50){
			$M.workScape.updateFooterToolbar(supButton, this);
		   	$j(this.$.wobtn).hide();
		   	if(this.createWO){
		   	$j(this.$.workorderSaveCancel).hide();
		}
		}
	},
	     
	 /**
	  * Detail page Action buttons
	  */
	_getFooterApproveButton : function(e){
		return [{'id':'maximo_supervisor_label_approve','action':true,'label':this.localize('uitext','mxapiwodetail','approve'),'event':'approve'}];
	},
	 _getFooterApprovedButton : function(e){
		 return [{'id':'maximo_supervisor_label_approved','disabled':'true','action':true,'label':this.localize('uitext','mxapiwodetail','Approved'),'event':'approve','icon':'Maximo:Confirm','buttonColor':'green'}];
	 },
		
	  _getFooterAssignButton : function(e){
		 return [{'id':'maximo_supervisor_label_assign','action':true,'label':this.localize('uitext','mxapiwodetail','assignOwner'),'event':'showSelectOwner'}];
	  },
	  _getFooterAssignedButton : function(e){
			 return [{'id':'maximo_supervisor_label_assigned','action':true, 'disabled':'true' ,'icon':'Maximo:Confirm', 'label':this.localize('uitext','mxapiwodetail','Assigned'),'buttonColor':'green'}];
	  },
		   
	 _getFooterCloseButton : function(e){
		return [{'id':'maximo_supervisor_label_close','action':true,'label':this.localize('uitext','mxapibase','Close'),'event':'close'}];
	 },
	 
	  _getFooterClosedButton : function(e){
			 return [{'id':'maximo_supervisor_label_closed','disabled':'true','icon':'Maximo:Confirm','action':true,'label':this.localize('uitext','mxapiwodetail','Closed'),'buttonColor':'green'}];
	  },
	  
	  _approve: function(e){
		  this.approve(e);
	  },
	  
	  _close: function(e){
		  this.close(e);
	  },
   
	  _showSelectOwner: function(e){
		  this.showSelectOwner(e);
	  },
	  /**
	   * Show different buttons on small devices with respect to panel
	   */
	  _updateFooterActionButton: function(){
		if(this.actionName=='APPROVE'){
			   this._showFooterDetail('approvebtn');
		}else if(this.actionName=='APPROVED'){
			   this._showFooterDetail('approvedbtn');
		}if(this.actionName=='OWNER'){
			   this._showFooterDetail('assignbtn');
		}else if(this.actionName=='ASSIGNED'){
			   this._showFooterDetail('assignedbtn');
		}else if(this.actionName=='CLOSE'){
		       this._showFooterDetail('closebtn');
		}else if(this.actionName=='COMP'){
		       this._showFooterDetail('closedbtn');
		}else if(this.actionName=='MONITOR'){
			this._showFooterDetail(null);
		}else if(this.actionName==''){
			this._showFooterDetail('savecancelbtn');
		}
	  },
	  /** fetch description of records of different types in workorder
	   * 
	   */
	  _getOrigDesc: function(record){
		  if(!$j.isEmptyObject(record.origticket)){
			  return record.origticket.description;
		  }else if(!$j.isEmptyObject(record.origwo)){
			  return record.origwo.description;
		  }
		  return '';
	  }, 
	  
	  _hideGLAccount: function(attribute){
		  return this._isValueBlank(attribute); 
	  },
	  
	  
	  /**
		  * show enter meter readings tile
		  */
		 _handleLocationMeterRefreshed: function(e)
		 {
			if(this.$.locationMeterCollection.totalCount > 0){
				this.locationFlag = true;
				if(this.$.locationMeterCollection.collectionData !== undefined){
		 			this.$.locationMeterCollection.collectionData.forEach(function(record,index){
		 				if(record.meter.metertype==='CHARACTERISTIC'){
		 					if(record.locationmeterdomain && record.locationmeterdomain.description){
		 						record.readingmeasure = record.locationmeterdomain.description;
		 					} else {
		 						record.readingmeasure = record.locationmeterdomain.value;
		 					}
		 				} else {
		 					if(record.lastreading){
		 						if(record.meter.measureunitid){
			 						record.readingmeasure = record.lastreading+' '+record.meter.measureunitid;
			 					} else {
			 						record.readingmeasure = record.lastreading;
			 					}
							} else {
								record.readingmeasure = null;
							}
		 				}
						if(!record.meter.description){
	 						record.meter.description = record.metername;
	 					}
		 				record.index = index;
		 		  });
		 		}
			 } else {
				   this.locationFlag = false;
			    }
		 },
		
		 /**
		 * show enter meter readings tile
		 */
		_handleAssetMeterRefreshed: function(e)
		{
			if(this.$.assetMeterCollection.totalCount > 0){
				this.assetFlag = true;
				if(this.$.assetMeterCollection.collectionData !== undefined){
		 			this.$.assetMeterCollection.collectionData.forEach(function(record,index){
		 				if(record.meter.metertype==='CHARACTERISTIC'){
		 					if(record.assetmeterdomain && record.assetmeterdomain.description){
		 						record.readingmeasure = record.assetmeterdomain.description;
		 					} else {
		 						record.readingmeasure = record.assetmeterdomain.value;
		 					}
		 				} else {
		 					if(record.lastreading){
		 						if(record.meter.measureunitid){
			 						record.readingmeasure = record.lastreading+' '+record.meter.measureunitid;
			 					} else {
			 						record.readingmeasure = record.lastreading;
			 					}
							} else {
								record.readingmeasure = null;
							}
		 				}
		 				if(!record.meter.description){
		 					record.meter.description = record.metername;
	 					}
		 				record.index = index;
		 		  })
		 		}
			} else {
				   this.assetFlag = false;
			   }
		},
		
	
	/**
	 * Collection error
	 */
	_handleError: function (e) {
		var error = e.detail.Error;
		if(error){
			$M.notify(error.message, $M.alerts.error);
		}
	},
	
	/**
	 * check if any of the originating record has values
	 */
	
	_isOrgRecordEmpty: function(record){
		var origrecdDescval= this._getOrigDesc(record);
		if(record.origrecordclass || record.origrecordid || origrecdDescval ){
			 return true;
		}
		else {
			return false;
		}
		
	},
	
	/**
	 * When determining if we should show the CLOSE button, make sure CLOSE is an allowable state
	 */
	_showClose: function(myRecord){
		if(this.panelName==='CLOSE' && record.canchangetomaxstatus && this._IsValueInArray(record.canchangetomaxstatus,'CLOSE')){
			return false;
		}
		else{
			return true;
		}
	},
	/**
	 * Set editable attributed when status is changed
	 */
	_statusChanged: function (e){
		this.refreshTiles();
		var self = this;
		$j(this.$.section_details).find('maximo-badge-tile').each(function(){
			if(self.record && self.record.status_maxvalue==='CLOSE' ){
				if(this.id==='details_statusTile' ){
					this.removeAttribute('editable'); 
				}			
			}else {
				if((this.id!=='details_isrunning') ){
					this.setAttribute('editable','true'); 
				}
			}	
		});
	},
	
	/**
	 * On Closed Work, actions to upload/delete attachments are disabled.
	 */
	_hideAddattachmentAndDeleteButton: function(record){
		if(record && record.status_maxvalue === 'CLOSE' || record.status_maxvalue === 'CAN'){
			if(this.$.section_attachments.querySelector('maximo-file-carousel')){
				this.$.section_attachments.querySelector('maximo-file-carousel').closedWO();
			}
			if(this.$.section_attachments.querySelector('maximo-file-upload')){
				this.$.section_attachments.querySelector('maximo-file-upload').disable();
			}
			$j(this.$.section_attachments).find('.controlButton maximo-button').prop('disabled',true);
		}else {
			if(this.$.section_attachments.querySelector('maximo-file-carousel')){
				this.$.section_attachments.querySelector('maximo-file-carousel').enableButtons();
			}
			if(this.$.section_attachments.querySelector('maximo-file-upload')){
				this.$.section_attachments.querySelector('maximo-file-upload').enable();
			}			
			$j(this.$.section_attachments).find('.controlButton maximo-button').prop('disabled',false);
		}
	},
	
	/**
	 *  prepares the detail page to display a new record 
	 */
	showDetail: function(workOrder,  collection, readOnly, sourcePage, panelName, displayTab, newWO){
		this.panelName = panelName;
		if(sourcePage === 'create'){
			var self = this;
			$j(this.$.contentSelector).attr('add-class','disableLink');
			this.cachedRecord ={};
			this.createWO = newWO;
			this._disabledPageNavigation(true);
			this.plandataexists = false;
			this.actionName = '';
			this.$.wopriority.newTile = this.createWO;
			this.record = workOrder;
			this.cachedRecord['uxsupervisor'] = this.record.reportedby;
			this.cachedRecord['siteid'] = this.record.siteid;
			if(this.record.wopriority === undefined){
				this.$.wopriority.newTile = this.createWO;
		  		this.$.wopriority.emptyRecord = true;
		  	}
			this.refreshTiles();
			this.dataLoaded = false;
			if(self.$.relatedRecordsWOTable.collection.totalCount>0){
				this.$.relatedRecordsWOCollection.refreshRecords().then(function(response){
					self.$.relatedRecordsWOTable.$.wrapperNoData.style.display='block';
					$j(self.$.relatedRecordsWOTable.$.nodata).removeClass('hideElement');
					$j(self.$.relatedRecordsWOTable.$.nolabel).removeClass('hideElement');
					self.$.relatedRecordsWOTable.collection.collectionData=[];
					self.$.relatedRecordsWOTable.$.table.$.rowRepeat.items=[];
					self.$.relatedRecordsWOTable.collection.totalCount=0
					self.dataLoaded = true;
				});
			}
		}else{
			this.createWO = false;
			$j(this.$.contentSelector).removeAttr('add-class');
		}
		this.panelName = panelName;
		this.collection = collection;
		this.recordLight = workOrder;	
		this.readOnly = readOnly;
		this.sourcePage = sourcePage;
		this.newWO = newWO;
		this.$.assetimg.newTile = newWO;
		this.$.statusTile.newTile = newWO;
		this.$.wopriority.newTile = newWO;
		this.$.locationimg.newTile = newWO;
		this.$.workfailure.newTile = newWO;
		this.$.workproblem.newTile = newWO;
		this.$.worktype.newTile = newWO;
		this.$.parentwo.newTile = newWO;
		this.$.originRecd.newTile = newWO;
		this.$.sitedesc.newTile = newWO;
		this.$.schedstart.newTile = newWO;
		this.$.schedfinish.newTile = newWO;
		this.$.targstartdate.newTile = newWO;
		this.$.targcompdate.newTile = newWO;
		this.$.durationTile.newTile = newWO;
		this.$.actstart.newTile = newWO;
		this.$.actfinish.newTile = newWO;
		this.$.reportbyimg.newTile = newWO;
		this.$.reportdate.newTile = newWO;
		this.$.onbehalfof.newTile = newWO;
		this.$.leadimg.newTile = newWO;
		this.$.ownerimg.newTile = newWO;
		this.$.ownergrp.newTile = newWO;
		this.$.superimg.newTile = newWO;
		this.$.jobplan.newTile = newWO;
		// add required details to session Cache
		if(!this.createWO){
			sessionStorage.setItem('WORecordLight', JSON.stringify(this.recordLight));
			sessionStorage.setItem('WOSourcePage', this.sourcePage);
			sessionStorage.setItem('WOCollectionId', this.collection.id);
			sessionStorage.setItem('WOCollectionQueryWhere', JSON.stringify(this.collection.queryWhere));
		}
		
		if(newWO){
			this.assetFlag = false;
			this.locationFlag = false;
		}
		
		var sectionId = 'section_details';
		this.reportTimeAction = false;
		if(!displayTab || displayTab === 'details'){
			this.woButtonActionsVisibility = false;
			this.resetContentSelectorDefault();
		}else if( displayTab === 'comments'){
			sectionId = 'section_comments';
	        this.resetContentSelectorComment();
		}
		else if(displayTab === 'reportTime' || displayTab === 'approveTime'){
			sectionId = 'section_reportedwork';
			this.reportTimeAction = true; 
			var currentIndex = $j(this.$['maximo_workorder_reportedwork']).index();
			if(displayTab === 'reportTime'){
				var self = this;
				self.async(function(){
					self.$.supervisorreportedwork.fire('add-reportedwork-time-card');
			},100);
			}			
	        this.resetContentSelectorReportedWork(currentIndex);
		}
		this._showSubTab(sectionId);
		if(this.createWO){
			$M.toggleWait(false);
		}
		this.fire('workscape-design-views',{'hasDesignMode':false});
	},

	
	/**
	 * Observer for recordLight
	 * Loads full attributes into record 
	 * from mx-resource
	 */
	_loadDetailedRecord: function(){
		if(this.createWO){
			return;
		}
    	$M.toggleWait(true);   	
		this.attchmentsLoaded = false;
		if(!this.createWO){
			$j(this.$.contentSelector).removeAttr('add-class');
			this.record = {'href': this.recordLight.href};
			var self = this;
			this.$.woresource.loadRecord().then(function(records) {
				self.refreshTiles();	
			});
		}
		
		this.loadJobPlanRecordCounts();
		
		var loadCommentsBackgroundMode = (this._currentTab !== 'section_comments');
		var loadPlanDataBackgroundMode = (this._currentTab !== 'section_plans');
		var loadReportedWorkDataBackgroundMode = (this._currentTab !== 'section_reportedwork');
		
		var supervisorComments  = $j(this.$.section_comments).find('maximo-worklog')[0];
		if(supervisorComments){
			supervisorComments._loadComments(loadCommentsBackgroundMode);
        }
	 
		var supervisorPlans  = $j(this.$.section_plans).find('maximo-supervisor-plans')[0];
		if(supervisorPlans && !this.createWO){
			supervisorPlans.loadPlanData(loadPlanDataBackgroundMode);
		}
	 
		var supervisorreportedwork  = $j(this.$.section_reportedwork).find('maximo-supervisor-reportedwork')[0];
		if(supervisorreportedwork){
			supervisorreportedwork.loadReportedWorkData(loadReportedWorkDataBackgroundMode, this.record.labtrnallowanycrft);
		}
	 
		var supervisorInspections  = $j(this.$.section_inspections).find('maximo-supervisor-inspections')[0];
		if(supervisorInspections){
			supervisorInspections.loadInspections();
        }
		
		if(this._currentTab==='section_attachments'){
		    this._loadWOAttachments(this.recordLight);
		    this._hideAddattachmentAndDeleteButton(this.recordLight);
        }
        
		if(this._currentTab==='section_assignments'){
			var supervisorAssignments  = $j(this.$.section_assignments).find('maximo-supervisor-assignments')[0];
			if(supervisorAssignments){
				supervisorAssignments.loadPlanData(false);
			}
        }
		
	    this._loadRelatedRecordsWorkorder();
	},
	
	/**
	 * woresource mx-resource 
	 * loadRecord success callback
	 */
	_recordLoadSuccessHandler: function(event) {
		this.setRecord();
	    $M.toggleWait(false);
	},
	
	/**
     * woresource mx-resource 
     * loadRecord error callback
     */
	_recordLoadErrorHandler: function(event) {
	    $M.toggleWait(false);
    },
    
    
    /**
	 * woresource mx-resource 
	 * updateRecord success callback
	 */
	_recordUpdatedSuccessHandler: function(event) {
	   this.setRecord();
	   $M.toggleWait(false);
	},
	
	
    /**
     * woresource mx-resource 
     * updateRecord error callback
     */
	_recordUpdatedErrorHandler: function(event) {
	    $M.toggleWait(false);
    },
    
    /**
     * Set record property
     * using resourceData from woresource mx-resource 
     */
    setRecord: function() {
    	var record = this.$.woresource.resourceData;
    	if(record.labtrnallowanycrft && !sessionStorage.getItem('allowanycraft')){
	    	sessionStorage.setItem('allowanycraft', record.labtrnallowanycrft);
	    }
    	if(this.createWO && this.sourcePage==='create'){
	   		 this.cachedRecord['assetnum'] = (record.assetnum)?record.assetnum:'';
	   		 this.cachedRecord['location'] = (record.location && record.location.location)?record.location:'';
	   		 Object.assign(record,this.cachedRecord);
	   		 if(record.onbehalfof){
	   			record.onbehalfof = this.record.onbehalfof;
	   		 }
	   		 if(record.reportedby){
	   			record.reportedby = this.record.reportedby;
	   		 }
	   		 if(record.parent){
	   			record.parent = this.record.parent;
	   		 }
	   		 
	   		 this.record = this.addAuxiliarObject(record);
	   		 this.cachedRecord['location'] = (this.record.location && this.record.location.location)?this.record.location.location:'';
    	 }else{
    		 this.record = this.addAuxiliarObject(record);
    	 }
  	    //Check if jpnum is set and tile is editable
		if(this.record.jpnum && this.$.jobplan.editable){
			this.loadJobPlanRecordCounts();
		}
  	
		if(this.record.location && this.currentLocation!==this.record.location.location){
			this.locationFlag = false;
	  	    if(this.record.location && this.record.location.location){
		    	this._loadLocatioMeterDetails();
		    	this.locationFlag = true;
		    	this.currentLocation = this.record.location.location;
		    }
		}
  	    
		if(this.record.assetnum && this.currentAssetnum!==this.record.assetnum){
	  	    this.assetFlag = false;
	  	    if(this.record.assetnum){
		    	this._loadAssetMeterDetails();
		    	this.assetFlag = true;
		    	this.currentAssetnum = this.record.assetnum; 
		     }
		}
	    
	    if(this.record.status_maxvalue ==='CLOSE' || this.record.status_maxvalue ==='CAN'){
  	    	$j('.workfailureTile').find('.actionLabel, .iron-icon').css({'color':this.getComputedStyleValue('--Primary-gray50'),'fill':this.getComputedStyleValue('--Primary-gray50')}); 
  	    	$j('.relatedRecordsWOTile').find('.actions button').hide();
  	    } else {
  	    	$j('.workfailureTile').find('.actionLabel, .iron-icon').css({'color':this.getComputedStyleValue('--Primary-blue50'),'fill':this.getComputedStyleValue('--Primary-blue50')});
  	    	$j('.relatedRecordsWOTile').find('.actions button').show();
  	    }
	  	
	  	if(!record.failurecode){
			$j('.workproblemTile').find('.actionLabel, .iron-icon, .noLabeaddlColor').css({'color':this.getComputedStyleValue('--Primary-gray40'),'fill':this.getComputedStyleValue('--Primary-gray40')});
		}else{
	  		$j('.workproblemTile').find('.actionLabel, .iron-icon, .noLabeaddlColor').css({'color':this.getComputedStyleValue('--Primary-blue50'),'fill':this.getComputedStyleValue('--Primary-blue50')});
	  	}
	  	
	  	if(this.record.wopriority === undefined){
	  		this.$.wopriority.emptyRecord = true
	  	}else{
	  		this.$.wopriority.emptyRecord = false;
	  	}
	  	this._hideAddattachmentAndDeleteButton(record);
    },
    /**
 	 * Calling _addRelatedWORecordData function 
 	 */	
 	_addRelatedWORecord : function(e) {
 		var self = this;
 		if(this.createWO){
 			this.saveWorkorder().then(function(){
 				self.$.woresource.resourceUri = self.record.href;
 				self._addRelatedWORecordData(e);
 			});
 		}else{
 			this._addRelatedWORecordData(e);
 		}
 	},
 	
 	/**
	 * Delete workorder record from related record workorders table 
	 */
	_deleteWOTableRecord : function(e) {
		var item = e.detail.record;
		if(e.target.dataset.scopeId === 'relatedRecordsWOTable') {		//delete from related record table tile	
			this.$.woresource.deleteRecord(item.localref).then(function(response) {
				this._loadRelatedRecordsWorkorder();                
	        }.bind(this), function(error) {
	        	this._loadRelatedRecordsWorkorder();
	            $M.showResponseError(error);
	        });
		}
	},
	
	/**
	 *  Actions call back used to show Delete icon for related records
	 */
	_actionCallback: function(record,action){
		// Getting value from max_value
		return (record.relatetype === 'RELATED')?true : false;
	 },
	 
	 /**
      *  Function will invoke createFollowUp function in order to create follow-up workorder.
      */
	 _createFollowupWorkorder : function(e){
		 var self = this;
		 this._createFollowupWO();
		 
		 this.async(function(){ 
	    	   $j(window).scrollTop(0);
	      }, 200);
     },
     
     /**
  	 * Generate unique id for table tile 
  	 */
   	_generateUniqueIdForTableTile : function(e){
  	     var actions = $j(this).find('#actions.maximo-tile');
  	     var children = actions.children();
  	     children.each(function(){
  	    	 var child = this;
  	    	 if(!child.hasAttribute('data-uniqueid')) {	    		
  		    	 var prefix = $j(child).closest('maximo-tile').attr('id');
  		    	 var childId = $j(child).attr('id');
  		    	 $j(child).attr('id', prefix + childId);
  		    	 $j(child).attr('data-uniqueid', true);
  	    	 }	    	 
  	     });
  	},
  	
  	/**
     *  Function will load related records data in the table.
     */
    _loadRelatedRecordsWorkorder : function(e){
    	$j(this.$.relatedRecordsWOTable).find('maximo-table')[0].actionCallback = this.getLocalFunction('_actionCallback');
    	this._loadRelatedRecordsWO();
    },
    
    /**
     * Function to create list of already related workorder numbers in order to filter them out of workorder lookup list.
     */
    _getWorkorderClause : function(wonum,wonumset){
		var workorderClause = '';
		var wonumlist = '';
		if((this.recordLight && this.recordLight.wonum) || this.createWO){
			if(this.createWO){
				wonumlist = wonumset + this.record.wonum;
			}else{
				wonumlist = wonumset + this.recordLight.wonum;
			}
			if(this.recordLight && wonumlist !== this.recordLight.wonum){
				wonumlist = '%5B' + wonumlist + '%5D';
			}
			workorderClause = 'oslc.where=wonum!%3D%22'+ wonumlist +'%22%20and%20siteid%3D%22' + this.record.siteid+'%22&domaininternalwhere=woclass=WORKORDER&responseos=MXAPIWODETAIL';
		} 
		return workorderClause;
    },

    
    /**
     * Displaying the failure codes.
     */
    _displayFailurePage : function(e){
    	if(e.detail.status_maxvalue !== 'CLOSE' && e.detail.status_maxvalue !== 'CAN') {
    		this.fire('show-failure-code',{'record':this.recordLight});
    	}
    },
    
    /**
     * Showing the failure details.
     */
    showFailureDetail : function(e){
		  var self = this;
		  this.failureFlag = true;
		  this._showHideSection("section_reportedwork");
		  var supervisorreportedwork = $j(this).find('maximo-supervisor-reportedwork')[0];
	      this.$.contentSelector.select(6);
	      this.async(function(){ 
	    	  supervisorreportedwork.$.reportedworkSelector.select(4);
	      }, 500);
	      supervisorreportedwork._loadFailureReportData();
	      $j(supervisorreportedwork.$.section_failures).show();
	      $j(supervisorreportedwork.$.section_times).hide();
	      if(this.record && this.record.problemcode && this.record.problem.description){
	    	  supervisorreportedwork.$.maximo_failure_detail.$.collapseIconProblemWarning.hidden = true;
	    	  supervisorreportedwork.$.maximo_failure_detail.$.collapseIconProblemConfirm.hidden = false;
		  }else{
			  supervisorreportedwork.$.maximo_failure_detail.$.collapseIconProblemConfirm.hidden = true;
			  supervisorreportedwork.$.maximo_failure_detail.$.collapseIconProblemWarning.hidden = false;
  		  }
	},
    /**
     *  Gets the label for revision number for JP
     *  it will be empty when jpprevnum is null  
     */
    getPluscJprevnum : function(pluscjprevnum){
    	if(pluscjprevnum){
    		return $M.localize('uitext', 'mxapiwodetail','jprevision',[pluscjprevnum]);	
    	}else {
    		if(pluscjprevnum===0){
    			return $M.localize('uitext', 'mxapiwodetail','jprevision',['0']);
    		}
    	}
    }, 
    
    /**
	 * Check for failure class flag to display edit icon. 
	 */
	_isProblemTileEditable : function(record){
		if(record.status_maxvalue === 'CLOSE' || !record.failurecode){
			$j('.workproblemTile').find('.actionLabel, .iron-icon').css({'color':this.getComputedStyleValue('--Primary-gray40'),'fill':this.getComputedStyleValue('--Primary-gray40')});
			return false;
		}else {
			$j('.workproblemTile').find('.actionLabel, .iron-icon').css({'color':this.getComputedStyleValue('--Primary-blue50'),'fill':this.getComputedStyleValue('--Primary-blue50')});	
			return this.isAuthorized('REPORT_FAILURES');
		}
	},
	
	/**
	 * Check for failure class flag to display edit icon or not. 
	 */
	_editFailureTileEditable : function(record){
		if(!this.isAuthorized('REPORT_FAILURES')){
			return false;
		}
		return  !this._getReadonlyFlag(record.status_maxvalue);
	},
	
    /**
     *  Check if Jobplan tile is editable based on
     *  1. If any work plan components doesn't exist (task work orders)
	 *  2. If there aren't any planned (labor, material, tool)
     *  3. This, its parent or task work orders haven't gone through approval status in the past
     */
    getEditableFlagForJobplan : function(record,plandataloaded,status,plandataexists){
    	var editable = true;
    	//check for work order tasks/labor/material from plan section
    	var supervisorPlans  = $j(this.$.section_plans).find('maximo-supervisor-plans')[0];
    	if(supervisorPlans){
			var wplabor = supervisorPlans.getLocalObject('wplabor');
			var wptasks = supervisorPlans.getLocalObject('workordertasks');
			var wpmaterial = supervisorPlans.getLocalObject('wpmaterial');
			if(wplabor && wplabor.totalCount>0){
				editable = false;
			}else if(wptasks && wptasks.totalCount>0){
				editable = false;
			}else if(wpmaterial && wpmaterial.totalCount>0){
				editable = false;
			}    		
       }
       if(this.record && this.record.status_maxvalue!=='WAPPR'){
    		editable = false;
    	}else if(this.record && this.record.parent && this.record.parent.status_maxvalue && this.record.parent.status_maxvalue!=='WAPPR'){
    		editable = false;
    	}else if(this.plandataexists){
    		editable = false;
    	}
       
	    //show or hide tile
	   	if(!editable && !this.$.jobplan.value){
	   		this.$.jobplanTile.hidden=true;
	   	}else{
	   		this.$.jobplanTile.hidden=false;
	   	}
    	return editable;
    },

    /**
     *  Event handler for plan data loaded. This will trigger getEditableFlagForJobplan() to check and update editable 
     *  flag for job plan tile
     */

    _wpDataLoaded: function(e){
    	if(e.detail===this.record.href){
    		this.plandataloaded = true;
    	}	
    },
    
    /**
     *  Load the record counts for tasks/labor/material when detail record is loaded
     */

    loadJobPlanRecordCounts : function(){
    	
    	this.plandataexists = false;
    	 //check for tasks
    	 this.$.workplan.collectionUri = this.record.href + '/woactivity';
    	 this.$.workplan.attributeNames = "taskid";
    	 var self = this;
         this.$.workplan.refreshRecords().then(function(task) {
             var totalTaskCount = task.response.responseInfo.totalCount;
             if(totalTaskCount && totalTaskCount>0){
            	 self.plandataexists = true;
             }else {
            	 //Check for labor
            	 self.$.workplan.collectionUri = self.record.href + '/showplanlabor';
            	 self.$.workplan.attributeNames = "craft";
            	 self.$.workplan.refreshRecords().then(function(labor) {
                     var totalLaborCount = labor.response.responseInfo.totalCount;
                     if(totalLaborCount && totalLaborCount>0){
                    	 self.plandataexists = true;
                     }else {
                    	 //Check for material
                    	 self.$.workplan.collectionUri = self.record.href + '/showplanmaterial';
                    	 self.$.workplan.attributeNames = "unitcost";
                    	 self.$.workplan.refreshRecords().then(function(material) {
                             var totalMaterialCount = material.response.responseInfo.totalCount;
                             if(totalMaterialCount && totalMaterialCount>0){
                            	 self.plandataexists = true;
                             }
                         });
                     }
                 });
             }
             
         });

    },

    /*
     * If a record is saved in the tpae iframe and it matches the current record, we need to refresh it.
     */
    _recordChangedFromIframe: function(e){
   	 if(this.$.mainPage.offsetHeight > 0){ //is this page displayed?
   	 	if(e.detail.uniqueid === this.record.workorderid && e.detail.mbo === 'WORKORDER' || e.detail.mbo === 'WOACTIVITY'){ //was modified record the same as current?
   	 		this.$.woresource.loadRecord();
   	 	}
   	 }
    },
    
    /**
	 * To select the reported work tab when clicked report time button from CLOSE Panel.
	 */
	resetContentSelectorReportedWork : function(index){
 	    if(this.$.contentSelector && this.$.contentSelector.length >= index){
 	    	this.$.contentSelector.select(index);
 	    }
	},
	/** 
	 * Fire event to force the workscape to update the monitor work panel.
	 */
	_notifyParent: function() {
		if(this._currentTab === 'section_reportedwork' && this.record.status_maxvalue !== 'WAPPR' && (this.record.ownerperson.displayname || this.record.workorderownergroup.description)){
			this.reportTimeAction = true;
			this._showSubTab(this._currentTab);
		}
		this.showActualTile(true);
	},
	
	/** 
	 * Fire event to handle when owner or owner group changed.
	 */
	_notifyParentOwnerChanged: function() {
		this._notifyParent();		
		this.showActualTile(true);
	},
	
    /**
     * Loading the location meter details.
     */
    _loadLocatioMeterDetails: function(){
 		var self = this;
 		this.$.locationMeterCollection.additionalParams=['oslc.where=location=%22'+encodeURIComponent(this.record.location.location)+'%22'];
		this.$.locationMeterCollection.collectionUri = $M.getMaxauth().baseUri+'/oslc/os/mxapilocationmeter';
 		$M.toggleWait(true);
 		this.$.locationMeterCollection.refreshRecords().then(function(records) {
 			self.locationCollectionData = records;
		});
      },
 	 /**
 	   * Change asset status
 	   */
 	 _changeAssetStatus:function(e){
 		var self=this;
 		$M.toggleWait(true); 
 		var tile=e.target;
 		var downTime = {};
 		downTime.statuschangedate=tile.dateValue;
 		downTime.statuschangecode=this.datalabel;
 		downTime.operational='1';
 		var responseProperties = 'statuschangedate,statuschangecode,isrunning,statuschangedate_localized';
        this.$.woresource.updateAction('wsmethod:downtimereport', downTime, responseProperties)
         .then(function(result) {
        	 if (self.record.asset){
        		 self.$.woresource.loadRecord();
        	 }
        	 self.record.asset.isrunning = result.response.isrunning;
        	 self._updateSliderTile(self.record);
        	 self.datalabel=null;
             $M.toggleWait(false);
        }, function(error) {
        	if(self.record){
        		self._handleErrorDowntime(self.record);
        	}
        	tile._editTile();
            $M.toggleWait(false);
            $M.showResponseError(error);
        });
 	},
 	/**
	 * Update slider tile
	 */
	_updateSliderTile: function(record){
		if(record && record.asset){
			var isrunning = record.asset.isrunning;
		}
 		var tile = this.$.slider_tile;
 		if (this.record.asset){
 			this.record.asset.isrunning=isrunning;
 		}
		if(isrunning){
			if(record.moddowntimehist && record.moddowntimehist.length>0){
				tile.$.upDownIcon.icon='Maximo:Arrow2-Forward';
				tile.fillcolor='#4B8400';
			}else{
				tile.$.upDownIcon.icon=null;
			}
			tile.$.sliderCheckbox.classList.remove('red');
			tile.$.sliderCheckbox.classList.add('green');
			$j(tile.$.sliderCheckbox).attr('checked',true);
		}else{
			if(record.moddowntimehist && record.moddowntimehist.length>0){
				tile.$.upDownIcon.icon='Maximo:Arrow2-Down';
				tile.fillcolor='#D74108';
			}else{
				tile.$.upDownIcon.icon=null;
			}
			tile.$.sliderCheckbox.classList.remove('green');
			tile.$.sliderCheckbox.classList.add('red');
			$j(tile.$.sliderCheckbox).attr('checked',false);
		}
		if(this.$.assetimg && this.$.assetimg.value){
			return tile.value = tile.$.sliderCheckbox.checked;
		}else{
			return tile.value = null;
		}
	 },
	 /**
	  * Update Date value
	  */
	 _updateDate: function(downtime){
		 
		 var self = this;
		 if(downtime && downtime.length>0){
			 if(downtime[0].enddate){
				 return downtime[0].enddate_localized;
			 }else {
				 return downtime[0].startdate_localized;
			 }
		 }else{
			 return this.$.slider_tile.dateValue =null;
			 
		 }
	 },
	 /**
	  * Update code value
	  */
	 _updateCode: function(downtime){
		 if(downtime && downtime.length>0 && !this.record.asset.isrunning){
			 this.$.slider_tile.$.backtext.value=downtime[0].startcode_description;
			 return downtime[0].startcode_description;
		 }else{
			 this.$.slider_tile.$.backtext.value=null;
			 return '';
		 }
	 },
	 
	 /**
	  * Loading the asset meter details.
	  */
	 _loadAssetMeterDetails: function(){
		var self = this;
		this.$.assetMeterCollection.additionalParams=['oslc.where=assetnum=%22'+encodeURIComponent(this.record.assetnum)+'%22'];
		this.$.assetMeterCollection.collectionUri = $M.getMaxauth().baseUri+'/oslc/os/mxapiassetmeter';
	 		$M.toggleWait(true);
	 		this.$.assetMeterCollection.refreshRecords().then(function(records) {
	 			self.assetCollectionData = records;
	    });
	 },
	 
	 /**
	  * Handle values on error and reset the values to previous
	  */
	 _handleErrorDowntime: function(downtime){
		 var self = this;
		 if(downtime && downtime.moddowntimehist && downtime.moddowntimehist.length>0){
     		if(downtime.moddowntimehist[0].endcode || downtime.moddowntimehist[0].enddate){
				 	this.$.slider_tile.textValue = downtime.moddowntimehist[0].endcode_description;
				 	this.$.slider_tile.dateValue = downtime.moddowntimehist[0].enddate_localized;
	   		}else{
	   				this.$.slider_tile.textValue = downtime.moddowntimehist[0].startcode_description;
	   				this.$.slider_tile.dateValue = downtime.moddowntimehist[0].startdate_localized;
	   			 }
     	}else{
     		this.$.slider_tile.textValue = null;
     		this.$.slider_tile.dateValue = null;
     	}
	 },
	 /**
	  * Update lookup default value.
	  */
	 _setBackFaceValue: function(e){
		this._updateCode(this.record.moddowntimehist);
	 },
	 
	 /**
	  * Make slider tile readonly when in status_maxvalue ='CLOSE' 
	  */
	 _isSliderTileEditable: function(status){
		 if(status === 'CLOSE'){
			return false;
		 }else {
			return true;
		}
	 },
	 
	 /**
	  * Delete button was flash out when first time click on attachment section. 
	  */
	 _showHideDeleteIcon : function(){
		 if(this._showAddAttachmentLink(_images)){
			 return false;
		 } else {
			 return true;
		 }
	 },
	 /* 
	` * Show the top label based on asset value. 
	  */
	 _showSliderAnnotation: function(assetnum){
		 return assetnum?false:true;
	 },
	 
	/** 
	 * For handling specific scenarios when record is updated
	 */
	_recordUpdated: function(e) {
		 if(e.detail && e.detail.id && e.detail.id.includes('owner')){
			 this.showActualTile(true);				
		 }	
	 },
	 /** 
	  * Save new work-order.
	  */
	 saveWorkorder: function(){
		 $M.toggleWait(true);
		 var self = this;
		 if(this.cachedRecord && this.cachedRecord.uxsupervisor){
			 delete this.cachedRecord['uxsupervisor'];
		 }
		 this.cachedRecord['wonum'] = this.record.wonum;
		 this.cachedRecord['supervisor'] = this.record.uxsupervisor.personid;
		 this.cachedRecord['siteid'] = this.record.siteid;
		 this.cachedRecord['lead'] = this.record.uxlead.personid;
		 this.cachedRecord['assetnum'] = this.record.assetnum;
		 this.cachedRecord['location'] = this.record.$alias_this_attr$location;
		 return new Promise(function (resolve, reject) {
			 this.collection.createRecord(this.cachedRecord, this.attributeList, false).then(function(records){
				 $M.toggleWait(false);
				 self.createWO = false;
				 self.sourcePage='card'
				 self.checkInspectionAccess();
				 records.response['href'] = records.response.href;
				 self.recordLight = records.response;
				 $j("#details_contentSelector_inner")[0].style.maxWidth = 'none';
				 var worktype = (records.response.worktype) ? records.response.worktype : '';
				 var wonum = records.response.wonum;
				 var worktypeWonum = ' ' + worktype +' '+ wonum;
				 var message = $M.localize('uitext', 'mxapiwodetail', 'workordercreated', [worktypeWonum]);
				 $M.notify(message, $M.alerts.info);
				 self.cachedRecord={};
				 var dataKey= $j(self).find('[data-key]');
				 $j(dataKey).each(function(index,elem){
					 elem.newTile = self.createWO;
				 });
				 self.$.workfailure.newTile = self.createWO;
				 self.$.workproblem.newTile = self.createWO;
				 self.$.wopriority.emptyRecord = false; //Set default value as false
				 self.tempRecordClean = true;
				 self.cachedRecord={};
				 resolve(records);
				 $M.clearDisableWarningCallback(); 
				 $M.allowPageNavigation(true);
			  }, function(error) {
				  	$M.toggleWait(false);
					$M.showResponseError(error);
					reject(error);
			    });
		 }.bind(this));
		 
	 },
	 /** 
	  * set cached value in  cachedRecord
	  */
	 _setCachedValue: function(e){
		 var self =this;
		 var key;
		 var value;
		 if(e.target.dataset.key){
			 key = $j(e.target).data('key');
			 if(key==='reportedby'){
				 value = this.record.reportedby.personid;
			 }else if(key==='ownergroup'){
				 value = this.record.workorderownergroup.persongroup;
				 this.cachedRecord['owner'] =''; 
				 this.$.ownerimg.value=null;
			 }else if(key==='owner'){
				 value = this.record.ownerperson.personid;
				 this.cachedRecord['ownergroup'] ='';
				 this.$.ownergrp.value=null;
			 }else if(key==='wopriority'){
				 value = e.target.value;
				 this.$.wopriority.emptyRecord =false;
			 }else if(key==='schedstart'){
				 var schedstart=e.target.value;
				 var schedstartdata={'schedstart':schedstart};
				 this._updateWODates(new Date(this.$.schedfinish.value),new Date(this.$.schedstart.value),schedstartdata,'schedstart');
				 value = schedstart;
			 }else if(key==='schedfinish'){
				 var schedfinish=e.target.value;
	             var schedfinishdata={'schedfinish':schedfinish};
	             this._updateWODates(new Date(this.$.schedfinish.value),new Date(this.$.schedstart.value),schedfinishdata,'schedfinish');
				 value = schedfinish;
			 }else if(key==='targstartdate'){
				 var targstartdate=e.target.value;
	             var targetstartdata={'targstartdate':targstartdate};
	             this._updateWODates(new Date(this.$.targcompdate.value),new Date(this.$.targstartdate.value),targetstartdata,'targstartdate');
				 value = targstartdate;
			 }else if(key==='targcompdate'){
				 var targcompdate=e.target.value;
	             var targcompdatedata={'targcompdate':targcompdate};
	             this._updateWODates(new Date(this.$.targcompdate.value),new Date(this.$.targstartdate.value),targcompdatedata,'targcompdate');
				 value = targcompdate;
			 }else if(key==='assetnum'){
				 value = e.target.value;
				 var data = {'assetnum': e.target.value};
				 this._getLocationAssetData(data,e.target,true);
			 }else if(key==='location'){
				 value = e.target.value;
				 var data = {'location': e.target.value};
				 this._getLocationAssetData(data,e.target,true);
			 }else if(key==='onbehalfof'){
				 value = this.record.onbehalfof.personid;
			 }else if(key==='lead'){
				 value = (e.target.value === this.record.uxlead.displayname) ? this.record.uxlead.personid : e.target.value;
			 }else if(key==='supervisor'){
				 value = (e.target.value === this.record.uxsupervisor.displayname) ? this.record.uxsupervisor.personid : e.target.value;
			 }else{
				 value = e.target.value;
			 }
			 if(value === undefined){
				 value = '';
			 }
			 this.cachedRecord[key] = value;
			 if(key==='ownergroup' || key==='owner'){
				 this.saveWorkorder();
			 }
		 }else if(e.target.dataset.scopeId==='slider_tile'){
			 this.saveWorkorder().then(function(result){
				 self.$.woresource.resourceUri = self.record.href; 
				 self._changeAssetStatus(e);
			 });
		 }
		 if(key!=='assetnum' && key!=='location' && key!=='ownergroup' && key!=='owner' && e.target.dataset.scopeId!=='slider_tile'){
			 this._validateUserInput(e.target,true);
		 }
	 },
	 /** 
	  * clean/remove new in memory record
	  */
	 _cancelWorkorder : function(){
		 $M.clearDisableWarningCallback();
		 $M.allowPageNavigation(true);
		 var self = this;
		 this.cachedRecord ={};
		 if(!this.tempRecordClean){
			 self.tempRecordClean = true;
		 }
		 if(this._cancelWorkorder.caller.name!=='_goBack'){
			 this._goBack();
		 }
	 },
	 /** 
	  * Get Location/Asset Data
	  */
	 _getLocationAssetData : function(data,component,showInEditModeWhenError){
		 var self = this;
		 var resource = this.$.woresource;
		 resource.resourceUri = $M.getMaxauth().baseUri + '/oslc/os/mxapiwodetail';
		 var responseProperties = this.attributeList;
		 var record={};
		 record.wonum = this.record.wonum;
		 record.siteid = this.record.siteid;
		 Object.assign(record,this.cachedRecord);
		 if(record.onbehalfof){
			 delete record['onbehalfof'];
		 }
		 if(record.reportedby){
			 delete record['reportedby'];
		 }
		 
		 if(record.parent){
			 delete record['parent'];
		 }
		 		 
		 if(record.assetnum){
			 delete record['assetnum']
		 }
		 if(record.location){
			 delete record['location'];
		 }
		 if(data.assetnum){
			 record.assetnum= data.assetnum;
		 }else if(data.location){
			 record.location= data.location;
		 }
		 var requestHeaders ={};
		 requestHeaders['setvaluemode'] ='1';
		 requestHeaders['method'] ='POST';
		 resource.updateRecord(record, responseProperties, true, true,requestHeaders).then(function(result) {
			$M.toggleWait(false);
		 }, function(error) {
			$M.toggleWait(false);
			if(component){
				if(showInEditModeWhenError){
					 component._editMode = true;
					 component._showHighlight(true);
					 component._flipTile(true);
				}
			}
			
			self.cachedRecord[component.dataset.key] ='';
			if(!resource.yncShown){
				$M.showResponseError(error);
			}
		 });
	  },
		/**
		* show the yes/no/cancel dialog and process accordingly
		*/
	  _showYNC: function(){
		  if (this.activeYNC){
			  return false;
		  }
		  this.activeYNC=true;
		  var self = this;
		  $M.toggleWait(true);
		  var response = {};
		  var yncOptions = {
				'Yes':'8',
				'No':'16',
				'Cancel':'4'
		  };
		  var message = $M.localize('uitext', 'mxapiwodetail', 'yncMessage');
		  $M.confirmMaxMessage(message, self._confirmYNC, self, 2, yncOptions, null, $M.alerts.question);
	  },
		
	  /**
		* this is a callback for the yes/no/cancel
		* callbackVal should be one of these... close: 1, ok: 2, cancel: 4, yes: 8, no: 16
		*/
	  _confirmYNC: function(callbackVal, params, caller){
		  this.activeYNC=false;
		  var self = this;
		  if (callbackVal && callbackVal > 1 && callbackVal !== 4){	// don't do anything if they clicked Close or Cancel
				if(callbackVal===8){
					this.saveWorkorder().then(function(result) {
						self._goBack();
					});
				}else if(callbackVal===16){
					self._cancelWorkorder();
				}
				
		  }else{
				return;
			 }
	  	},
		/**
	 	 * Add related workorder in the workorder table with relation RELATED
	 	 */	
		_addRelatedWORecordData: function(e){
			  var self = this;
			  var followupData = e.detail.records[0];
			  var params;
		 		var responseProperties = 'wonum,description';
		 		if (e.target.dataset.scopeId === 'relatedRecordsWOTable' ) {
		 			params = {
							description: followupData.description,
							wonum: followupData.wonum,
							siteId: followupData.siteid
						};
		 			$M.toggleWait(true);
		 			this.$.woresource.updateAction('wsmethod:generateWORelRecord', params, responseProperties).then(
		 				function(result) {
		 					$M.toggleWait(false);
		 					self._loadRelatedRecordsWorkorder();   
		 				}, function(error) {
		 					$M.showResponseError(error);
		 					$M.toggleWait(false);
		 					self._loadRelatedRecordsWorkorder();   
		 				});
		 		}
		  },
		  /**
	       * editmode=1 require's if calling action with in-memory mbo to skip the clearing the MBO.
	       */
		  _getCustomizedJobPlanHref : function(record){
			  if(this.createWO){
				  return $M.getMaxauth().baseUri + '/oslc/os/mxapiwodetail/zombie' + '?editmode=1'
			  }
			  return record.href;
		  },
		  /**
	       * Customized lookup href for the tile which is show on new work order scenario
	       */
		  _getCustomizedLookupHref: function(record){
			  if(this.createWO){
				  return $M.getMaxauth().baseUri + '/oslc/os/mxapiwodetail/zombie';
			  }
			  return record.href;
		  },
		  /**
	       * Customized common clause for the tile which is show on new work order scenario
	       */
		  _getCustomizedCommonClause: function(record){
			  if(this.createWO){
				  return 'setupdata={}'
			  }
		  },
		  /**
	       * Customized parent clause for the tile on new work order scenario
	       */
		  _getCustomizedParentClause: function(record){
			  if(this.createWO){
				  return 'setupdata={%22wonum%22:%22'+record.wonum+'%22}'
			  }
		  },
		  /**
	       * validatin user input in new work order scenario
	       */
		  _validateUserInput : function(targetElement,showInEditModeWhenError){
			  var self =this;
			  this.collection.createRecord(this.cachedRecord, this.attributeList, true, false, false, true).then(function(records){
					$M.toggleWait(false);
			 	},function(error) {
					$M.toggleWait(false);
					if(targetElement){
						if(showInEditModeWhenError){
							targetElement._editMode = true;
							targetElement._showHighlight(true);
							targetElement._flipTile(true);
						}
					}					
					self.cachedRecord[targetElement.dataset.key] ='';
					$M.showResponseError(error);
			  });
	 },
	 
	 /**
	  * Perform actions after tile edit cancel
	  */
	 _handleTileEditCancel : function(e){
		 this._updateFooterActionButton();
	 },
	 /**
	  * Show worktype if istask=0 
	  */
	 _showWorktype: function(worktype){
		 if(!this.record.istask){
			 return worktype
		 }
	 },
	 
	 /**
	  * Hide open work order tracking section in case of 
	  * New Workorder or workorder istask=1
	  */
	 _hideOpenWO : function(istask){
		 if(this.record && (this.createWO || istask) || $M.isMobile()){
			 return true;
		 }
		 return false;
	 },
	 /**
	  * Get Doclinks Woactivity URL 
	  */
	 getDoclinksWoactivityURL: function(record){
		 var self = this;
		 this.$.woactivityDocLinksCollection.additionalParams=['oslc.where=wonum=%22'+record.parent.wonum+'%22','ignorecollectionref=1'];
		 this.$.woactivityDocLinksCollection.collectionUri = $M.getMaxauth().baseUri+'/oslc/os/mxapiwodetail';
		 return new Promise(function (resolve, reject) {
			 this.$.woactivityDocLinksCollection.refreshRecords().then(function(records) {
				 resolve(records);
			  }, function(error) {
					$M.showResponseError(error);
					reject(error);
			    });
		 }.bind(this));
	 },
	 /**
	  * Refresh attachment collection and set doclinks member and href
	  */
	 refreshAttachmentCollection : function(recordHref){
		 this.$.attachmentsCollection.collectionUri = recordHref;
		 var self = this;
		 this.$.attachmentsCollection.refreshRecords().then(function(records){
			self.attchmentsLoaded = true;
			if(records && records.response && records.response.doclinks){
				self._attachments = records.response.doclinks.member;				
				self._doclinksUrl = records.response.doclinks.href;
			}
		 });	
	 },
	 /**
	  * Hide open task Activity section in case of workorder istask=0
	  */
	 _hideOpenACT : function(istask){
		 var hasAccess = this.isAuthorized('ACTIVITY:STATUS');
		 if(hasAccess && istask){
			 return false;
		 }
		 return true;
	  },
	  /**
	   * Disable page navigation in case of new workorder
	   */
	  _disabledPageNavigation: function(disabled){
		  var selectorArray = [
	  			$M.workScape.$.headerbar, //workscape header
	  			$j('.carouselController') //page carousel on mobile
	  		];
	  		var navbar = $j('maximo-navbar')[0];
	  		if(navbar){
	  			selectorArray = selectorArray.concat([
	  				navbar.$.sideMenu,
	  	  			navbar.$.hamburger
	  	  		]); 
	  		}
	  		if(this.createWO){
	  			$M.toggleDisabled(selectorArray, disabled,this._showYNC, this);
	  		}else{
	  			$M.toggleDisabled(selectorArray, disabled);
	  		}	  		
	  },
	  _getCancelSaveButton : function(){
			return [{'id':'cancelButtonWorkorder','action':true,'label':this.localize('uitext','mxapibase','Cancel'),'event':'cancelWorkorder'},
				{'id':'saveButtonWorkorder','action':false,'label':this.localize('uitext','mxapibase','save'),'event':'_saveWorkorder'}];
	  },
	 
	 /**
	  * Get Service address details 
	  */
	 getServiceAddress: function(currentRecord){
		 var serviceAddressLabel = "";
		 if(currentRecord && currentRecord.serviceaddress){
			 var servAddress = currentRecord.serviceaddress;
		 
			 if(servAddress.formattedaddress){
				 serviceAddressLabel = servAddress.formattedaddress; 
			 }else if(servAddress.description){
				 serviceAddressLabel = servAddress.description; 
			 }else{
				 serviceAddressLabel = servAddress.saddresscode;
			 } 
		 }
		 return serviceAddressLabel;
	 },
 
	 /**
	  * Update Service address 
	  */	 
	 updateServiceAddress: function(e){
		 var newServiceAddress = e.detail.serviceaddress;
		 var self = this;
     	 this._updateWO({'saddresscode':newServiceAddress.addresscode}, this.collection,undefined,undefined,true,'serviceaddress').then(function(result){
          	self.record.serviceaddress = newServiceAddress;
     		self.$.serviceAddress._cancelEditNotLoadPreEditValues();
     		self.$.serviceAddress.value = self.getServiceAddress(self.record);
     	 });
	 },
	  
	  /**
  	  * Click on Checkbox button under Lookup filter
  	  * fires the event in the _lookupFilterAction
  	  */
	 _chkToggleAction : function(e)
	 {
		this.toggleFilter = ($j($M.workScape.querySelector('.chkToggle .switch')).attr('checked'))? true : false;
		var lookupURL = '';
		if(e && e.target && e.target._lookupObject){
			if(!this.toggleFilter){
				lookupURL = this.record.href+'/getlist~inspformnum?oslc.select=name,inspformnum,status&oslc.where=orgid="'+$M.userInfo.defaultOrg+'"';
			}else{
				lookupURL = e.target._lookupObject.href+'/recinspforms?oslc.select=*,INSPECTIONFORM.name--name&searchAttributes=INSPECTIONFORM.name,inspformnum&oslc.where=orgid="'+$M.userInfo.defaultOrg+'"';
			}
		}
		var lookupObj = $M.workScape.querySelector('maximo-lookup-drawer');
		lookupObj.$.lookupCollection.collectionUri = lookupURL;
		lookupObj.$.lookupCollection.refreshRecords();
	 },
	 /**
	 * Check for readonly flag for inspection 
	 */
	 _getReadonlyInspFlag : function(record, status){		
		var self = this;
		var editable = true;
		if(status === 'CLOSE' || status === 'CAN'){
			editable = false;
		}else { 
			$j(this.$.section_details).find('maximo-badge-tile').each(function(currenttile){ 
				if(this.id === 'details_inspTile' && !record.inspformnum){
					editable = true;
				}else if(this.id === 'details_inspTile' && record.inspformnum){
					editable = false;
				}
			});
	  }

		return editable;
	},
	/**
     * Set site description on site tile.
     */
	_getSiteDescription : function(record){
		return (record.site && record.site.description)?record.site.description : record.siteid;
	}
 });
