/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2017,2018
 */
Polymer({
	is: 'maximo-supervisor-reportedwork',
  	behaviors: [BaseComponent],
	listeners: {
   	   'save-reportwork-time-card' : '_saveWPTimeCard',
   	   'deleteTimeCard': '_deleteWPTimeCard',
   	   'add-reportedwork-time-card' : '_addReportedworkTimeCard',
   	   'disableAddTimeHeader' : '_disableTimeHeader'
    }, 
	properties : {
		totalTimeCount: {
			type: Number,
			notify: true
		},
		timeLoaded : {
			type: Object,
			value: false,
			notify: true
		},
		timeswoschema : {
			type: Object
		},
		materialwoschema : {
			type: Object
		},
		
		totalReportedMaterialCount: {
			type: Number,
			notify: true
		},
		materialsLoaded : {
			type: Object,
			value: false,
			notify: true
		},
		/**
		 * show hide reported time card attribute
		 */
		showReportedTimeCard:{
			type: Boolean,
            value: false 
		},
		totalServicesCount: {
			type: Number,
			notify: true
		},
		servicesLoaded : {
			type: Object,
			value: false,
			notify: true
		},
		servicesWoSchema:{
			type: Object
		},
		/**
		 * Tools total count
		 */
		totalToolsCount : {
			type: Number,
			notify: true
		},
		/**
		 * To check if tools loaded or not
		 */
		toolsLoaded : {
			type: Object,
			value: false,
			notify: true
		},
		/**
		 * current tab name.
		 */
		currentTab: {
			type: String,
			notify: true
		},
		/**
		 * attribute for first load.
		 */
    	isFirstLoad : {
    		type: Boolean,
    		value: true
    	},
    	failTypeDomain : {
    		type : Array
    	}
	},
  	created : function(){
  		
  	},
  	ready : function(){
  		
  	},
  	attached: function(){

  	},
  	
  	 /*
     * Switch tab for detail, plan, comments and attachment
     */
	switchContent: function(event) {
		var curIdArray = event.currentTarget.id.split('_');
		var sectionId = 'section_' + curIdArray[curIdArray.length-1];
		this._showHideSection(sectionId);
	},
	/*
	 * Show and hide tab for detail, plan, comments and attachment
	 */
	_showHideSection: function(sectionName) {
    	this.currentTab = sectionName;
		var currentList;
		$j(this.$.subcontainer).children('div').each(function(index, elem) {
			if (elem.id.indexOf(sectionName) > -1) {
				currentList = this;
			}
			$j(this).hide();
		});
		
		$j(currentList).show();
		if(!this.isFirstLoad || this.currentTab!=='section_times'){
			this.loadReportedWorkData(false);
		}
		this.isFirstLoad = false;
		
		if(this.record.status_maxvalue==='WAPPR'){
			this.showReportedTimeCard = false
		}
	},
	/*
	 * Check if count is zero
	 */
	_showNoData: function(count,collectionRefresh){
		if(count === 0 && collectionRefresh){
			return false;
		}
		return true;
	},
	
	/*
	 * Load ReportedWork data through refresh records
	 */
	loadReportedWorkData : function(isBackgroundMode) {
        //enable wait layer
		$M.toggleWait(true);
		this.timeLoaded = false;
    	this.materialsLoaded = false;
    	this.servicesLoaded = false;
    	this.toolsLoaded = false;
    	//To load spinner making count as -1 , this means collections is being refreshed
    	this.totalTimeCount = -1;
    	this.totalReportedMaterialCount = -1;
    	this.totalServicesCount = -1;
    	this.totalToolsCount = -1;
    	
		if(this.$.reportedworkSelector){
			this.$.reportedworkSelector.select(0);
			if(this.isFirstLoad){
				this._showHideSection('section_times');
			}
		}
		var self = this;
		//check collection count for time and assign to local variable
		if(this.currentTab==='section_times'){
			this.$.times.collectionUri = this.record.href+'/uxshowactuallabor';
	  		this.$.times.refreshRecords().then(function(time){
	  			self.refreshCounters();
	  			self.timeLoaded = true;
	  			
	  			var hasDirty = false;
				self.async(function(){
			   		$j(self).find('maximo-reportedwork-time-card').each(function(i,v){ 
			   			if(v.id === 'newTimeCard'){
			   				this.isDirty = true;
			   				hasDirty = true;
			   			}else{
							this._clearDirty();
						}
					});
			   		
				}, 200);
				
				self.async(function(){ 
					if(hasDirty){
						this._disableTimeHeader(true);
					}
		       },250);
			   $M.toggleWait(false);
	  		});
		}
		if(this.currentTab==='section_materials'){
			this.$.wrmaterial.collectionUri = this.record.href+'/uxshowactualmaterial';
	  		this.$.wrmaterial.refreshRecords().then(function(reportedmaterial){ 
	  			self.refreshCounters();
	  			self.materialsLoaded = true;
	  			$M.toggleWait(false);
	  		});
		}
  		
		if(this.currentTab==='section_failures'){
			this._loadFailureReportData();
		}
		
		if(this.currentTab==='section_services'){
			this.$.servicesCollection.collectionUri = this.record.href+'/uxshowactualservice';
	  		this.$.servicesCollection.refreshRecords().then(function(actualservices){ 
	  			self.refreshCounters();
	  			self.servicesLoaded = true;
	  			$M.toggleWait(false);  			
	  		});
		}
  		
  		//uxshowactualtool
		if(this.currentTab==='section_tools'){
			this.$.actualtools.collectionUri = this.record.href+'/uxshowactualtool';
	  		this.$.actualtools.refreshRecords().then(function(reportedtools){
	  			var toolsData = reportedtools.response;
	  			self.refreshCounters();
	  			self.toolsLoaded = true;
	  			$M.toggleWait(false);  			
	  		});
		}
	},
	
	/**
	 * To load Report Failure data
	 */
	_loadFailureReportData : function(){
		//To load failure report data
		var self = this;
  		if(this.record && this.record.failurecode){
  			self.$.maximo_failure_detail.failureclass = false;
  			$j('[data-scope-id="fail_long_desc"]').prop('disabled',false);
  		} else {
  			self.$.maximo_failure_detail.failureclass = true;
  			$j('[data-scope-id="fail_long_desc"]').prop('disabled',true);
  		}
  		
  		if(this.record && !this.record.problemcode && this.record.problem && this.record.problem.description === undefined){
  			this.$.maximo_failure_detail.$.cause.value = '';
			this.$.maximo_failure_detail.$.remedy.value = '';
  		}
	
  		this.$.failureResource.resourceUri = this.record.href+'/uxshowfailurereport';
  		this.$.failureResource.loadRecord().then(function(results){  	
  			self.refreshCounters();
  			self.failureReportObj = results.member;
  			self.$.maximo_failure_detail.$.collapseIconCauseConfirm.hidden = true;
			self.$.maximo_failure_detail.$.collapseIconCauseDebug.hidden =  false;
			self.$.maximo_failure_detail.$.collapseIconRemedyConfirm.hidden = true;
			self.$.maximo_failure_detail.$.collapseIconRemedyRecommendation.hidden =  false; 
			self.$.maximo_failure_detail.$.collapseIconProblemConfirm.hidden = true;
			self.$.maximo_failure_detail.$.collapseIconProblemWarning.hidden =  false; 

			if(self.failureReportObj && self.failureReportObj.length === 1){
  				self.$.maximo_failure_detail.$.cause.value = '';
				self.$.maximo_failure_detail.$.remedy.value = ''; 
  			}
			if(self.failureReportObj && self.failureReportObj.length === 2){
				self.$.maximo_failure_detail.$.remedy.value = ''; 
			}
			
  			self.failureReportObj.forEach(function(failReport){  				
  				if(self.domHost && self.domHost.getInternalDomainValue(self.failTypeDomain,failReport.type) === 'PROBLEM') {
  					self.$.maximo_failure_detail.$.collapseIconProblemConfirm.hidden = false;
  					self.$.maximo_failure_detail.$.collapseIconProblemWarning.hidden =  true; 
  					self.$.maximo_failure_detail.problemObj = failReport;
  					self.$.maximo_failure_detail.problemhref = failReport.localref+'/failurelist';
  					self.$.maximo_failure_detail.flagCause = true;
  					self.$.maximo_failure_detail.failureFlag = true;
  					self.$.maximo_failure_detail.problemFlag = true;
  					self.$.maximo_failure_detail.$.problem.value = failReport.failurecode.description;
  					self.$.maximo_failure_detail.problem = failReport.failurecode.failurecode;
  				}
  				if(self.domHost && self.domHost.getInternalDomainValue(self.failTypeDomain,failReport.type) === 'CAUSE') {
  					self.$.maximo_failure_detail.cause = failReport.failurecode.failurecode;
  					self.$.maximo_failure_detail.causeDesc = failReport.failurecode.description;
  					self.$.maximo_failure_detail.$.collapseIconCauseConfirm.hidden = false;
  					self.$.maximo_failure_detail.$.collapseIconCauseDebug.hidden =  true;
  					self.$.maximo_failure_detail.causeObj = failReport;
  					self.$.maximo_failure_detail.causehref = failReport.localref+'/failurelist';
  					self.$.maximo_failure_detail.flagRemedy = true;
  					self.$.maximo_failure_detail.failureFlag = true;
  				}
  				if(self.domHost && self.domHost.getInternalDomainValue(self.failTypeDomain,failReport.type) === 'REMEDY') {
  					self.$.maximo_failure_detail.remedy = failReport.failurecode.failurecode;
  					self.$.maximo_failure_detail.remedyDesc = failReport.failurecode.description;
  					self.$.maximo_failure_detail.$.collapseIconRemedyConfirm.hidden = false;
  					self.$.maximo_failure_detail.$.collapseIconRemedyRecommendation.hidden =  true; 
  					self.$.maximo_failure_detail.remedyObj = failReport;
  					self.$.maximo_failure_detail.failureFlag = true;
  				}
  			});
  			
  			$M.toggleWait(false);
  		});
	},
	
	/**
	 * record- labtrans json object.
	 * attribute- requested date type like start/finish.
	 * return - If only date is entered return localized date 
	 * 			if only time is entered return localized time
	 * 			if both values are there return datetime localized value else null.
	 */	
	_getActualsDateTime(record,attribute){	
		var value = record[attribute+'datetime_localized'] ;
		if(!value){
            value = record[attribute+'date_localized'] ? record[attribute+'date_localized'] : record[attribute+'time_localized'];
            return value ? value:'';
        }
		return value;
   },
   /**
    * To Add a Time card in the reported work panel. 
    */
	_addReportedworkTimeCard: function(e) {
	   var cards = $j('#newTimeCard'); 
	   if(cards.length === 0){
		   var reportedworkTimeCard = Polymer.Base.create('maximo-reportedwork-time-card',{'id':'newTimeCard','isDirty':true, 'editable':true, 'workorderurl':this.record.href});
		   $M.toggleDisabled([this.$.reportedworktimediv], true);
		   reportedworkTimeCard.setAttribute('newTimeCard', true);
		   reportedworkTimeCard.istask = (this.record.istask===undefined)?this.domHost.recordLight.istask:this.record.istask;
	       this.$.reportedworkTimeList.insertBefore(reportedworkTimeCard, this.$.timeCardList); //InserBeforeTheList
	       reportedworkTimeCard.$.approvedButtonDivFront.hidden = true;
	       reportedworkTimeCard.$.approvedButtonDivBack.hidden = true;
	       reportedworkTimeCard.$.reportedwork_time_transtype_select.value = 'WORK'; 
	       $M.getServerDateTime().then(function(response){
	    	   if($M.isMobile()){
	    		   reportedworkTimeCard.$.reportedwork_time_startdate.value = moment(response.date,$M.maxauth.whoami.dateformat.toUpperCase()).format('YYYY-MM-DD');
	    	   }else{
	    	   reportedworkTimeCard.$.reportedwork_time_startdate.value = moment(response.date,$M.maxauth.whoami.dateformat.toUpperCase())._i;
	    	   }
	       });
	       this.async(function(){ 
	    	  this._disableTimeHeader(true);
	    	  this.$.nodatasection_labtranss.hidden = true;
	       },300);
	   }
   },
   /**
	 * This method perform Save/Update action for reported time card.
	 */
   _saveWPTimeCard: function(e) {
      $M.toggleWait(true);
      var currentCard = e.target;
      var timeData = e.detail; 
      var startTime = timeData.starttime;
      var finishTime = timeData.finishtime;
      var startDate = timeData.startdate;
      var finishDate = timeData.finishdate;
      
      var timeFormat = $M.getMaxauth().whoami.timeformat;
      var dateTimeFormat = $M.getMaxauth().whoami.datetimeformat.replace($M.getMaxauth().whoami.dateformat,$M.getMaxauth().whoami.dateformat.toUpperCase());
      var responseProperties = 'labtransid';
      this.$.timeresource.resourceUri = this.record.href + '/uxshowactuallabor';
      if (e.detail.href) {
          timeData._action = 'Update';
          if(e.detail.name === 'ApproveButton' && (!e.detail.genapprservreceipt)){
     	 	 e.detail.genapprservreceipt = true;
     	  } 
      }
      var timeList = [];
      timeList.push(timeData);
      var self = this;
      var card = $j(self).find('maximo-reportedwork-time-card')[0];
      //Handle invalid start time if user enter invalid time
      if(startTime && moment(startTime).format(timeFormat) === 'Invalid date'){ 
    	  currentCard.$.reportedwork_time_starttime.value = moment(startDate + ' '+ startTime , dateTimeFormat).format('HH:mm');
      }
      //Handle invalid finish time if user enter invalid time
      if(finishTime && moment(finishTime).format(timeFormat) === 'Invalid date'){
    	  currentCard.$.reportedwork_time_finishtime.value = moment(finishDate + ' '+ finishTime , dateTimeFormat).format('HH:mm');
      }
      
      var timeList = [];
      timeList.push(timeData); 
      
      this.$.timeresource.updateRecord(timeList, responseProperties, true)
          .then(function(result) {
       	   $M.toggleWait(false);
       	   if(e.target.id === 'newTimeCard'){
    		   e.target.remove();
    	   } 
       	   self.$.times.refreshRecords();
           card.clearDirtyStatus();
           card.isDirty = false;
           self._disableTimeHeader(false);
          }, function(error) {
              $M.toggleWait(false);
              $M.showResponseError(error);
         });
     },
    /**
	 * To Delete a Reported Time card.
	 */
	_deleteWPTimeCard: function(e) {
	  var self = this;
      $M.toggleWait(true);
      if (e.detail) {
           this.$.timeresource.deleteRecord(e.detail).then(function(response) {
              $M.toggleWait(false);
              self.$.times.refreshRecords();
       	      self.loadReportedWorkData();
       	      self._disableTimeHeader(false);
       	      if(self.totalTimeCount === 0){
             	self.$.nodatasection_labtranss.hidden = false;
              }
          }.bind(this), function(error) {
              $M.showResponseError(error);
          });
      }else{
	       	$j('#newTimeCard').remove();
	       	$M.toggleWait(false);
	       	self._disableTimeHeader(false);
	       	if(this.totalTimeCount === 0){
              	this.$.nodatasection_labtranss.hidden = false;
              }
      }
    },
    /** 
     * To disable/enable Add Time button, MastHead using maximo-context.
     * Mask onClick of Add Time Button
     */
    _disableTimeHeader: function(toggleDisabled) {
        var actionObjList = [this.$.reportedworktimediv, $M.workScape.querySelector('#details_maximoAppHeader'),
        					$M.workScape.querySelector('#supervisorreportedwork_timeCardList'), 
        					$M.workScape.querySelector('#supervisorreportedwork_reportedworkSelector')];
        if(toggleDisabled === true || toggleDisabled.detail){
           $M.allowPageNavigation(false);
           $M.toggleDisabled(actionObjList, true);
        }else{
           $M.allowPageNavigation(true);
           $M.toggleDisabled(actionObjList, false);
        }
     },
   
   _hideFailuresTab : function(){
	   var hasAccess = this.isAuthorized('REPORT_FAILURES');
	   if(!hasAccess){
		   console.log('access denied for failures' );
		   return true;
	   }
   
	  return  false;
   },
   /**
    * Handle the display of location description and storelocation.
    */
   _getStoreroomLocation : function(storeLoc,locations){
  	 return locations.description ? locations.description : storeLoc;
   },
 	/**
	 * Fires all collection to fetch counters
	 */

   	refreshCounters: function() {
   		var self=this;
		if(this.currentTab!=='section_times'){
			this.$.times.queryInfo=[];
			this.$.times.queryInfo[0]={'href':this.record.href+'/uxshowactuallabor'};
			this.$.times.$.mxajaxCollectionCount.url  = this.$.times.queryInfo[0].href;
			this.$.times.collectionUri = this.record.href+'/uxshowactuallabor';
			this.$.times.getCollectionCount().then(function(response){
		    	self.totalTimeCount = response.response.totalCount;
		    });
		}
		
		if(this.currentTab!=='section_materials'){
			this.$.wrmaterial.queryInfo=[];
			this.$.wrmaterial.queryInfo[0]={'href':this.record.href+'/uxshowactualmaterial'};
			this.$.wrmaterial.collectionUri =	this.$.wrmaterial.queryInfo[0].href;
			this.$.wrmaterial.$.mxajaxCollectionCount.url  = this.record.href+'/uxshowactualmaterial';
			this.$.wrmaterial.getCollectionCount().then(function(response){
		    	self.totalReportedMaterialCount = response.response.totalCount;
		    });
		}
		
		
		
		if(this.currentTab!=='section_services'){
			this.$.servicesCollection.queryInfo=[];
			this.$.servicesCollection.queryInfo[0]={'href':this.record.href+'/uxshowactualservice'};
			this.$.servicesCollection.collectionUri =	this.$.servicesCollection.queryInfo[0].href;
			this.$.servicesCollection.$.mxajaxCollectionCount.url  = this.record.href+'/uxshowactualservice';
			this.$.servicesCollection.getCollectionCount().then(function(response){
		    	self.totalServicesCount = response.response.totalCount;
		    });
		}
		
		if(this.currentTab!=='section_tools'){
			this.$.actualtools.queryInfo=[];
			this.$.actualtools.queryInfo[0]={'href':this.record.href+'/uxshowactualtool'};
			this.$.actualtools.collectionUri =	this.$.actualtools.queryInfo[0].href;
			this.$.actualtools.$.mxajaxCollectionCount.url  = this.record.href+'/uxshowactualtool';
			this.$.actualtools.getCollectionCount().then(function(response){
		    	self.totalToolsCount = response.response.totalCount;
		    });
		}
		
  }
   
});
