<!--
 @license 
 Licensed Materials - Property of IBM
 5724-U18
 Copyright IBM Corporation. 2016,2017
-->

<!--
	Changes made to this file need to be synchronized with its corresponding database reference in the maxworkcenterfiles table
	
	filename = maximocards/workorder/technician/maximo-technician-card/maximo-technician-card.jsp	
-->

<%@ taglib prefix="ibm" uri="/WEB-INF/webclient.tld"%>

<link rel="import" href="../../../../handlers/handler-workorder/handler-workorder.html"/>

<link rel="import" href="../../behaviors/workorder.html">
<link rel="import" href="../../../../../css/palette.html">
<link rel="import" href="../../../../../css/shared.html">
<link rel="import" href="maximo-technician-card-css.html">

<dom-module id="maximo-technician-card">
	
	<style is="custom-style" include="maximo-palette-css"></style>
	<style is="custom-style" include="maximo-shared-css"></style>
	<style is="custom-style" include="maximo-technician-card-css"></style>		

		<template id="techsection">
	  		<div id="tileContainer" class="container"> 	  			
				<div id="tile" class="dataSetCard">
					<div id="undoOverlayDiv" class="dataSetCard" style$="border-bottom: 10px solid {{_getStatusColorCode(record.status_maxvalue)}} !important" on-mouseover="_addHoverStyle" on-mouseout="_clearHoverStyle">						
						<div id="techCardHeader" class="cardheader card-header" on-tap="_workOrderDetail">
							<div class="flex-equal-justified" style="padding:5px 0px 0px 0px;">
						
								<div id="technician_carddescription" class="carddescription ellipsis" style="margin-right:15px;">
									<ibm:maximo-component id="placeholder-1"></ibm:maximo-component>
								</div>
								<div id="tech_inner_div20" hidden$="{{showPriority(record)}}" class="flex-horizontal">
									<ibm:maximo-component id="placeholder-2"></ibm:maximo-component>
									<ibm:maximo-component id="placeholder-3"></ibm:maximo-component>
								</div>
							</div>
						</div>
						<div id="container" class="cardcontainer card-content" on-tap="_workOrderDetail">
							<div style="text-align: left;display:flex;">
								<div id="ellipsis_cardfields" class="ellipsis cardfields" style="flex:4;" >				
							
									<div id="maximo_technician_inner_div10">
									<div id="maximo_technician_inner_div10_worktype" style="display:inline;" hidden$="{{showWorktype(record,'placeholder-4')}}">
										<ibm:maximo-component id="placeholder-4"></ibm:maximo-component>
									</div>
									<ibm:maximo-component id="placeholder-5"></ibm:maximo-component>
								</div>
									<div id="tech_status" class="cardlabel" style="margin-top:4px;margin-bottom: 4px;">
										<ibm:maximo-component id="placeholder-6"></ibm:maximo-component>
									</div>										
									<ibm:maximo-component id="placeholder-7"></ibm:maximo-component>
									<ibm:maximo-component id="placeholder-8"></ibm:maximo-component>
									<ibm:maximo-component id="placeholder-9"></ibm:maximo-component>
									<ibm:maximo-component id="placeholder-11"></ibm:maximo-component>
								</div>
								<div id="tech_record_image" style="flex:1;margin-top:3px" hidden$="{{showImage(record.asset._imagelibref)}}">
									<ibm:maximo-component id="placeholder-10"></ibm:maximo-component>
								</div>
							</div>							
						</div>
						<div hidden$="{{_inDesignMode()}}">
							<div id="line" class="line" hidden$="{{_showLine(record)}}">
								<div id="worklinks1" class="flex-equal-around-justified footerLabel" style="flex: 0 0 auto; padding:3px;" hidden$="{{_canShowStart(record)}}">
									<maximo-button id="tech_label_start" action="true" record="{{record}}" on-tap="_onSelectWorkOverlay" label="{{localize('uitext', 'mxapiwodetail', 'start')}}" sigoptions="MXAPIWODETAIL:STARTTIMER" ></maximo-button>
								</div>
								<div id="worklinks2" class="flex-equal-around-justified card-footer footerLabel" hidden$="{{!_showStart(record)}}">
									<maximo-button id="tech_label_reportwork" hidden$="{{_showReportWork(record)}}" action="true" on-tap="_reportWork" label="{{localize('uitext', 'mxapiwodetail', 'reportwork')}}" ></maximo-button>
									<maximo-button id="tech_label_stop" hidden$="{{_showStop(record)}}" action="true" on-tap="_finishAssignment" label="{{localize('uitext', 'mxapiwodetail', 'stop')}}" ></maximo-button>
								</div>
							</div>
						</div>
						<div id="selectWorkType" hidden class="overlay">
							<div id="containerDiv" class="containerDiv">
								<div id="maxselect">
									<maximo-select id="select" label="{{localize('uitext', 'mxapiwodetail', 'selectWorkType')}}" values="[[_domainList(ltTypeSet)]]" placeholder=""></maximo-select><br>
								</div>
						
								<div id="buttons" class="flex-equal-around-justified footerLabelSelectWO" style="flex: 0 0 auto; padding:3px;">
									<div id="cancelButton" class="flex-equal-around-justified card-footer footerLabelSelectWO">
										<maximo-button id="cancelButton" action="true" on-tap="_offSelectWorkOverlay" label="{{localize('uitext', 'mxapibase','cancel')}}" ></maximo-button>
									</div>
									<div id="startButton" class="flex-equal-around-justified footerLabelSelectWO" style="flex: 0 0 auto; padding:3px;">
										<maximo-button id="startButton" class="button" on-tap="_startAssignment" label="{{localize('uitext', 'mxapiwodetail', 'start')}}" sigoptions="MXAPIWODETAIL:STARTTIMER" ></maximo-button>
									</div>								
								</div>							
							</div>								
						</div>
						
						<div id="setDateTime" hidden class="overlay">	
							<div id="containerDateDiv" class="containerDateDiv">
								<div id="startTime">
									<maximo-datetime id="startdatetime1" type="time" style="display:inline-block;" width="70" value="{{startTime}}" label="{{localize('uitext', 'mxapiwodetail', 'workStartTime')}}"></maximo-datetime>
									<maximo-datetime id="startdatetime2" style="display:inline-block; margin-left:-5px;" width="80" value="{{startDate}}"></maximo-datetime>
								</div>
								<div id="stopTime">
									<maximo-datetime id="stopdatetime1" type="time" style="display:inline-block;" width="70" value="{{stopTime}}" label="{{localize('uitext', 'mxapiwodetail', 'workStopTime')}}"></maximo-datetime>
									<maximo-datetime id="stopdatetime2" style="display:inline-block; margin-left:-5px;" value="{{stopDate}}" width="80" value=""></maximo-datetime>
								</div>
						
								<div id="buttons" class="flex-equal-around-justified footerLabelSelectWO" style="flex: 0 0 auto; padding:3px;">
									<div id="cancelButton" class="flex-equal-around-justified card-footer footerLabelSelectWO">
										<maximo-button id="cancelButton" action="true" on-tap="_offDateTimeOverlay" label="{{localize('uitext', 'mxapibase','cancel')}}" ></maximo-button>
									</div>
									<div id="doneButton" class="flex-equal-around-justified footerLabelSelectWO" style="flex: 0 0 auto; padding:3px;">
										<maximo-button id="startButton" on-tap="_stopAssignment" label="{{localize('uitext', 'mxapiwodetail', 'done')}}"></maximo-button>
									</div>								
								</div>							
							</div>								
						</div>
														
					</div>
				</div>							
			</div>
			
			<maximo-resource id="confirmResource"
				resource-uri="" 
				add-internal-values attribute-names="maxvar.confirmlabtrans,maxvar.labtranstolerance" 
				resource-data="{{labtransData}}"
				on-record-refreshed="_confirmHandler"
				on-record-refresh-error="_confirmErrorHandler"
				></maximo-resource>
		</template>

	<script src="maximo-technician-card.js"></script>

</dom-module>
