/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2016,2017
 */
Polymer({
	is: 'maximo-technician-detail',
  	behaviors: [BaseComponent, AttachmentValidator, HandlerWorkOrder, Workorder],
  	listeners: {
  	    'carouselDelete': '_deleteFile',
  		'hideViewMoreDisplay': '_hideViewMoreDisplay',
  		'maximo-collection-navigator': '_navigatorRecordUpdate',
  		'maximo-tile-edit-apply': '_applyEdits',
  		'reportWorkFooter' : '_reportWork',
  		'startFromFooter' : '_onSelectWorkOverlay',
  		'stopFromFooter' : '_onYesOrNoDiv',
  		'tile-clicked':'_navigatePage',
  		'statusChanged' : '_statusChanged',
  		'goBackandCompleteWO' : '_goBackAndCompleteWO',
  		'startAssignment':'_startAssignment',
  		'beginWork':'_beginWork',
  		'compReportWork':'_compReportWork',
  		'maximo-lookup-selected' : '_applyEditLookUpSelected',
  		'maximo-typeahead-selected' : '_applyEditLookUpSelected',
  		'relatedrecord-wo-detail' : '_displayRelatedWODetail',
  		'inner-app-saved' : '_recordChangedFromIframe',
  		'save-meter-details' : '_saveMeterDetails',
  		'tile-edit-mode' : '_setBackFaceValue',
  		'save-long-desc' : '_saveLongDescription',
		'cancel-long-desc' : '_cancelLongDescription',
		'linkToEAQuery' : '_linkToEAQuery',
  		'linkToAugCollab' : '_linkToAugCollab',
  		'maximo-lookup-addserviceaddress': '_showAddServiceAddressFlyout',
  		'maximo-serviceaddress-created': 'updateServiceAddress',
		'tile-event-action' : '_failureInvocation',
		'show-confirm-ync': '_showYNC'
  	},
    properties: {
        
        /**
         * Lightweight representation of the current record 
         */
        recordLight: {
            type: Object,
            observer: '_loadDetailedRecord'
        },
        
    	record: {
			type: Object,
			notify: true,
			observer: 'refreshTiles'
		},			
		attributeList: {
			type: String,
			value: 'rel.labtranstimerstatus{*},workorderid,worktype,wo_worktype.wtypedesc,wopriority,schedstart,targstartdate,targcompdate,description,estdur,description_longdescription,wonum,pmnum,assetnum,asset.location--assetloc,asset.description--assetdesc,asset.isrunning--isrunning,location,location.description,status,schedfinish,parent.wonum,parent.description,parent.parent,siteid,reportedby,reportdate,owner,ownergroup,onbehalfof,lead,supervisor,location._imagelibref,asset._imagelibref--assetimg,ownerperson.primaryemail,ownerperson.primaryphone,ownerperson.primarysms,ownerperson.displayname,ownerperson._imagelibref,onbehalfof.primarysms,onbehalfof.primaryemail,onbehalfof.primaryphone,onbehalfof.displayname,onbehalfof._imagelibref,reportedby.displayname,reportedby._imagelibref,reportedby.primaryemail,reportedby.primarysms,reportedby.primaryphone,uxlead.displayname,uxlead._imagelibref,uxlead.primarysms,uxlead.primaryemail,uxlead.primaryphone,uxsupervisor.primarysms,uxsupervisor.primaryemail,uxsupervisor.primaryphone,uxsupervisor.displayname,uxsupervisor._imagelibref,glaccount,actstart,actfinish,failure.description,relatedreckey,relatetype,origrecordid,origrecordclass,origticket.description,origwo.description,synonymdomain.description,jpnum,jobplan.description,pluscjprevnum,problemcode,problem.description,failurecode,workorderownergroup.description,failure.description_longdescription,remarkdesc,remarkdesc_longdescription,worktype.promptfail--worktypeprompt,rel.asset.mxapiasset{assetnum,assettype,classstructure.classificationid,description},rel.moddowntimehist{*},classstructure.description_class,maxvar.labtrnallowanycrft,classstructure.classificationid,location.location,istask,serviceaddress.saddresscode,serviceaddress.description,serviceaddress.formattedaddress,location.saddresscode,location.serviceaddress.addresscode,location.serviceaddress.formattedaddress,location.serviceaddress.description,site.description'
		},
		_attachments: {
			type: Array,
			value: [],
			observer: '_loadAttachments',
			notify: true
		},
		_images: {
			type: Array,
			value: [],
			notify: true
		},
    	/**
    	 * Synonym domain collection
    	 */
    	statusSet: {
    		type: Array,
    		observer: '_statusSetChange'
    	},
		woFilterData: {
			type: Object,
			value: null,
			notify: true
		},
		hideUploading: {
			type: Boolean,
			value: true,
			notify: true
		},
		/** 
		 * flag if there are comments
		 */
		hasComments: {
			type: Boolean,
			value: false
		},
		
    	/**
    	 * LT Type domain filter
    	 */
    	ltTypeSet: {
    		type: Array,
    		value: function () {
    			return [{'filtertype': 'SIMPLE', 'field': 'domainid', 'availablevalues': [ {'value': 'LTTYPE', 'selected': true} ]}];
    		} 	
    	},
    	startTime : {
			type: String,
		},
		startDate : {
			type: String,
		},
		stopTime : {
			type: String,
		},
		stopDate : {
			type: String,
		},
	
		
    	/**
    	 * Question progress object
    	 * read only
    	 */
    	progress: {
    		type: Object,
    		computed: 'computeQuestionProgress(originalDataListQuestions)'
    	},
    	/**
    	 * flag if total questions same as required total
    	 * read only
    	 */
    	allRequired: {
    		type: Boolean,
    		value: false,
    		computed: 'computeAllRequired(progress)'
    	},

    	/**
    	 * schema for mxapiwodetail collection
    	 */
    	schema: {
    		type: Object
    	},
		
		/**
	     * owner of the current registry 
	     */
		collection: {
			type: Object
		},
		
		/**
	     * Selected Tab 
	     */
		_currentTab: {
			type: String
		},
		
		/**
		 * Enable/Disable visibility for Actions on Header
		 */
		toggleHeaderActionsVisibility: {
    		type: Boolean,
    		value: false,
    		notify: true
    	},
    	
    	/**
    	 * Disable Desktop/Mobile check, when no actions should appear.
    	 */
    	disableActions: {
    		type: Boolean,
    		value: false,
    		notify: true
    	},

    	/**
    	 * Flag to show/hide Inspections tab based on grants
    	 */
    	inspectionAccess: {
    	    type: Boolean,
    	    value: false
    	},
    	/**
    	 * URI for Asset resource fetched from asset.mxapiasset object
    	 */
    	assetURI :{
    		type:Object
    	},
    	/**
    	 * Asset record data
    	 */
    	assetrecordData : {
    		type: Object    		
    	},
    	/**
    	 * URI for resource location
    	 */
    	locationURI :{
    		type:Object
    	},
    	/**
    	 * Location record data
    	 */
    	locationRecordData : {
    		type: Object    		
    	},
    	/**
    	 * Preview workorder records
    	 */
    	previewWORecords : {
			type : Array,
			value : []
		},
		additionalWOparams : {
   			type: Array,
   			value: [],
   			notify: true
   		},
   		/**
    	 * Property added in order to track user navigation after creation of workorder.
    	 */
   		backStack : {
			type : Array,
			value : []
		},
		
		/**
    	 * Flag related to Asset meter section
    	 */
		assetFlag :{
			type : Boolean,
			value : false
		},
		/**
    	 * Flag related to Location meter section
    	 */
    	locationFlag :{
			type : Boolean,
			value : false
		},
		/**
		 * For assetmeter lookup and meter to persist
		 */
		meterHref : {
			type: String
		},
		isrunning : {
			type : Boolean
		},
		contextSubscriptions: {
			value: ['inner-app-saved']
		},  
		
		/* Properties for EA */
		EAQueryUrl: {
			type: String,
			notify: true
		},
		EAToken: {
			type: String,
			notify: true
		},
		EAApiKey: {
			type: String,
			notify: true,
			value: ''
		},
		/**
    	 * property for follow-up workorder
    	 */
		isFollowUpWO : {
			type : Boolean,
			value : false
		},
		/**
		 * For fail type
         */
		failType : {
			type: Array
		},
		btnMenuItems : {
        	type: Array,
    		value: [],
    		notify:true    		
        },
        
        /**
        * Maximo Augmented Collaboration
        */
        sessionDataSet: {
    		type: Array,
    		value: []
    	},
		
		/**
		 * URI for service address lookup
		 */
		serviceAddressURI: {
			type : String,
			value : ''
		},
	
		/**
		 * Record mapping for service address lookup 
		 */
		serviceAddressRecordMapping: {
			type : String,
			value : 'record.serviceaddress.formattedaddress:formattedaddress,record.serviceaddress.saddresscode:addresscode,record.serviceaddress.description:description'
		},
		/** 
		 * temp record for new work-order.
		 */
		cachedRecord: {
			type: Object,
			value:{}
		},
		/**
		 * Flag for create workorder page
		 */
		createWO :{
			type : Boolean,
			value : false
		},
		/**
		 * Flag for temp record clean
		 */
		tempRecordClean :{
			type : Boolean,
			value : false
		},
		
		/**
		 * Check if the WO is new.
		 */
    	newWO : {
    		type: Boolean,
            value: false
    	},
    	/** 
		 * prior page.
		 */
		sourcePage: {
			type: String 
		},
		
		/**
	     * To get customized href for all tile in new work order scenario
	     */
		newWOCustomLookupHref :{
			type : String,
			computed:'_getCustomizedLookupHref(record)'
		},
		/**
	     * Set up clause for new work order scenario
	     */
		newWOSetupClause :{
			type : String,
			computed:'_getCustomizedCommonClause(record)'
		}

		
	},
	
	attached: function() {
		if(!$M.isMobile()){
			var naviColObj = this.$.navigationCollection;
			naviColObj.$.previousDivWrapper.style.display = 'flex';
			naviColObj.$.nextDivWrapper.style.display = 'flex';
		}
		this.SKIP_REFRESH_TILES=false;
	    this.checkInspectionAccess();
	    
		if($j('[data-scope-id="nolabelstr"]').length && $j('[data-scope-id="frontLabel"]').length){
			$j('[data-scope-id="nolabelstr"], [data-scope-id="frontLabel"]').css('padding-top', '4px');
		}
	    
		var styleObj = {
			textAlign: 'left'
		};
		if ($M.isMobile()) {
			$j(this.$.stopdatetime1.$.time_mobile_template_label)
				.add(this.$.startdatetime1.$.time_mobile_template_label)
				.css(styleObj);
		}
		else {
			$j(this.$.startdatetime1.$.time_nonmobile_template_label)
				.add(this.$.stopdatetime1.$.time_nonmobile_template_label)
				.css(styleObj);
		}
	    
	    this.previewWORecords = [{
			'attribute' : 'relatedreckey',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'WO'),
			'sortable' : true,
			'hyperlink' : true,
			'listener' : 'relatedrecord-wo-detail',
			'flexGrow': '2'
		}, {
			'attribute' : 'relatedrecwo.description',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'Description'),
			'flexGrow': '6'
		}, {
			'attribute' : 'relatetype_description',
			'sortattribute' : 'relatetype',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'relationship'),
			'sortable' : true,
			'flexGrow': '4',
		}];
	    
	    this.assetMeterRecords = [{
			'attribute' : 'metername',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'ID'),
			'flexGrow': '2'
		}, {
			'attribute' : 'meter.description',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'Description'),
			'flexGrow': '3'
		}, {
			'attribute' : 'readingmeasure',
			'sortattribute' : 'previousreading',
			'title' : $M.localize('uitext', 'mxapimeter', 'lastreading'),
			'sorttype':'descending',
			'flexGrow': '3'
		}];
		
		this.locationMeterRecords = [{
			'attribute' : 'metername',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'ID'),
			'flexGrow': '2'
		}, {
			'attribute' : 'meter.description',
			'title' : $M.localize('uitext', 'mxapiwodetail', 'Description'),
			'flexGrow': '3'
		}, {
			'attribute' : 'readingmeasure',
			'sortattribute' : 'lastreading',
			'title' : $M.localize('uitext', 'mxapimeter', 'lastreading'),
			'sorttype':'descending',
			'flexGrow': '3',
		}];
	    
	    this.set('eaCfgUrl', $M.getMaxauth().baseUri + '/oslc/service/workorder?action=wsmethod:checkEAcfg');
	    var self = this;
	    this.$.checkEAcfg.loadRecord().then(function(result){
	    	self._EAUrl = self.eaCfgData.url;
	    	self.EAQueryUrl = self._EAUrl + '/query';
			self.EAApiKey = self.eaCfgData.apikey;
			self._setHideEAButton();
	    },function(error){
	    	console.log(error);
	    });
	    
  		this.set('btnMenuItems', [{label:$M.localize('uitext', 'mxapiwodetail', 'SeekAdvice'),event:'linkToEAQuery',icon:'Maximo:Watson'},
  								  {label:$M.localize('uitext', 'mxapiwodetail', 'SeekAdvice'),event:'linkToAugCollab',icon:'Maximo:Relationship'}]);
	    
	    $j('maximo-tile').find('.maximo-tile.titleContainer').attr('style', 'display: block!important');
	    $j('.largelabel').find('.mainLabeldiv > label').css('font-size','129%');
	},
	
	/**
	 * Hide/show inspection module
	 */
	checkInspectionAccess: function() {
	    var workCenter = 'inspector';
	    this.inspectionAccess = $M.hasAccessToWorkscape(workCenter);
	},
	
    /**
     * Check whether data param is undefined or zero length
     * to show and hide view more option for description
     */
     _isnodata: function(data){
            return (data != undefined && data.length > 0 ? false : true);
     },
	/**
	 * Computed function for all required flag
	 * Compute
	 */
	computeAllRequired: function (progress) {
		
		var allRequired = false;
		if (progress.reqtotal === progress.total ) {
			allRequired = true;
		}
		
		return allRequired;
	},
	/**
	 * Count total questions
	 */
	countQuestions: function (questions) {
		
		var totalQuestions = 0;

		for (var i = 0; i < questions.length; i++) {
			var q = questions[i];
			
			if (q.children) {
				totalQuestions += this.countQuestions(q.children);
			} else {
				totalQuestions++;
			}
			
		}
		return totalQuestions;
	},
	
	/**
	 * Count required questions
	 */
	countRequiredQuestions: function(questions) {

		var totalReqQuestions = 0;
		outerl:
		for (var i = 0; i < questions.length; i++) {
			var q = questions[i];
			
			if (q.children) {
				totalReqQuestions += this.countRequiredQuestions(q.children);
			} else if (q._required && q._required === true) {
				totalReqQuestions++;
			}
			
		}
		return totalReqQuestions;
		
	},
	
	_addBtnClicked: function() {
		$j(this.$.fileInput).trigger('click');
	},
	
	getImages: function(e) {
		if(e){
			var record = e.detail;
			console.log(record.doclink);
		}
	},
			
	_onSelectWorkOverlay: function() {
		
		var oriRecord = this.record;
	  	var self = this;
	  	var externalValues=[];
	  	this.$.confirmResource.resourceUri = this.record.href+'/uxshowactuallabor/newmbo/getlist~transtype?oslc.select=synonymdomainid,valueid,maxvalue,href,defaults,description,value,domainid&lean=1&querylocalized=1';
	  	 this.$.confirmResource.loadRecord().then(function(result){
	  					 
	  					if(result && result.member && result.member.length > 0){
	  						
	  						result.member.forEach(function(domainrecord){
				 	   	    		externalValues.push(domainrecord);
					  	   });
	  						self.record = oriRecord;
	  						if(externalValues.length > 0){
	  							self.record.ltTypeSet= externalValues;	
	  							self.ltTypeSet = externalValues;
	  						}
	  						
				 		}
	  					self.$.overlayDiv.hidden = true;
	  					self.$.selectWorkType.hidden = false;
	  					self.$.select.values = self._domainList(self.record.ltTypeSet);
	  					self._fixWorkTypeLabel();
	  				 });
		
	},

	_offSelectWorkOverlay: function() {
		this.$.overlayDiv.hidden = false;
	    this.$.selectWorkType.hidden = true;
	},

	_onYesOrNoDiv: function() {
		var self = this;
		var wonum = this.record.wonum;
		var workorderid = this.record.workorderid;
		var confirmResourceUri = $M.getMaxauth().baseUri + '/oslc/os/mxapiwodetail?lean=1&oslc.where=workorderid%3D%22' + workorderid + '%22&oslc.select=maxvar.confirmlabtrans,maxvar.labtranstolerance';
		self.$.confirmResource.resourceUri = confirmResourceUri;
		self.$.confirmResource.loadRecord();
		self.$.overlayDiv.hidden = true;
		self.$.yesOrNoDiv.hidden = false;
		self.$.setDateTime.hidden = true;
	},
	
	_offYesOrNoDiv: function() {
		this.$.overlayDiv.hidden = false;
	    this.$.yesOrNoDiv.hidden = true;
	},
	
	_offDateTimeOverlay: function() {
		this.$.overlayDiv.hidden = false;
	    this.$.setDateTime.hidden = true;
	},
	
	
	/**
	 * begin Work
	 */
	_beginWork : function() {
		
		var self = this;
		this.isWorkOrderComp=false;
		var wonum = this.record.wonum;
		var worktype = this.record.worktype;
		var startMessage = $M.localize('uitext','mxapiwodetail','woStatusStarted',[worktype,wonum]);
		
		var _timerExpired = function(overlayNode) {
				self.fire('beginAssignment',self.record);
		};

		var _undo = function(overlayNode) {	
			self.$.worklinks1.hidden = false;
		};
		
		$M.notify(startMessage, $M.alerts.info, _timerExpired, _undo);
		
	},
	
	/**
	 * Start Assignment
	 */
	_startAssignment : function() {
		
		var self = this;
		this.isWorkOrderComp=false;
		var labor = $M.userInfo.labor.laborcode;
		var card = this.$.undoOverlayDiv;
		var wonum = this.record.wonum;
		var worktype = this.record.worktype;
		var wo = this.record;
		var startMessage = $M.localize('uitext','mxapiwodetail','woStatusStarted',[(worktype && !this.record.istask?worktype:'') ,wonum]);
		
		var _timerExpired = function(overlayNode) {
				self.domHost.fire('startAssignment', {'record': self.record, 'workType': self.$.select.value, 'laborcode':labor});
		};

		var _undo = function(overlayNode) {	
			self.$.worklinks1.hidden = false;
		};
		
		$M.notify(startMessage, $M.alerts.info, _timerExpired, _undo);
		
		self.$.worklinks1.hidden = true;
		self.$.selectWorkType.hidden = true;
		self.$.overlayDiv.hidden = false;
	},
	
	/**
	 * Finish Assignment
	 */
	_noStopOnly : function() {	
			
		var self = this;
		var wonum = this.record.wonum;		
		var userInfo = $M.getUserInfo();
		if(!userInfo || !userInfo.labor){
			var technicianCard = this;
			this.async(function(){
				technicianCard._showStart();
			}, 200);
			return;
		}
	
		var userLaborCode = userInfo.labor.laborcode;		
		var labtranstimerstatus = self.record.labtranstimerstatus;
		var starttime = '';
		var startdate = '';
		if(labtranstimerstatus){
			if(labtranstimerstatus.length>0){
				labtranstimerstatus.forEach(function(member){
					if(member.laborcode===userLaborCode){					
						starttime = member.starttimeentered_localized;
						startdate = member.startdateentered_localized;
					}
				});
			}else{
				starttime = labtranstimerstatus.starttimeentered;
				startdate = labtranstimerstatus.startdateentered;
			}
		}
		self.$.yesOrNoDiv.hidden = true;
		
		if (self.labtransData && self.labtransData.member[0].confirmlabtrans==='1') {
			
			self.$.setDateTime.hidden = false;
					
			var timeformat = $M.getMaxauth().whoami.timeformat;
			var dateFormat = $M.getMaxauth().whoami.dateformat.toUpperCase();
			$M.getServerDateTime().then(function(response){
				if($M.isMobile()){
					self.startTime = moment(starttime,timeformat).format('HH:mm');
					self.startDate = moment(startdate, dateFormat).format('YYYY-MM-DD');
					self.stopTime = moment(response.time,timeformat).format('HH:mm');
					self.stopDate = moment(response.datetime, dateFormat).format('YYYY-MM-DD');
				} else {
					self.startTime = starttime;
					self.startDate = startdate;
					self.stopTime = response.time.toUpperCase();
					self.stopDate = moment(response.datetime, dateFormat).format(dateFormat);
				}

			});	
		} else {
		
			self.$.setDateTime.hidden = true;				
			self._stopAssignment();
		
		};
	},
		
	_stopAssignment : function() {
		$M.toggleWait(true);
		var self = this;
		var card = this.$.undoOverlayDiv;
		var wonum = this.record.wonum;
		var worktype = this.record.worktype;
		var stopMessage = $M.localize('uitext','mxapiwodetail','woStatusStop',[(worktype && !this.record.istask?worktype:''),wonum]);		
		var _timerExpired = function(overlayNode) {
			self.fire('stopAssignment', self.record, self.startTime, self.startDate, self.stopTime, self.stopDate)};

		var _undo = function(overlayNode) {
			self.$.worklinks2.hidden = false;
			$M.toggleWait(false);
		};
		
		$M.notify(stopMessage, $M.alerts.info, _timerExpired, _undo);
		self.$.worklinks2.hidden = true;
		self.$.overlayDiv.hidden = false;
		self.$.setDateTime.hidden = true;
		
	},
	
	_confirmHandler : function() {
		$M.toggleWait(false);
	},
	
	_confirmErrorHandler : function(e) {
		var error = e.detail.error;
		$M.notify(error.message, $M.alerts.error);
		$M.showResponseError(error);
		$M.toggleWait(false);
	},
	
	switchContent: function(event) {
		var curIdArray = event.currentTarget.id.split('_');
		var sectionId = 'section_' + curIdArray[curIdArray.length-1];
		
		if(sectionId === 'section_details'){
			this.disableActions = false;
			this.toggleHeaderActionsVisibility = false;
			this.fire('handleMobileActionFooterNav');
		} else {
			this.disableActions = true;
			this.toggleHeaderActionsVisibility = true;
			this.fire('loadButtons');
		}
		
		var currentTab = this._showHideSection(sectionId);
		//set the color of the current tab's parent to the color of the tab.  This ensures the entire page is same color
		var tabColor = currentTab.style.backgroundColor;
		$j(this).parent().parent().css({'background': tabColor});
		this._currentTab = sectionId;
	},
	
	_showHideSection: function(sectionName) {
		this.addContent(sectionName);
		var currentList;
		$j(this.$.maincontainer).children('div').each(function(index, elem) {
			if (elem.id.indexOf(sectionName) > -1) {
				currentList = this;
			}
			$j(this).hide();
		});
		
		if(sectionName==='section_comments'){
			this.getCommentsComponent()._loadComments();
			//if($M.screenInfo.device !== 'desktop'){  // show keyboard when not on desktop
		}
		
		if(sectionName==='section_plans'){
			this.getPlansComponent()._firstLoad = true;
			var sectionName = 'section_tasks';
			if(this.record.istask){
				sectionName = 'section_materials';
			}
			this.getPlansComponent()._showHideSection(sectionName);
		}
		
		if(sectionName==='section_inspections'){
            this.getInspectionsComponent().loadInspections();
        }
		
		if(sectionName==='section_attachments'){
			this._hideAddattachmentAndDeleteButton();
			this.domHost._loadAttachments(this.recordLight);
			this.showHideDeleteBtn();
        }
		
		if(sectionName === 'section_macmosaic'){
		  	this._getSessionDetailRequest();
		}
		
		
		$j(currentList).show();
		return currentList;
	},
	
	_goBack: function(e){
		$M.toggleWait(true);
		if(this.recordLight && this.backStack.length){
	   		this.recordLight = this.backStack.pop();
		}else {
			if(this.createWO && !this.tempRecordClean){
				this._showYNC();
			}else{
				this._currentTab='';
				this.$.contentSelector.select(0);
				this.fire('goback');
				if(this.$.wopriority){
					this.$.wopriority.emptyRecord = false;
				}
				setTimeout(function(){
					$M.toggleWait(false);					
				},50);
			}
		}
	},
	
	_isChecked: function(val){
		if (val){
			return true;
		}
		return false;
	},
	
	/**
	 * Load the attachments to the details, using the temp array helps polymer knows the set underlying array changed
	 */
	_loadAttachments: function(){
		//Check isAborted property before invoking _abortUpload() since this function invokes when user upload, delete or cancel attachment.
		var self = this;
		this.async(function(){
			if(self.isAborted === true){
				self._abortUpload();
			}
		},300);
		this._buildImagesArray(this._attachments);
		this.showHideDeleteBtn();
	},

	/**
	 * Listen response from dialog
	 */
	_deleteFile : function(e) {
		this.$.attachmentResource.deleteAttachment(e.detail[1]);
		this.$.section_attachments.querySelector('maximo-file-carousel').enableButtons();
	},
	
	/**
	 * After the file was deleted we need to remove it from the local array of files and refresh the array so the ui will pick up the change.
	 */
	_handleAttachmentDeleted : function(jsonResponse){
		var delUrl = jsonResponse.detail.url;
		var members = this._attachments;
		
		for(var i=0; i< members.length; i++){
			if(members[i].href === delUrl){
				this._attachments.splice(i, 1);
				this._loadAttachments();
				break;
			}
		}		
	},
	
	_formatTime: function (seconds) {
	    var date = new Date(seconds * 1000),
	        days = Math.floor(seconds / 86400);
	    days = days ? days + 'd ' : '';
	    return days +
	        ('0' + date.getUTCHours()).slice(-2) + 'h:' +
	        ('0' + date.getUTCMinutes()).slice(-2) + 'm:' +
	        ('0' + date.getUTCSeconds()).slice(-2) + 's';
	},

	_getDirection : function(wl){
		if(wl.createby === $M.userInfo.personid){
			return false;
		} else if (this.record && (wl.createby === this.record.reportedby)) {
			return false;
		} else if (this.record && (wl.createby === this.record.affectedperson)) {
			return false;
		}
		else {
			return true;
		}
	},
	_getDescription: function(wl) {
		if (wl.description_longdescription && wl.description_longdescription.length !== 0) {
			return wl.description_longdescription;
		} else if (wl.description && wl.description.length !== 0) {
			return wl.description;
		}
		return '';
	},
	_getMessageWidth : function(){
		return '500px';// (parseInt(this.querySelector('.commentPanel').offsetWidth) - 112) + 'px'; 
	},
	resetContentSelectorDefault : function(){
		this.$.contentSelector.select(0);
	},
	
	/**
	 * Handle the hide view more option to display once the detail page is loaded.
	 */
	_hideViewMoreDisplay: function(e){
		this.$.description._hideViewMoreDisplay();
	},
	
	/** 
	 * apply any edits made to the record 
	 */
	_applyEdits: function(e){
		if(this.createWO){
			this._setCachedValue(e);
			return;
		}
		switch(e.detail.dataset.scopeId){
			case 'statusTile':
				this.changeWOStatus(e.target, this.collection);
				this.domHost._refreshCurrentCompAll(e);
				break;
			case 'assetimg':
				this._updateWO({'assetnum': e.target.value}, this.collection, true,e.target,true);
				break;
			case 'locationimg':
				var self = this;
				this._updateWO({'location': e.target.value}, this.collection, true,e.target,true).then(function(result){
		          	if(result && result.response && result.response.location && result.response.location.saddresscode){
						//Update WO's service address with location
		          		var fakeEvent = {detail:{serviceaddress:result.response.location.serviceaddress}}
		          		self.updateServiceAddress(fakeEvent);
		          	}
		     	 });
				break;
            case 'schedstart':
            	 var schedstart=e.target.value;
                 var schedstartdata={'schedstart':schedstart};
                 this._updateWODates(new Date(this.$.schedfinish.value),schedstart,schedstartdata,'schedstart');
                 break; 
            case 'schedfinish':
            	var schedfinish=e.target.value;
                 var schedfinishdata={'schedfinish':schedfinish};
                 this._updateWODates(schedfinish,new Date(this.$.schedstart.value),schedfinishdata,'schedfinish');
                 break;
            case 'targstartdate':
                this._updateWO({'targstartdate': e.target.value}, this.collection);
                break;
            case 'targcompdate':
                this._updateWO({'targcompdate': e.target.value}, this.collection);
                break;
            case 'durationTile':
            	this.async(function(){
                    this._updateWO({'estdur': e.target.value}, this.collection);
    			}, 100);
                break;
            case 'workfailure':
            	var failurecode = (e.target.value === this.record.failure.description) ? this.record.failure.failurecode : e.target.value;
            	this._updateWO({'failurecode': failurecode}, this.collection,false,e.target,true);
	            break;
            case 'workproblem':
            	if(this.$.workproblem.value === ''){
					this.record.problemcode = this.$.workproblem.value;
				}
            	var problemcode = (e.target.value === this.record.problem.description) ? this.record.problemcode : e.target.value;
	            this._updateWO({'problemcode': problemcode}, this.collection,false,e.target,true);
	            break;
            case 'slider_tile':  
				this._changeAssetStatus(e);
				break;
            case 'worktype':
                var dataToUpdate = {'worktype': e.target.value};
                this._updateWO(dataToUpdate, this.collection);
                break;
            case 'wopriority':
                var dataToUpdate = {'wopriority': e.target.value};
                this._updateWO(dataToUpdate, this.collection);
                break;
            case 'serviceAddress':
            	if(e.detail.value=== ''){
                    this.record.serviceaddress.saddresscode = ''; //remove service address
                }
            	this._updateWO({'saddresscode':this.record.serviceaddress.saddresscode}, this.collection,undefined,undefined,true,'serviceaddress');
            	break;
		}
	},
		
	/**
     * update the current record with the new record selected 
     */
	_navigatorRecordUpdate: function(event) {
		this.SKIP_REFRESH_TILES=false;
	    var newLightRec = event.detail.record;
	    
//	    if (this.record === newLightRec) {
//	        return;
//	    }
	    
	    //Not used
		//this.fire('recordChanged', newLightRec);	
		this.recordLight = newLightRec;

		if(this._currentTab==='section_comments'){
			this.getCommentsComponent()._loadComments();
		}
		
		if(this._currentTab==='section_plans'){
			this.getPlansComponent().loadPlanData();
		}
		
		if(this._currentTab==='section_inspections'){
            this.getInspectionsComponent().loadInspections();
        }
		
		if(this._currentTab==='section_attachments'){
			this.fire('reloadAttachments',{'record': newLightRec});
			this._hideAddattachmentAndDeleteButton();
		}
	},
	
	/**
	 * woresource mx-resource 
	 * loadRecord success callback
	 */
	_recordLoadSuccessHandler: function(event) {
		this.SKIP_REFRESH_TILES=false;
	    this.setRecord();
	    $M.toggleWait(false);
	},
	
	/**
     * woresource mx-resource 
     * loadRecord error callback
     */
	_recordLoadErrorHandler: function(event) {
	    $M.toggleWait(false);
    },
    
    /**
     * woresource mx-resource 
     * updateRecord success callback
     */
    _recordUpdateSuccessHandler: function(event) {
    	this.SKIP_REFRESH_TILES=false;
        this.setRecord();
    },
    
    /**
     * woresource mx-resource 
     * updateRecord error callback
     */
    _recordUpdateErrorHandler: function(event) {
        //TODO 
    },
    
    /**
     * Set record property
     * using resourceData from woresource mx-resource 
     */
    setRecord: function(record) {
        var record = this.$.woresource.resourceData;
        if(record.wopriority === undefined){
	  		this.$.wopriority.emptyRecord = true;
	  	} else {
	  		this.$.wopriority.emptyRecord = false;
	  	}
        if(record && record.labtrnallowanycrft && !sessionStorage.getItem('allowanycraft')){
              sessionStorage.setItem('allowanycraft', record.labtrnallowanycrft);
        }
        if(this.record && (this.record.status_maxvalue ==='CLOSE' || this.record.status_maxvalue ==='CAN')){
  	    	$j('.workfailureTile').find('.actionLabel, .iron-icon').css({'color':this.getComputedStyleValue('--Primary-gray50'),'fill':this.getComputedStyleValue('--Primary-gray50')}); 
  	    } else {
  	    	$j('.workfailureTile').find('.actionLabel, .iron-icon').css({'color':this.getComputedStyleValue('--Primary-blue50'),'fill':this.getComputedStyleValue('--Primary-blue50')});
  	    }
        if(this.sourcePage === 'create'){
        	this.cachedRecord['location'] = (record.location)?record.location:'';
        	Object.assign(record,this.cachedRecord);
	   		this.record = this.addAuxiliarObject(record);
	   	} else if(record){
	        this.record = this.addAuxiliarObject(record);
	   	}
        if(!this.$.siteidTile.value){
   			this.$.siteidTile.value = $M.userInfo.defaultSiteDescription;
   		}
        if(!this.createWO){
        	this.serviceAddressURI = record.href+'/serviceaddress/zombie';
        }
    },
	
	/**
	 * Report Work eventlistener triggered from Report Work action on detail page.
	 */
	_reportWork : function(e){
		// reset the page height when tour happens
		// to cater the blue space issue at bottom
		var tourCanvasElem = $M.$.tourController.$.tourCanvas;
		if(tourCanvasElem.height && tourCanvasElem.height > window.innerHeight){
			tourCanvasElem.height = window.innerHeight;
			tourCanvasElem.style.height = window.innerHeight + 'px';
		}
		this.record.ltTypeSet=this.ltTypeSet;
		this.record.isWorkOrderComp=this.isWorkOrderComp;
		this.fire('reportWork',this.record);
	},
	
	_compReportWork : function(e){
		this.record.ltTypeSet=this.ltTypeSet;
		this._offYesOrNoDiv();
		this.record.isWorkOrderComp=true;
		this.fire('reportWorkFromCard',this.record);
	},

	/**
	 * Show/Hide the Start link.
	 */
	_showStart : function(wo){
		var showStart = this.isAuthorized('MXAPIWODETAIL:STARTTIMER');
		if(!showStart || this.createWO){
			console.log('access denied for Start Work');
			return true;
		}
		
		if (!wo) {
			wo = this.record;
		}
		var userInfo = $M.getUserInfo();
		if(!userInfo || !userInfo.labor){
			var technicianCard = this;
			this.async(function(){
				technicianCard._showStart();
			}, 200);
			return;
		}
		var userLaborCode = userInfo.labor.laborcode;
		var craft = userInfo.labor.laborcraftrate.laborcode;		
		var userLabtrans=[];
		var labtransStatus='';
		if(wo.labtranstimerstatus){
			if(wo.labtranstimerstatus.length>0){
				wo.labtranstimerstatus.forEach(function(member){
					if(member.laborcode===userLaborCode){
						labtransStatus='ACTIVE';
					}
				});
			}
			else{
				labtransStatus=wo.labtranstimerstatus.timerstatus_maxvalue;
			}
		}
				if((((wo.status_maxvalue==='INPRG' || wo.status_maxvalue !== 'WAPPR' && wo.status_maxvalue !== 'COMP' && wo.status_maxvalue !== 'CAN'  && wo.status_maxvalue !== 'CLOSE') && (labtransStatus !== 'ACTIVE'))) && (userLaborCode !== undefined) && (craft !== undefined)){
				return false;
			} else {
				return true;
			}				
	},
	
	/**
	 * Show/Hide the Report Actuals link.
	 */
	_showReportWork : function(wo){
		if(!(this.isAuthorized('REPORT_TIME') || this.isAuthorized('REPORT_FAILURES')|| this.isAuthorized('REPORT_MATERIAL'))){
			console.log('access denied for Report Work');	
			return true
		}
		
		if(this.record.status_maxvalue==='APPR' || this.record.status_maxvalue==='INPRG' || this.record.status_maxvalue==='COMP' || this.record.status_maxvalue==='WPCOND' || this.record.status_maxvalue==='WSCH' || this.record.status_maxvalue=='WMATL'){	
			return false;			
		} else {
			return true;
		}
				
	},
	
	/**
	 * Show the Report Actuals when status is in any of the following states:
	 * APPR,COMP,WMTL,WPCOND,WSCH
	 */
	_showReportActuals : function(maxstatus){
		if(maxstatus==='APPR' || maxstatus==='INPRG' || maxstatus==='COMP' || maxstatus==='WMATL' || maxstatus==='WPCOND' || maxstatus==='WSCH'){
			this.disableActions = false;
			return 'block';
		} 
		this.disableActions = true;
		return 'none';
	},
	
	
	/**
	 * Show/Hide the Complete link.
	 */
	_showStop : function(wo){
		var showStop = this.isAuthorized('MXAPIWODETAIL:STOPTIMER');
		if(!showStop){
			console.log('access denied for Stop Work');	
			return true;
		}
		if (!wo) {
			wo = this.record;
		}
		var userInfo = $M.getUserInfo();
		if(!userInfo || !userInfo.labor){
			var technicianCard = this;
			this.async(function(){
				technicianCard._showStop();
			}, 200);
			return;
		}
		var userLaborCode = userInfo.labor.laborcode;
		var userLabtrans=[];
		var labtransStatus='';
		if(wo && wo.labtranstimerstatus){
			if(wo.labtranstimerstatus.length>0){
				wo.labtranstimerstatus.forEach(function(member){
					if(member.laborcode===userLaborCode){
						labtransStatus='ACTIVE';
					}
				});
			}
			else{
				labtransStatus=wo.labtranstimerstatus.timerstatus_maxvalue;
			}
		}
			
		if( (wo.status_maxvalue==='INPRG' || wo.status_maxvalue !== 'WAPPR' && wo.status_maxvalue !== 'CAN') && (labtransStatus === 'ACTIVE')){
				return false;			
		} else {
				return true;
		}	
	},	
	
    /**
	 * Handle the hide/show  long description line.
	 */
	_hideLongdescription : function(record){
		if(record){
			return (record.description_longdescription == undefined || record.description_longdescription.length == 0); 
		} 
		
		return true;
	},
	
	
	/**
	 * To undo edit tile.
	 */
	refreshTiles : function(){
		if (this.SKIP_REFRESH_TILES){
			return false;
		}
		$j(this).find('maximo-tile').each(function(){
    		 this.cancelEditMode();
		});
		
   		$j(this.$.meterTile).toggleClass('hideTile', true);	
   		
   		if(this.record){
   		   $j(this.$.assetDowntimeTile).toggleClass('hideTile',  this._isValueBlank(this.record.assetnum) );	
         
   		   if(this.record && this._isValueBlank(this.record.location) && this._isValueBlank(this.record.assetnum)){
   			  $j(this.$.meterTile).toggleClass('hideTile', true);	
 		   }else{
 				var maximoQbe;
 				var qbeObject;
 				var self = this;
 				this.assetFlag = false;
 				this.locationFlag = false;
 				
 				this.SKIP_REFRESH_TILES=this.record.assetnum?true:false;
 				if (this.record.assetnum) {
 					maximoQbe = new MaximoQbe();
 	 				maximoQbe.setEquals('active','true').setEquals('assetnum',this.record.assetnum);
 	 				this.$.assetMeterCollection.searchAttributes = this.record.assetnum;
 	 				qbeObject = maximoQbe.toJSON();
 					this.$.assetMeterCollection.queryWhere = qbeObject;
 					this.$.assetMeterCollection.refreshRecords();
 					if(this.record.asset && this.record.asset.length>0){
 					this.meterHref = this.record.asset[0].href;
 					}
 					this.assetFlag = true;
 				}
 				
 				if (this.record.location && this.record.location.location) {
 					maximoQbe = new MaximoQbe();
 					maximoQbe.setEquals('active','true').setEquals('location',this.record.$alias_this_attr$location);
 	 				this.$.locationMeterCollection.searchAttributes = this.record.$alias_this_attr$location;
 	 				qbeObject = maximoQbe.toJSON();
 					this.$.locationMeterCollection.queryWhere = qbeObject;
 					this.$.locationMeterCollection.refreshRecords();
 					this.locationFlag = true;
 				}
 		   }	 
 				
        }
   		   
   		if((this.record.status_maxvalue === 'CLOSE') || (this.record.status_maxvalue === 'CAN')){
   			if(this.assetMeterCount > 0){
   				this.$.assetMeterTileTable.enableAdd= false;
	   			this.$.assetMeterTileTable.customActions = true;
	   			this.$.assetMeterTileTable._updateActionTable();
   			}
   			if(this.locationMeterCount > 0){
   				this.$.locationMeterTileTable.enableAdd= false;
	   			this.$.locationMeterTileTable.customActions = true;
	   			this.$.locationMeterTileTable._updateActionTable();	
   			}
   		} else {
   			if(this.assetMeterCount > 0){
	   			this.$.assetMeterTileTable.enableAdd= true;
	   			this.$.assetMeterTileTable._updateActionTable();
   			}
   			if(this.locationMeterCount > 0){
   				this.$.locationMeterTileTable.enableAdd= true;
	   			this.$.locationMeterTileTable._updateActionTable();	
   			}
   		}
   		
   		//Set URI for service address lookup 
		this.serviceAddressURI =  this.record.href+'/serviceaddress/zombie';
   	},
	  
	  /**
	  * show enter meter readings tile
	  */
	 _handleLocationMeterRefreshed: function(e)
	 {
		if(this.$.locationMeterCollection.totalCount > 0){
			$j(this.$.meterTile).toggleClass('hideTile', false);
			this.locationFlag = true;
			if(this.$.locationMeterCollection.collectionData !== undefined){
	 			this.$.locationMeterCollection.collectionData.forEach(function(record,index){
	 				if(record.meter.metertype==='CHARACTERISTIC'){
	 					if(record.locationmeterdomain && record.locationmeterdomain.description){
		 					record.readingmeasure = record.locationmeterdomain.description;
		 				} else {
		 					record.readingmeasure = record.locationmeterdomain.value;
		 				}
	 				} else {
	 					if(record.lastreading){
	 						if(record.meter.measureunitid){
		 						record.readingmeasure = record.lastreading+' '+record.meter.measureunitid;
		 					} else {
		 						record.readingmeasure = record.lastreading;
		 					}
						} else {
							record.readingmeasure = null;
						}
	 				}
	 				if(!record.meter.description){
	 					record.meter.description = record.metername;
	 				}
	 				record.index = index;
	 		  });
	 		}
		 } else {
			   this.locationFlag = false;
		    }
	 },
	
	 /**
	 * show enter meter readings tile
	 */
	_handleAssetMeterRefreshed: function(e)
	{
		if(this.$.assetMeterCollection.totalCount > 0){
			$j(this.$.meterTile).toggleClass('hideTile', false);
			this.assetFlag = true;
			if(this.$.assetMeterCollection.collectionData !== undefined){
	 			this.$.assetMeterCollection.collectionData.forEach(function(record,index){
	 				if(record.meter.metertype==='CHARACTERISTIC'){
	 					if(record.assetmeterdomain && record.assetmeterdomain.description){
	 						record.readingmeasure = record.assetmeterdomain.description;
	 					} else {
	 						record.readingmeasure = record.assetmeterdomain.value;
	 					}
	 				} else {
		 				if(record.previousreading){
			 				if(record.meter.measureunitid){
		 						record.readingmeasure = record.previousreading+' '+record.meter.measureunitid;
		 					} else {
		 						record.readingmeasure = record.previousreading;
		 					}
		 				} else {
		 					record.readingmeasure = null;
		 				}
	 				}
	 				if(!record.meter.description){
	 					record.meter.description = record.metername;
	 				}
	 				record.index = index;
	 		  })
	 		}
		} else {
			   this.assetFlag = false;
		   }
	},
		
	
	/**
	 * Collection error
	 */
	_handleError: function (e) {
		var error = e.detail.Error;
		if(error) {
			$M.notify(error.message, $M.alerts.error);
		}
	},
	
	
	/**
	 * Parse domains to create key:description string array for Drop Down
	 */
	_domainList : function(record){
		var self = this;
		var worktypes = record;
		var externalValues=[];
			if(worktypes.length>0){
				worktypes.forEach(function(member){
					if(member.maxvalue==='WORK'){
						externalValues.push(member.value+':'+member.description);
						if(member.valueid==='LTTYPE|WORK'){
							self.$.select.value = 'WORK';
						}
					}
				});
			}
			return externalValues.toString();
	},

	/**
	 * On Closed Work, upload/delete attachments are disabled.
	 */
	_hideAddattachmentAndDeleteButton : function(){
		if(this.record.status_maxvalue === 'CLOSE' || this.record.status_maxvalue === 'CAN'){
			this.$.section_attachments.querySelector('maximo-file-carousel').closedWO();
			this.$.section_attachments.querySelector('maximo-file-upload').disable();
			$j(this.$.section_attachments).find('.controlButton maximo-button').prop('disabled',true);
		}else {
			this.$.section_attachments.querySelector('maximo-file-carousel').disableDeletion();
			this.$.section_attachments.querySelector('maximo-file-upload').enable();
			$j(this.$.section_attachments).find('.controlButton maximo-button').prop('disabled',false);
		}
	},
	
	/**
	 * Check for readonly flag for tile 
	 */
	_getReadonlyFlag : function(status){	
		
		if(status==='CLOSE' || status==='CAN'){
			return true;
		}else {
			var showChangeSatus = this.isAuthorized('MXAPIWODETAIL:STATUS');
			if(!showChangeSatus){
				console.log('access denied for WO Change Status');	
			}
			$j(this.$.section_details).find('maximo-badge-tile').each(function(currenttile){ 
				if(this.id==='technicianmain_techWODetail_statusTile' && showChangeSatus){
					this.setAttribute('editable','true');
				}
			});
		}
		return false;
	},
	
	/**
	 * Set editable attributed when status is changed
	 */
	_statusChanged: function (e){
	    this.recordLight = this.record;
		var self = this;
		$j(this.$.section_details).find('maximo-badge-tile').each(function(){
			if(self.record && self.record.status_maxvalue==='CLOSE' ){
				if(this.id==='technicianmain_techWODetail_statusTile' ){
					this.removeAttribute('editable'); 
				}			
			}
		});
		this.fire('updateFooter','details');
	},
	
	/**
	 * Observer for recordLight
	 * Loads full attributes into record 
	 * from mx-resource
	 */
	_loadDetailedRecord: function(newV, oldV) {
		if(this.createWO){
			return;
		}
		if(!this.createWO){
		    if (newV && newV.href) {
		        this.$.woresource.resourceUri = newV.href;
		        var self = this;
		        this.$.woresource.loadRecord().then(function(result) {
		        	if(result && result.asset && result.asset[0]){
		        		self.meterHref = result.asset[0].href;
		        	}
		        	self._loadRelatedRecordsWO();
		        });
		        $M.toggleWait(true);
		    }
		}
	},
	
	/**
	 * Auto save when a record is selected from look up.
	 */
    _applyEditLookUpSelected : function(e)
    {    	
    	if(e.target.dataHost && e.target.dataHost.dataset && e.target.dataHost.dataset.scopeId==='slider_tile'){
    		if(e.detail.records && e.detail.records.length === 1){
    			this.datalabel=e.detail.records[0].value;
    			e.target.value=e.detail.records[0].description;
    		}
    	}
    	//bypass auto-save for status
    	if(e.target.id && e.target.id.indexOf('statusTile')>-1 || e.target.id.indexOf('slider_tile')>-1) {
    		 return; 
    	}
    	if((e.detail && e.detail.identifier === 'newreading') || e.target.dataset.scopeId === 'meterinfo'){
    		return;
    	}
    	if(e.target.id && e.target.id.includes('serviceAddress')){
        	e.target.value = this.getServiceAddress(this.record);
        }
    	var outerTile = $j(e.target).closest('maximo-tile');
    	if(outerTile && outerTile.length) {
    		var innerTile = outerTile.find('.inner-tile');
    		if(innerTile && innerTile.length) {
    			if(innerTile[0].nodeName === 'MAXIMO-TABLE-TILE') {
    				this._applyEdits(e);
    			} else if(e.target._applyEdit){
                    e.target._applyEdit(e);
                } else {
                    e.target.domHost._applyEdit(e);
                }
    		}
    	}
    },
    
    /**
     *  Function will invoke createFollowUp function in order to create follow-up workorder.
     */
	_createFollowupWorkorder : function(e){
		var self = this;
		this._createFollowupWO().then(function(reponse){
			self.async(function(){
					self._loadRelatedRecordsWO();
				},300);
			},function(error){
				$M.showResponseError(error);
				$M.toggleWait(false);
			});
		},
 
	/**
	 *  Check if any of the originating record has values.
	 */
	_isOrgRecordEmpty: function(record){
		var origrecdDescval= this._getOrigDesc(record);
		return (record.origrecordclass || record.origrecordid || origrecdDescval )?true : false;
	},
	/** 
	 *	Fetch description of records of different types in work order.
	 */
	_getOrigDesc: function(record){
		return (!$j.isEmptyObject(record.origticket))?record.origticket.description : (!$j.isEmptyObject(record.origwo))?record.origwo.description : '';
	},
	
    /**
     *  Gets the label for revision number for JP
     *  it will be empty when jpprevnum is null  
     */
    getPluscJprevnum : function(pluscjprevnum){
    	if(pluscjprevnum){
    		return $M.localize('uitext', 'mxapiwodetail','jprevision',[pluscjprevnum]);	
    	}else {
    		if(pluscjprevnum===0){
    			return $M.localize('uitext', 'mxapiwodetail','jprevision',['0']);
    		}
    	}
    },
    
    /**
	 * Check for failure class flag to display edit icon or not. 
	 */
	_isProblemTileEditable : function(record){
		if(record.status_maxvalue === 'CLOSE' || record.status_maxvalue === 'CAN' || !record.failurecode){
			return false;
		}else {
			return this.isAuthorized('REPORT_FAILURES');
		}
	},
	
	/**
	 * Check for failure class flag to display edit icon or not. 
	 */
	_editFailureTileEditable : function(record){
		if(!this.isAuthorized('REPORT_FAILURES')){
			return false;
		}
		return  !this._getReadonlyFlag(record.status_maxvalue);
	},
	
	/*
     * If a record is saved in the tpae iframe and it matches the current record, we need to refresh it.
     */
    _recordChangedFromIframe: function(e){
   	 if(this.$.mainPage.offsetHeight > 0){ //is this page displayed?
   	 	if(e.detail.uniqueid === this.record.workorderid && e.detail.mbo === 'WORKORDER'){ //was modified record the same as current?
   	 		this.$.woresource.loadRecord();
   	 	}
   	 }
    },	
    /**
	 * Updating the existing asset meter details. 
	 */
	_saveMeterDetails : function(e){
		var meterObj ={};
		meterObj = e.detail.record;
		meterObj._action = 'Update';
		var responseProperties = '*';
		var self = this;
		
		if(e.detail.record.location){
			this.$.locationresource.resourceUri = e.detail.href;
			
			this.$.locationresource.updateRecord(meterObj, responseProperties, true)
	        .then(function(result) {
	            self.$.locationMeterCollection.refreshRecords();
	        	$M.toggleWait(false);
	        	self.$.locationMeterTileTable._applyEdit(e);
	        }, function(error) {
	            $M.toggleWait(false);
	            $M.showResponseError(error);
	        });
		} else {
			var meterList = [];
			meterList.push(meterObj);
			this.$.assetresource.resourceUri = this.meterHref+'/int_assetmeter';
			this.$.assetresource.updateRecord(meterList, responseProperties, true)
	        .then(function(result) {
	            self.$.assetMeterCollection.refreshRecords();
	        	$M.toggleWait(false);
	        	self.$.assetMeterTileTable._applyEdit(e);
	        }, function(error) {
	            $M.toggleWait(false);
	            $M.showResponseError(error);
	        });
		}
	},
	/**
	 * Update slider tile
	 */
	_updateSliderTile : function(record) {
		if(record.asset){
			var isrunning = record.isrunning;
		}
		var tile = this.$.slider_tile;
		if (this.record.asset){
 			this.record.isrunning=isrunning;
 		}		
		if (isrunning) {
			if(record.moddowntimehist && record.moddowntimehist.length>0){
				tile.$.upDownIcon.icon='Maximo:Arrow2-Forward';
				tile.fillcolor='#4B8400';
			}else{
				tile.$.upDownIcon.icon=null;
			}
			tile.$.sliderCheckbox.classList.remove('red');
			tile.$.sliderCheckbox.classList.add('green');
			$j(tile.$.sliderCheckbox).attr('checked', true);
		} else {
			if(record.moddowntimehist && record.moddowntimehist.length>0){
				tile.$.upDownIcon.icon='Maximo:Arrow2-Down';
				tile.fillcolor='#D74108';
			}else{
				tile.$.upDownIcon.icon=null;
			}
			tile.$.sliderCheckbox.classList.remove('green');
			tile.$.sliderCheckbox.classList.add('red');
			$j(tile.$.sliderCheckbox).attr('checked', false);
		}
		if(this.$.assetimg && this.$.assetimg.value){
			return tile.value = tile.$.sliderCheckbox.checked;
		}else{
			return tile.value = null;
		}
	},
	 /**
		 * Change asset status
		 */
	 _changeAssetStatus:function(e){
		var self = this;
		$M.toggleWait(true); 
		var tile=e.target;
		var downTime = {};
		downTime.statuschangedate=tile.dateValue;
 		downTime.statuschangecode=this.datalabel;
		downTime.operational='1';
		var responseProperties = 'statuschangedate,statuschangecode,isrunning,statuschangedate_localized';
       this.$.woresource.updateAction('wsmethod:downtimereport', downTime, responseProperties)
        .then(function(result) {
        	self.reloadCurrentRecord();
        	self.record.isrunning = result.response.isrunning;
        	self._updateSliderTile(self.record);
        	self.datalabel=null;
            $M.toggleWait(false);
       }, function(error) {
    	   if(self.record){
       			self._handleErrorDowntime(self.record);
       		}
    	    tile._editTile();
            $M.toggleWait(false);
            $M.showResponseError(error);
       });
	},
	/**
	 * Update Date value
	 */
	_updateDate: function(downtime){
		 var self = this;
		 if(downtime && downtime.length>0){
			 if(downtime[0].enddate){
				 return downtime[0].enddate_localized;
			 }else {
				 return downtime[0].startdate_localized;
			 }
		 }else{
			 return this.$.slider_tile.dateValue =null;
			 
		 }
	 },
	 /**
	  * Update code value
	  */
	 _updateCode: function(downtime){
		 if (downtime && downtime.length > 0 && !this.record.isrunning) {
			this.$.slider_tile.$.backtext.value = downtime[0].startcode_description;
			return downtime[0].startcode_description;
		} else {
			this.$.slider_tile.$.backtext.value = null;
			return '';
		}
	 },
	 /**
	  * Update lookup default value.
	  */
	 _setBackFaceValue: function(e){
		this._updateCode(this.record.moddowntimehist); 
	 },
	 /**
	  * reload the current resource record.
	  */
	 reloadCurrentRecord: function(){
		 var self=this;
		 this.$.woresource.loadRecord().then(function(result) {
			self.record=result;
		});
		$M.toggleWait(true);
	 },
	 /**
	  * Handle values on error and reset the values to previous
	  */
	 _handleErrorDowntime: function(downtime){
		 var self = this;
		 if(downtime && downtime.moddowntimehist && downtime.moddowntimehist.length>0){
     		if(downtime.moddowntimehist[0].endcode || downtime.moddowntimehist[0].enddate){
				 	this.$.slider_tile.textValue = downtime.moddowntimehist[0].endcode_description;
				 	this.$.slider_tile.dateValue = downtime.moddowntimehist[0].enddate_localized;
	   		}else{
	   				this.$.slider_tile.textValue = downtime.moddowntimehist[0].startcode_description;
	   				this.$.slider_tile.dateValue = downtime.moddowntimehist[0].startdate_localized;
	   			 }
     	}else{
     		this.$.slider_tile.textValue = null;
     		this.$.slider_tile.dateValue = null;
     	}
	 },
	 /**
	  * Hide the attachment delete button and label when there is not attachment exist.
	  */
	 showHideDeleteBtn: function(){
		if(this._attachments.length > 0){
			$j('#detailsCarousel_deleteIcon').show();
			$j('.bottomButtonsWrapper ').show();
		}else{
			$j('#detailsCarousel_deleteIcon').hide();
			$j('.bottomButtonsWrapper ').hide();
		}
	 },
	 
	 /**
	  * Make slider tile readonly when in status_maxvalue ='CLOSE' 
	  */
	 _isSliderTileEditable: function(status){
		 if(status === 'CLOSE'){
			return false;
		 }else {
			return true;
		}
	 },
    
	/* EA related implementation */
	/**
	 * Set the visible of 'Seek Advise' button
	 */
	_setHideEAButton: function() {
		if (this._EAUrl && this.EAApiKey && this._EAUrl.length > 0 && this.EAApiKey.length > 0) {
			// if EAM Augmented Collaboration also exists and isMobile = true, show the combined Seek Advise button
			if ($M.getSigoptions().LCAUGCOLLAB && $M.isMobile()) {
				this.$.AugCollabEAQueryTile.hidden = false;
			} else {
				this.$.EAQueryTile.hidden = false;
			}
			return;
		}
		// if EAM Augmented Collaboration exists, and EMA does not and user is on a mobile device, show the Aug Collab Seek Advise button
		if ($M.getSigoptions().LCAUGCOLLAB && $M.isMobile()) {
			this.$.AugCollabTile.hidden = false;
		}
		this.$.EAQueryTile.hidden = true;
	},

	/**
	 * Get token from EA and open the EA page
	 */
	_linkToEAQuery: function() {
	    this.set('eaTokenUrl', $M.getMaxauth().baseUri + '/oslc/service/workorder?action=wsmethod:getEAToken');
	    var self = this;
	    this.$.getEAToken.loadRecord().then(function(result){
	        self.EAToken = self.tokenInfo.token;
	        self.$.EAQueryForm.submit();
	    }, function(error){
	    	console.log(error);
	    });
	},
	
	/**
	 * Get token from Augmented Collaboration and open the Augmented Collaboration page
	 */
	_linkToAugCollab: function() {    
	    $M.showLookup('expertgroup-custom', this);
	},
	
	
	 /**  
     * 
     * return maximo-technician-plans component
     * 
     */
    getPlansComponent: function(){	        	
    	return   this.getComponent('maximo-technician-plans','section_plans')
    },
    
 
   /**  
     * 
     * return maximo-worklog component
     * 
     */
    getCommentsComponent: function(){	        	
    	return   this.getComponent('maximo-worklog','section_comments')
    },
    
    
    /**  
     * 
     * returnmaximo-technician-inspections component
     * 
     */
    getInspectionsComponent: function(){	        	
    	return   this.getComponent('maximo-technician-inspections','section_inspections')
    },
    
    
    
    /**  
     * 
     * return  component  
     * 
     */
    getComponent: function(id, templateId){
    	var  component = $j(this).find(id)[0];
    	if(component) {
    		return component;
    	}

    	if(templateId){
    		this.addContent(templateId);
	    }else{
	    	this.addContent(id);
		}
    	
    	
    	return  $j(this).find(id)[0];
    },
    /** 
`    * Show the top label based on asset value. 
     */
    _showSliderAnnotation: function(assetnum){
	    return assetnum?false:true;
    },
    /**
     * Set the width of Longdescription iframe.
     */
    _setLongDescriptioniframeWidth : function(){    	
    	 $j('.maximo-technician-detail maximo-longdesc iframe').css({'width':window.innerWidth+'px','height':'20px','font-style':'normal'});
         $j('.maximo-technician-detail maximo-longdesc iframe').attr('scrolling','no');    
         if(navigator.userAgent.search('Firefox')>=0){
	         $j('.maximo-technician-detail .longDesc').removeAttr('margin');
	         $j('.maximo-technician-detail maximo-longdesc iframe').contents().find('body>div>p').css({'margin':'5px 0px','padding-bottom':'7px'});
	     }
         var div = $j('.maximo-technician-detail maximo-longdesc iframe').contents().find('body>div');
         div.css({'word-break':'break-word'});
         
         if(div[0]){
  			var divContent = div[0];
  			var test = divContent.cloneNode();
  		 	test.innerHTML = '<br>';
  		 	divContent.parentNode.appendChild(test);
  		 	var singleLineHeight = test.clientHeight;
  		 	divContent.parentNode.removeChild(test);
  		 	var showHide = (divContent.clientHeight > singleLineHeight) ? 'inline-block' : 'none'; 
  		 	$j('.maximo-technician-detail .moreContent').css('display',showHide);
  		 }
    },
    
    /**
	 * Update the description for work order
	 */
	_updateDescription : function(e) {
		var description = e.target.value;
		if (!description && this.record.description === description) {
			return;
		}
		if (description.length > 0) {
			var self = this;
			if(this.createWO){
				this.cachedRecord['description'] = description;
			}else{
				setTimeout(function() {
					self._updateWO({
						'description' : description
					}, self.collection);
				}, 100);
			}

		} else {
			this.$.textdescription.value = this.record.description;
		}
	},

	/**
	 * Suppress flyout without updating the data when the cancel button is clicked 
	 */
	_cancelLongDescription : function(e) {
		this.LongDescRTE = null;
	},
	/**
	 * Suppress flyout after updating the user entered data when the save  button is clicked 
	 */
	_saveLongDescription : function(e) {
		var getRTEContent;
		
		if($M.isMobile()){
			getRTEContent = $j(tinyMCE.activeEditor.getBody())[0].innerHTML;
		}
		else {
			getRTEContent = this.LongDescRTE.value;
		}
		if(this.createWO){
			this.cachedRecord['description_longdescription'] = getRTEContent;
			this.record['description_longdescription'] = getRTEContent;
		}else{
			this._updateWO({
				'description_longdescription' : getRTEContent
			}, this.collection);
		}
		$j('.maximo-technician-details> maximo-longdesc iframe').contents()
				.find('body div p, body div ul li, body div ol li').css({
					'text-overflow' : 'ellipsis',
					'white-space' : 'nowrap',
					'overflow' : 'hidden',
					'max-width' : '90%'
				});
		$j('.maximo-technician-details> maximo-longdesc iframe').contents()
				.find('body div ol, body div ul').css({
					'padding' : '0px'
				});
		this._cancelLongDescription();
	},
		
	/**
	 * Check for follow-up workorder
	 */
	_checkForFollowUp : function() {
		this.isFollowUpWO= false;
		if(this.record && this.record.origrecordclass && this.record.origrecordclass==='WORKORDER'){
			if(this.record.reportedby && $M.maxauth.whoami.displayname === this.record.reportedby.displayname){
				this.isFollowUpWO= true;
			}	
		}
		
	},
	/**
	 * Check for readonly flag for tile. 
	 */
	_getReadonlyFlagForFollowUP : function(status){	
		this._checkForFollowUp();
		if(status==='CLOSE' || status==='CAN'){
			return true;
		}else if(!this.isFollowUpWO){
			if(this.createWO || (this.recordLight && this.recordLight.reportedby) && ($M.maxauth.whoami.displayname === this.recordLight.reportedby.displayname)){
				return false;
			}else{
				return true;
			}
		}
		return false;
	},
	/**
	 * Show worktype if istask=0 
	 */
	_showWorktype: function(worktype){
		if(!this.recordLight.istask){
			return worktype
		}
		
	},
	/**
	 * Get Doclinks Woactivity URL 
	 */
	getDoclinksWoactivityURL: function(record){
		var self = this;
		this.$.woactivityDocLinksCollection.additionalParams=['oslc.where=wonum=%22'+record.parent.wonum+'%22','ignorecollectionref=1'];
		this.$.woactivityDocLinksCollection.collectionUri = $M.getMaxauth().baseUri+'/oslc/os/mxapiwodetail';
		 return new Promise(function (resolve, reject) {
			 this.$.woactivityDocLinksCollection.refreshRecords().then(function(records) {
				 resolve(records);
			  }, function(error) {
					$M.showResponseError(error);
					reject(error);
			    });
		 }.bind(this));
	},
	/**
	 * Show worktype if istask=0 
	 */
	_showWorktype: function(worktype){
		if(this.recordLight && !this.recordLight.istask){
			return worktype
		}
		
	},
	/**
	 * Get Doclinks Woactivity URL 
	 */
	getDoclinksWoactivityURL: function(record){
		var self = this;
		this.$.woactivityDocLinksCollection.additionalParams=['oslc.where=wonum=%22'+record.parent.wonum+'%22','ignorecollectionref=1'];
		this.$.woactivityDocLinksCollection.collectionUri = $M.getMaxauth().baseUri+'/oslc/os/mxapiwodetail';
		 return new Promise(function (resolve, reject) {
			 this.$.woactivityDocLinksCollection.refreshRecords().then(function(records) {
				 resolve(records);
			  }, function(error) {
					$M.showResponseError(error);
					reject(error);
			    });
		 }.bind(this));
	},
	/**
	 * Function will set lttypeset and fire event to load failure details.
	 */
	_failureInvocation : function(e) {
		this.record.ltTypeSet=this.ltTypeSet;
		this.fire('loadFailureData',this.record);
	},
	
	/**
	  * Get Service address details 
	  */
	 getServiceAddress: function(currentRecord){
		 var serviceAddressLabel = "";
		 if(currentRecord && currentRecord.serviceaddress){
			 var servAddress = currentRecord.serviceaddress;
		 
			 if(servAddress.formattedaddress){
				 serviceAddressLabel = servAddress.formattedaddress; 
			 }else if(servAddress.description){
				 serviceAddressLabel = servAddress.description; 
			 }else{
				 serviceAddressLabel = servAddress.saddresscode;
			 }
		 }
		 return serviceAddressLabel;
	 },
	 
	 /**
	  * Update Service address 
	  */	 
	 updateServiceAddress: function(e){
		 var newServiceAddress = e.detail.serviceaddress;
		 var self = this;
   	 	this._updateWO({'saddresscode':newServiceAddress.addresscode}, this.collection,undefined,undefined,true,'serviceaddress').then(function(result){
        	self.record.serviceaddress = newServiceAddress;
   			self.$.serviceAddress._cancelEditNotLoadPreEditValues();
   			self.$.serviceAddress.value = self.getServiceAddress(self.record);
   	 	});
	 },
	/**
     * Set show/hide wo tracking section.
     */
	_showHideWOTracking : function(record, createWO){
		if(this.record && !this.record.istask && this.isAuthorized('WOTRACK:READ')){
			if(createWO || $M.isMobile()){
				return true;
			} else {
				return false;
			}
		}else{
			return true;
		}
	},
	/**
	  * fix for the worktype label on cards and 
	  * on wo details page.
	  */
	_fixWorkTypeLabel:function(){
		var leftAlignWorktypeLabel = {
				display    : "flex",
				padding    : "0px 0px 5px 50%",
				marginLeft : -(this.$.select.$.selectdiv.getBoundingClientRect().width/2) + "px"
		};
		$j(this.$.select.$.label).css(leftAlignWorktypeLabel);
	},
	/**
	  * Hide open work order tracking section in case of 
	  * workorder istask=1
	  */
	 _hideOpenWO : function(istask){
		 if(this.record && (this.createWO || istask) || $M.isMobile()){
			 return true;
		 }
		 return false;
	 },
	 
	/**
  	 * To Save new workorder 
	 */
	 saveWorkorder: function(){
		 $M.toggleWait(true);
		 var self = this;
		 if(this.cachedRecord && this.cachedRecord.uxsupervisor){
			 delete this.cachedRecord['uxsupervisor'];
		 }
		 this.cachedRecord['wonum'] = this.record.wonum;
		 this.cachedRecord['siteid'] = this.record.siteid;
		 this.cachedRecord['assetnum'] = this.record.assetnum;
		 this.cachedRecord['location'] = this.record.$alias_this_attr$location;
		 if (!this.collection.creationInfo){
             this.collection.creationInfo=[];
             this.collection.creationInfo[0]={'href':$M.getMaxauth().baseUri + '/oslc/os/mxapiwodetail'};
         }
		 return new Promise(function (resolve, reject) {
			 var that = self;
			 self.collection.createRecord(self.cachedRecord, self.attributeList, false).then(function(records){
				 $M.toggleWait(false);
				 that.createWO = false;
				 that.newWO = false;
				 records.response['href'] = records.response.href;
				 that.recordLight = records.response;
				 var _uxsettings_ = {};
				 that.recordLight._uxsettings_ = _uxsettings_;
				 var worktype = (records.response.worktype) ? records.response.worktype : '';
				 var wonum = records.response.wonum;
				 var worktypeWonum = ' ' + worktype +' '+ wonum;
				 var message = $M.localize('uitext', 'mxapiwodetail', 'workordercreated', [worktypeWonum]);
				 $M.notify(message, $M.alerts.info);
				 
				 var dataKey= $j(that).find('[data-key]');
				 $j(dataKey).each(function(index,elem){
					 elem.newTile = that.createWO;
				 });
				 that.$.workfailure.newTile = that.createWO;
				 that.$.workproblem.newTile = that.createWO;
				 that.$.wopriority.emptyRecord = false;
				 that.tempRecordClean = true;
				 that.cachedRecord={};
				 resolve(records);
				 $M.clearDisableWarningCallback();
				 $M.allowPageNavigation(true);
				 if(that.domHost){
					 that.domHost._handleMobileActionFooterNav();
				 }
				 that._disabledPageNavigation(false);
				 $j(that.$.contentSelector).removeAttr('add-class');
			  }, function(error) {
				  	$M.toggleWait(false);
					$M.showResponseError(error);
					reject(error);
			  });
		 }.bind(this));
	 },
	 
	 /** 
	  * To clean/remove new in memory record
	  */
	 _cancelWorkorder : function(){
		 $M.clearDisableWarningCallback();
		 $M.allowPageNavigation(true);
		 this.createWO = this.newWO = false;
		 this.cachedRecord ={};
		 if(!this.tempRecordClean){
			 this.tempRecordClean = true;
		 }
		 if(this._cancelWorkorder.caller.name!=='_goBack'){
			 this._goBack();
		 }
	 },
	  /**
	   * Disable page navigation in case of new workorder.
	   */
	  _disabledPageNavigation: function(disabled){
		  var selectorArray = [
	  		  $M.workScape.$.headerbar, //workscape header
	  		  $j('.carouselController') //page carousel on mobile
	  	  ];
	  	  if(this.createWO && disabled){
	  		  $M.toggleDisabled(selectorArray, disabled, this._showYNC, this);
	  	  }else{
	  		  $M.toggleDisabled(selectorArray, disabled);
	  	  }	  		
	  },
	 
	  /** 
	  * set cached value in  cachedRecord
	  */
	 _setCachedValue: function(e){
		 var self =this;
		 var key;
		 var value;
		 if(e.target.dataset.key){
			 key = $j(e.target).data('key');
			 if(key==='reportedby'){
				 value = this.record.reportedby.personid;
			 }else if(key==='ownergroup'){
				 value = this.record.workorderownergroup.persongroup;
				 this.cachedRecord['owner'] =''; 
				 this.$.ownerimg.value=null;
			 }else if(key==='owner'){
				 value = this.record.ownerperson.personid;
				 this.cachedRecord['ownergroup'] ='';
				 this.$.ownergrp.value=null;
			 }else if(key==='wopriority'){
				 value = e.target.value;
				 this.$.wopriority.emptyRecord =false;
			 }else if(key==='worktype'){
				 value = e.target.value;
			 }else if(key==='schedstart'){
				 var schedstart=e.target.value;
				 var schedstartdata={'schedstart':schedstart};
				 this._updateWODates(new Date(this.$.schedfinish.value),schedstart,schedstartdata,'schedstart');
				 value = schedstart;
			 }else if(key==='schedfinish'){
				 var schedfinish=e.target.value;
                 var schedfinishdata={'schedfinish':schedfinish};
                 this._updateWODates(schedfinish,new Date(this.$.schedstart.value),schedfinishdata,'schedfinish');
				 value = schedfinish;
			 }else if(key==='assetnum'){
				 value = e.target.value;
				 var data = {'assetnum': e.target.value};
				 this._getLocationAssetData(data,e.target,true);
			 }else if(key==='location'){
				 value = e.target.value;
				 var data = {'location': e.target.value};
				 this._getLocationAssetData(data,e.target,true);
			 }else if(key==='supervisor'){
				 value = (e.target.value === this.record.uxsupervisor.displayname) ? this.record.uxsupervisor.personid : e.target.value;
			 }else{
				 value = e.target.value;
			 }
			 if(value === undefined){
				 value = '';
			 }
			 this.cachedRecord[key] = value;
			 if(key==='ownergroup' || key==='owner'){
				 this.saveWorkorder();
			 }
		 }else if(e.target.dataset.scopeId==='slider_tile'){
			 this.saveWorkorder().then(function(result){
				 self.$.woresource.resourceUri = self.record.href; 
				 self._changeAssetStatus(e);
			 });
		 }
		 if(key!=='assetnum' && key!=='location' && key!=='ownergroup' && key!=='owner' && e.target.dataset.scopeId!=='slider_tile'){
			 this._validateUserInput(e.target,true);
		 }
	 },
	 	 
	 /**
      * validation user input in new work order scenario
      */
	  _validateUserInput : function(targetElement,showInEditModeWhenError){
		  var self =this;
		  this.cachedRecord['siteid'] = this.record.siteid;
		  if(this.cachedRecord['location']){
			  	this.cachedRecord['location'] = this.record.$alias_this_attr$location;
		  }
		  if (!this.collection.creationInfo){
	             this.collection.creationInfo=[];
	             this.collection.creationInfo[0]={'href':$M.getMaxauth().baseUri + '/oslc/os/mxapiwodetail'};
	      }
		  return new Promise(function (resolve, reject) {
			  var that = self;
			  self.collection.createRecord(self.cachedRecord, self.attributeList, true, false, false, true).then(function(records){
					$M.toggleWait(false);
			 	},function(error) {
					$M.toggleWait(false);
					if(targetElement){
						if(showInEditModeWhenError){
							targetElement._editMode = true;
							targetElement._showHighlight(true);
							targetElement._flipTile(true);
						}
					}					
					that.cachedRecord[targetElement.dataset.key] ='';
					$M.showResponseError(error);
			  });
		  }.bind(this));
	  },
	  
	 /** 
	  * Get Location/Asset Data
	  */
	 _getLocationAssetData : function(data,component,showInEditModeWhenError){
		 var self = this;
		 var resource = this.$.woresource;
		 resource.resourceUri = $M.getMaxauth().baseUri + '/oslc/os/mxapiwodetail';
		 var responseProperties = this.attributeList;
		 var tempRecord={};
		 tempRecord.wonum = this.record.wonum;
		 tempRecord.siteid = this.record.siteid;
		 Object.assign(tempRecord, this.cachedRecord);
		 if(tempRecord.location){
			 delete tempRecord['location'];
		 }
		 if(tempRecord.assetnum){
			 delete tempRecord['assetnum'];
		 }
		 if(data.assetnum){
			 tempRecord.assetnum= data.assetnum;
		 }else if(data.location){
			 tempRecord.location= data.location;
		 }
		 var requestHeaders ={};
		 requestHeaders['setvaluemode'] ='1';
		 requestHeaders['method'] ='POST';
		 resource.updateRecord(tempRecord, responseProperties, true, true,requestHeaders).then(function(result) {
			$M.toggleWait(false);
		 }, function(error) {
			$M.toggleWait(false);
			if(component){
				if(showInEditModeWhenError){
					 component._editMode = true;
					 component._showHighlight(true);
					 component._flipTile(true);
				}
			}
			
			self.cachedRecord[component.dataset.key] ='';
			if(!resource.yncShown){
				$M.showResponseError(error);
			}
		 });
	  },
	  
	  /**
       * Customized lookup href for the tile which is show on new work order scenario
       */
	  _getCustomizedLookupHref: function(record){
		  if(this.createWO){
			  return $M.getMaxauth().baseUri + '/oslc/os/mxapiwodetail/zombie';
		  }
		  return record.href;
	  },
	  /**
       * Customized common clause for the tile which is show on new work order scenario
       */
	  _getCustomizedCommonClause: function(record){
		  if(this.createWO){
			  return 'setupdata={}'
		  }
	  },
	  	  
	  /**
	   * Check for readonly flag for self workorder. 
	   */
	   _getReadonlyFlagForSelfWorkOrder : function(status){	
			if(this.recordLight && this.recordLight.reportedby && $M.maxauth.whoami.displayname === this.recordLight.reportedby.displayname){
				if(status==='CLOSE' || status==='CAN'){
					return true;
				} else {
					return false;
				}
			} else {
				return false;
			}
	},
	
	    
   _getSessionDetailRequest: function()
	{		
		var ajaxURL = this.$.myauthenticator.getBaseUri() + '/oslc/mac/sessions?workorderid='+this.record.workorderid;
		this.$.mxajaxGetResource.url = ajaxURL;
						  						  
		var headers = {};
	    //adding the csrf token
		headers.csrftoken = $M.getCSRFToken();

		this.$.mxajaxGetResource.headers = headers;
		this.$.mxajaxGetResource.contentType = 'application/json';
		this.$.mxajaxGetResource.method='GET';
		this.$.mxajaxGetResource.generateRequest();		
	},
	
	_processSessionDetailResponse: function(e)
	{		
		this.sessionDataSet = e.detail.response;
	},
	
	
	_processSessionError: function(e)
	{
		this.fire('data-error', e.detail.request.xhr.response);
	},
	/**
	 * show the yes/no/cancel dialog and process accordingly
	 */
    _showYNC: function(e){
	    if (this.activeYNC){
		    return false;
	    }
	    this.activeYNC=true;
	    var self = this;
	    $M.toggleWait(true);
	    var response = {};
	    var yncOptions = {
		 	'Yes':'8',
			'No':'16',
			'Cancel':'4'
	    };
	    var message = $M.localize('uitext', 'mxapiwodetail', 'yncMessage');
	    var yncUserInputID = (e && e.detail) ? e.detail : null;
	    $M.confirmMaxMessage(message, self._confirmYNC, self, 2, yncOptions, yncUserInputID, null, $M.alerts.question);
   },
	
   /**
	 * this is a callback for the yes/no/cancel
	 * callbackVal should be one of these... close: 1, ok: 2, cancel: 4, yes: 8, no: 16
	 */
   _confirmYNC: function(callbackVal, params, caller){
	    this.activeYNC=false;
	    var self = this;
	    if (callbackVal && callbackVal > 1 && callbackVal !== 4){	// don't do anything if they clicked Close or Cancel
		    if(callbackVal===8){
		  	    this.saveWorkorder().then(function(result) {
			  	    if(params==='techWODetail_assetimg'){
					    self.record.assetnum = self.recordLight.assetnum;
					    $j(self.$.assetimg.$.frontflipper).trigger('click');
				    }else if(params==='techWODetail_locationimg'){
					    self.record.location = self.recordLight.location;
					    self.$.locationimg.fire('tile-clicked', self.$.locationimg);
				    }else{
					    self._goBack();
				    }
			    });
			}else if(callbackVal===16){
			    self._cancelWorkorder();
			}
		}else{
		    return;
	  	}
	}
});
