/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2017,2018
 */

Polymer({
	is: 'maximo-collection-navigator',
  	behaviors: [BaseComponent],
	properties : {
		
		/**
	     * collection to be handler 
	     */
		collection:{
			type: Object,
			observer: '_updateIcons'
		},
		
		/**
	     * selected record 
	     */
		record:{
			type: Object,
			notify: true,
			observer: '_updateRecord'
		},
		
		/**
	     * Set the label value
	     */
		label:{
			type:String 
		}
		
	},
  	created : function(){
  		
  	},
  	ready : function(){
  		
  	},
  	attached: function(){
  	},
  	
  	song2: function(blur){
  		$j(this).parent().toggleClass('song2',blur);
  	},
  	
  	/**
     * move to previous element in the collection 
     */
  	_goToPreviousElement: function(){
  		var index = this.collection.collectionData.indexOf(this.record) -1;
  		if(index >= 0){
  			this.record= this.collection.collectionData[index];
  		}else{
  			var self = this;
  			 this.song2(true);
  			this.collection.pagePrevious().then(function(){
  				index = self.collection.pageSize -1;
  				self.record= self.collection.collectionData[index];
  				self.song2(false);
  			});
  		}
  	},
  	
	/**
     * move to next element in the collection 
     */
  	_goToNextElement: function(){
  		var index = this.collection.collectionData.indexOf(this.record) + 1;
		var  currentRecord = this.collection.collectionData[index];	
  		if(currentRecord){
  			this.record = currentRecord;
  		}else{
  			var self = this;
  			 this.song2(true);
  			this.collection.pageForward().then(function(){
  				self.record= self.collection.collectionData[0];
  				self.song2(false);
  			});
  		}
  	},
  	
  	/**
     * hide/show the next/previous icons 
     */
  	_updateIcons: function(){
  		$j(this.$.nextDivWrapper).toggleClass('hidden', !this._hasNext());
  		$j(this.$.previousDivWrapper).toggleClass('hidden', !this._hasPrevious());
  	},
  	
  	/**
     * check if there is next element in the collection 
     */
  	_hasNext: function(){
  	   if(this.collection !== undefined   && this.collection.collectionData !== undefined  ){
  		   if(this.collection.hasNextPage()){
  			 return true;
  		   }else{
  			  var index = this.collection.collectionData.indexOf(this.record) + 1;
  	  		  return (index < this.collection.collectionData.length);
  		   }
  	   }
  	   return false;
  	},
  	
  	/**
     * check if there is previous element in the collection 
     */
  	_hasPrevious: function(){
  		 if(this.collection !== undefined   && this.collection.collectionData !== undefined  ){
  			 if(this.collection.hasPreviousPage()){
  				 return true;
  			 }else{
  				 var index = this.collection.collectionData.indexOf(this.record);
  	    		 return (index !== -1 && index !== 0);
  			 }
    	}
  		return false;
  	},
  	
  	/**
     * update next/previous icons and fire event with the new record 
     */
  	_updateRecord: function(){
  		this._updateIcons();
  		this.fire('maximo-collection-navigator', {'record':this.record, 'collection':this.collection});
  	}
  	
});