/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2016,2018
 */
/*
A wait component that is used via maximo-context. Use $M.toggleWait(boolean) to place entire document in/out of wait state.
Any component that implements the BaseComponent behavior supports {component}.toggleLoading(boolean) to leverage a localized wait layer.
 */
Polymer({
	is: 'maximo-wait',
  	behaviors: [BaseComponent],
	properties : {
		/**
		 * Change property to hide/show
		 */
		show: {
			type: Boolean,
			value: false,
			observer: '_toggleShow'
		},
		message: {
			type: String,
			value: ''
		},
		messageRight: {
			type: String,
			value: ''
		},
		clear: {
			type: Boolean,
			value: false
		}
	},
	/**
	 * Toggle show property to hide/show
	 */
	toggle: function(show){
		this.show = show;
	},
	created: function(){
		if(!$M.wait){
			$M.wait = this;
		}
	},
	attached: function(){
		$j(this.$.wait).toggleClass('clear',this.clear);
	},
	_toggleShow: function(){
		$j(this.$.wait).css({'display':this.show?'initial':'none'});
		//Add/Remove overflow property to show/hide body overflow 
		var waitHidden; 
		if(this.$.wait){
			waitHidden = this.$.wait.hasAttribute('hidden');
		}
		if($M.isMobile() && this.$.wait && !waitHidden){
			$j('body').addClass('overflow');
		}else{
			$j('body').removeClass('overflow');
		}
		if(this.show){
			var height = $j(this.$.wait).height();
			var width = $j(this.$.wait).width();
			if(this.parentNode !== document.body && (height < 200 || width < 200)){
				$j(this.$.wrapper).css({'border':'0px','background':'transparent'});
				if(this.messageRight){
					$j(this.$.wrapper).css({'left':'calc(50% - 80px)'});
				}
				$j(this.$.bee).css({'transform':'scale(.5)','-moz-transform':'scale(.5)','margin-left':'-10px'});
				$j(this.$.messageRight).css({'left':'calc(45%)'});
				
			}
		}
	}
});
